
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; CABBAGE CODE ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
<Cabbage>

;color macros:
#define PLANT colour(76,130,180,155) outlineColour(0,0,0,255) outlineThickness(2)
#define BASIC colour(56, 150, 180, 255) trackerColour(56,255,182,255) outlineColour(17,37,37,155)
#define VBASIC colour("Gainsboro") trackerColour(56,255,182,255) outlineColour(17,37,37,155)
#define FTABLES tableGridColour("Silver") tableColour:0(20,20,20,245) tableBackgroundColour("Silver")
#define BUTTONS colour:0(79,79,79,105) colour:1("MediumTurquoise") colour:0("DarkSlateGrey")
#define MIDI colour:0(96,150,170,255) colour:1("Grey") value(0) latched(0)
#define MIDIX colour:0(96,150,170,255) colour:1("red") value(0) latched(0) 
#define RSLIDER colour(56, 150, 180, 255) trackerColour("MediumTurquoise") fontColour("Gainsboro") valueTextBox(1) textBoxColour("black") 
#define FONT fontColour("Gainsboro")

;MAIN GUI:
form caption("WaveTerrainSynth") channel("f1") size(1045, 872) pluginId("WTS1") colour(76,130,180,155) style("legacy") fontColour("Gainsboro")

label channel("l1") bounds(5, 5, 40, 10) text("Presets") $FONT

combobox bounds(48,1,110,17) populate("*.snaps") channelType("string") channel("cb1") ;$FONT
filebutton bounds(160,1,35,17) text("Save") populate("*.snaps") mode("named preset") channel("fb1") presetIgnore(1) 
filebutton bounds(195,1,50,17) text("Remove") populate("*.snaps") mode("remove preset") channel("fb2") presetIgnore(1) 

label channel("l2") bounds(245,5,30,10) text("Input") $FONT
button bounds(272,2,40,16) channel("liveon") text("Mic/Line") $BUTTONS
combobox bounds(315,1,50,17) channel("livech") text("Stereo","Mono")
button bounds(368,2,27,15) text("Amp") channel("mapliveamp") $MIDI
button bounds(395,2,9,15) text("") channel("mapliveampX") $MIDIX
rslider bounds(405, 0, 20, 20) channel("liveamp") range(0, 5, 0, 0.75, 0.001) $BASIC
filebutton bounds(430,2,45,16) channel("openFile") text("Load SF") $BUTTONS
button bounds(477,2,35,16) channel("sfplay") text("Play") $BUTTONS
button bounds(515,2,35,16) channel("sfloop") text("Loop") $BUTTONS
button bounds(557,2,27,15) text("Amp") channel("mapsfamp") $MIDI
button bounds(583,2,9,15) text("") channel("mapsfampX") $MIDIX
rslider bounds(595, 0, 20, 20) channel("sfamp") range(0, 5, 0, 0.75, 0.001) $BASIC
button bounds(618,2,30,15) channel("livetoOsc") text("to Osc","to Osc") value(1) $BUTTONS
button bounds(651,2,30,15) channel("livetoFX") text("to FX","to FX") value(1) $BUTTONS
label channel("l3") bounds(678,5,70,10) text("Tuning") $FONT
combobox bounds(735, 2, 70, 17), channel("MasterScale") text("Equal Temp", "1/8 Tone", "1/6 Tone", "1/4 Tone", "1/3 Tone",  "7 Tone", "8 Tone", "9 Tone", "10 Tone", "11 Tone", "11.6 Tone", "11.8 Tone", "12.2 Tone", "12.4 Tone", "13 Tone", "14 Tone", "15 Tone")
label channel("l4") bounds(788,5,100,10) text("Tune From") $FONT
nslider bounds(865,1,40,19) channel("ScaleStart") range(20,108,60.00,1,.01)
label channel("l5") bounds(925,5,80,10) text("jitter depth/rate") $FONT
rslider bounds(1002, 0, 20, 20) channel("Mjit") range(0, 10, 1, 0.5, 0.01) $BASIC
rslider bounds(1020, 0, 20, 20) channel("Mjitrate") range(.1, 10, 1, 0.5, 0.01) $BASIC
button bounds(100, 615, 47, 25) channel("record") text("Record","Stop") colour("red") fontColour("white")
combobox bounds(100,645,47,15) channel("recch") value(2) text("mono","stereo")
combobox bounds(100,665,47,15) channel("bit") value(1) text("16-bit","24-bit","32-bit")
button bounds(100, 685, 47, 25), channel("play") text("Play") colour("green") fontColour("white")
keyboard channel("k1") bounds(101,755,940, 80) value(21)
;combobox bounds(10,840,80,20), channel("resize") mode("resize"), value(3)
;PLANTS

;1D
image channel("i1") bounds(4,20,205,375) plant("1D") $PLANT
{
label channel("l6") bounds(5,5,195,15) text("Terrain Axis 1 Wave") $FONT
gentable bounds(5,25,195,75) channel("gen1") identChannel("table96") tableNumber(96) ampRange(-1.0, 1.0, 1.0, 0.0100) outlineThickness(2) $FTABLES
button bounds(78,107,37,15) text("Morph") channel("mapmorph1") $MIDI
button bounds(115,107,9,15) text("") channel("mapmorph1X") $MIDIX
rslider bounds(80,139,45,45) channel("morph1") identChannel("ID1") range(0,7,0,1,.01) $BASIC
combobox bounds(15,185,75,16) channel("fn11") text("sine","square","saw","pulse","Triangle","Ramp","harm 2","harm 3","harm 4","harm 5","harm 6","harm 7","harm 8","harm 9","harm 10","harm 11","harm 12","harm 13","harm 14","harm 15","harm 16","cello","violin","trombone","horn","trumpet","c bassoon","bassoon","oboe","sax","b clarinet","clarinet","b flute","flute","piccolo","piano","guitar","ahhh")
combobox bounds(5,165,75,16) channel("fn12") value(2) text("sine","square","saw","pulse","Triangle","Ramp","harm 2","harm 3","harm 4","harm 5","harm 6","harm 7","harm 8","harm 9","harm 10","harm 11","harm 12","harm 13","harm 14","harm 15","harm 16","cello","violin","trombone","horn","trumpet","c bassoon","bassoon","oboe","sax","b clarinet","clarinet","b flute","flute","piccolo","piano","guitar","ahhh")
combobox bounds(5,145,75,16) channel("fn13") value(3) text("sine","square","saw","pulse","Triangle","Ramp","harm 2","harm 3","harm 4","harm 5","harm 6","harm 7","harm 8","harm 9","harm 10","harm 11","harm 12","harm 13","harm 14","harm 15","harm 16","cello","violin","trombone","horn","trumpet","c bassoon","bassoon","oboe","sax","b clarinet","clarinet","b flute","flute","piccolo","piano","guitar","ahhh")
combobox bounds(15,125,75,16) channel("fn14") value(4) text("sine","square","saw","pulse","Triangle","Ramp","harm 2","harm 3","harm 4","harm 5","harm 6","harm 7","harm 8","harm 9","harm 10","harm 11","harm 12","harm 13","harm 14","harm 15","harm 16","cello","violin","trombone","horn","trumpet","c bassoon","bassoon","oboe","sax","b clarinet","clarinet","b flute","flute","piccolo","piano","guitar","ahhh")
combobox bounds(110,125,75,16) channel("fn15") value(5) text("sine","square","saw","pulse","Triangle","Ramp","harm 2","harm 3","harm 4","harm 5","harm 6","harm 7","harm 8","harm 9","harm 10","harm 11","harm 12","harm 13","harm 14","harm 15","harm 16","cello","violin","trombone","horn","trumpet","c bassoon","bassoon","oboe","sax","b clarinet","clarinet","b flute","flute","piccolo","piano","guitar","ahhh")
combobox bounds(125,145,75,16) channel("fn16") value(6) text("sine","square","saw","pulse","Triangle","Ramp","harm 2","harm 3","harm 4","harm 5","harm 6","harm 7","harm 8","harm 9","harm 10","harm 11","harm 12","harm 13","harm 14","harm 15","harm 16","cello","violin","trombone","horn","trumpet","c bassoon","bassoon","oboe","sax","b clarinet","clarinet","b flute","flute","piccolo","piano","guitar","ahhh")
combobox bounds(125,165,75,16) channel("fn17") value(7) text("sine","square","saw","pulse","Triangle","Ramp","harm 2","harm 3","harm 4","harm 5","harm 6","harm 7","harm 8","harm 9","harm 10","harm 11","harm 12","harm 13","harm 14","harm 15","harm 16","cello","violin","trombone","horn","trumpet","c bassoon","bassoon","oboe","sax","b clarinet","clarinet","b flute","flute","piccolo","piano","guitar","ahhh")
combobox bounds(110,185,75,16) channel("fn18") value(8) text("sine","square","saw","pulse","Triangle","Ramp","harm 2","harm 3","harm 4","harm 5","harm 6","harm 7","harm 8","harm 9","harm 10","harm 11","harm 12","harm 13","harm 14","harm 15","harm 16","cello","violin","trombone","horn","trumpet","c bassoon","bassoon","oboe","sax","b clarinet","clarinet","b flute","flute","piccolo","piano","guitar","ahhh")
label channel("l7") bounds(5,210,50,14) text("Tuning:") $FONT
button bounds(60,210,37,15) text("Coarse") channel("maptc1") $MIDI
button bounds(97,210,9,15) text("") channel("maptc1X") $MIDIX
rslider bounds(50,226,65,45) channel("tc1") range(-24, 24, 0, 1, 1) $RSLIDER
button bounds(120,210,37,15) text("Fine") channel("maptf1") $MIDI
button bounds(157,210,9,15) text("") channel("maptf1X") $MIDIX
rslider bounds(110,226,65,45) channel("tf1") range(-1, 1, 0, 1, 0.001) $RSLIDER 
label channel("l8") bounds(5,275,165,14) text("Index:     Shape         Phase") $FONT
combobox bounds(45,290,75,16) channel("iw1") value(1) text("sinusoid","linear","triangle","saw","square","pulse") ;,"random")
combobox bounds(132,290,35,16) channel("ip1") text("0",".25",".5",".75")
button bounds(60,310,37,15) text("Offset") channel("mapioff1") $MIDI
button bounds(97,310,9,15) text("") channel("mapioff1X") $MIDIX
rslider bounds(50,326,65,45) channel("ioff1") range(0,1,.5,1,.001) $RSLIDER
button bounds(120,310,37,15) text("Amp") channel("mapiamp1") $MIDI
button bounds(157,310,9,15) text("") channel("mapiamp1X") $MIDIX
rslider bounds(110,326,65,45) channel("iamp1") range(.01,50,1,.25,0.001) $RSLIDER 
}
;2D
image channel("i2") bounds(212,20,205,375) plant("2D") $PLANT
{
label channel("l9") bounds(5,5,195,15) text("Terrain Axis 2 Wave") $FONT
gentable bounds(5,25,195,75) channel("gen2") identChannel("table97") tableNumber(97) ampRange(-1.0, 1.0, 1.0, 0.0100) outlineThickness(2) $FTABLES
button bounds(78,107,37,15) text("Morph") channel("mapmorph2") $MIDI
button bounds(115,107,9,15) text("") channel("mapmorph2X") $MIDIX
rslider bounds(80,139,45,45) channel("morph2") identChannel("ID2") range(0,7,0,1,.01) $BASIC
combobox bounds(15,185,75,16) channel("fn21") text("sine","square","saw","pulse","Triangle","Ramp","harm 2","harm 3","harm 4","harm 5","harm 6","harm 7","harm 8","harm 9","harm 10","harm 11","harm 12","harm 13","harm 14","harm 15","harm 16","cello","violin","trombone","horn","trumpet","c bassoon","bassoon","oboe","sax","b clarinet","clarinet","b flute","flute","piccolo","piano","guitar","ahhh")
combobox bounds(5,165,75,16) channel("fn22") value(2) text("sine","square","saw","pulse","Triangle","Ramp","harm 2","harm 3","harm 4","harm 5","harm 6","harm 7","harm 8","harm 9","harm 10","harm 11","harm 12","harm 13","harm 14","harm 15","harm 16","cello","violin","trombone","horn","trumpet","c bassoon","bassoon","oboe","sax","b clarinet","clarinet","b flute","flute","piccolo","piano","guitar","ahhh")
combobox bounds(5,145,75,16) channel("fn23") value(3) text("sine","square","saw","pulse","Triangle","Ramp","harm 2","harm 3","harm 4","harm 5","harm 6","harm 7","harm 8","harm 9","harm 10","harm 11","harm 12","harm 13","harm 14","harm 15","harm 16","cello","violin","trombone","horn","trumpet","c bassoon","bassoon","oboe","sax","b clarinet","clarinet","b flute","flute","piccolo","piano","guitar","ahhh")
combobox bounds(15,125,75,16) channel("fn24") value(4) text("sine","square","saw","pulse","Triangle","Ramp","harm 2","harm 3","harm 4","harm 5","harm 6","harm 7","harm 8","harm 9","harm 10","harm 11","harm 12","harm 13","harm 14","harm 15","harm 16","cello","violin","trombone","horn","trumpet","c bassoon","bassoon","oboe","sax","b clarinet","clarinet","b flute","flute","piccolo","piano","guitar","ahhh")
combobox bounds(110,125,75,16) channel("fn25") value(5) text("sine","square","saw","pulse","Triangle","Ramp","harm 2","harm 3","harm 4","harm 5","harm 6","harm 7","harm 8","harm 9","harm 10","harm 11","harm 12","harm 13","harm 14","harm 15","harm 16","cello","violin","trombone","horn","trumpet","c bassoon","bassoon","oboe","sax","b clarinet","clarinet","b flute","flute","piccolo","piano","guitar","ahhh")
combobox bounds(125,145,75,16) channel("fn26") value(6) text("sine","square","saw","pulse","Triangle","Ramp","harm 2","harm 3","harm 4","harm 5","harm 6","harm 7","harm 8","harm 9","harm 10","harm 11","harm 12","harm 13","harm 14","harm 15","harm 16","cello","violin","trombone","horn","trumpet","c bassoon","bassoon","oboe","sax","b clarinet","clarinet","b flute","flute","piccolo","piano","guitar","ahhh")
combobox bounds(125,165,75,16) channel("fn27") value(7) text("sine","square","saw","pulse","Triangle","Ramp","harm 2","harm 3","harm 4","harm 5","harm 6","harm 7","harm 8","harm 9","harm 10","harm 11","harm 12","harm 13","harm 14","harm 15","harm 16","cello","violin","trombone","horn","trumpet","c bassoon","bassoon","oboe","sax","b clarinet","clarinet","b flute","flute","piccolo","piano","guitar","ahhh")
combobox bounds(110,185,75,16) channel("fn28") value(8) text("sine","square","saw","pulse","Triangle","Ramp","harm 2","harm 3","harm 4","harm 5","harm 6","harm 7","harm 8","harm 9","harm 10","harm 11","harm 12","harm 13","harm 14","harm 15","harm 16","cello","violin","trombone","horn","trumpet","c bassoon","bassoon","oboe","sax","b clarinet","clarinet","b flute","flute","piccolo","piano","guitar","ahhh")
label channel("l10") bounds(5,210,50,14) text("Tuning:") $FONT
button bounds(60,210,37,15) text("Coarse") channel("maptc2") $MIDI
button bounds(97,210,9,15) text("") channel("maptc2X") $MIDIX
rslider bounds(50,226,65,45) channel("tc2") range(-24, 24, 0, 1, 1) $RSLIDER
button bounds(120,210,37,15) text("Fine") channel("maptf2") $MIDI
button bounds(157,210,9,15) text("") channel("maptf2X") $MIDIX
rslider bounds(110,226,65,45) channel("tf2") range(-1, 1, 0, 1, 0.001) $RSLIDER 
label channel("l11") bounds(5,275,165,14) text("Index:     Shape         Phase") $FONT
combobox bounds(45,290,75,16) channel("iw2") value(1) text("sinusoid","linear","triangle","saw","square","pulse") ;,"random")
combobox bounds(132,290,35,16) channel("ip2") value(2) text("0",".25",".5",".75")
button bounds(60,310,37,15) text("Offset") channel("mapioff2") $MIDI
button bounds(97,310,9,15) text("") channel("mapioff2X") $MIDIX
rslider bounds(50,326,65,45) channel("ioff2") range(0,1,.5,1,.001) $RSLIDER
button bounds(120,310,37,15) text("Amp") channel("mapiamp2") $MIDI
button bounds(157,310,9,15) text("") channel("mapiamp2X") $MIDIX
rslider bounds(110,326,65,45) channel("iamp2") range(.01,50,1,.25,0.001) $RSLIDER 
}
;3D
image channel("i3") bounds(420,20,205,375) plant("3D") $PLANT
{
label channel("l12") bounds(5,5,195,15) text("Terrain Axis 3 Wave") $FONT
gentable bounds(5,25,195,75) channel("gen3") identChannel("table98") tableNumber(98) ampRange(-1.0, 1.0, 1.0, 0.0100) outlineThickness(2) $FTABLES
button bounds(78,107,37,15) text("Morph") channel("mapmorph3") $MIDI
button bounds(115,107,9,15) text("") channel("mapmorph3X") $MIDIX
rslider bounds(80,139,45,45) channel("morph3") identChannel("ID3") range(0,7,0,1,.01) $BASIC
combobox bounds(15,185,75,16) channel("fn31") text("sine","square","saw","pulse","Triangle","Ramp","harm 2","harm 3","harm 4","harm 5","harm 6","harm 7","harm 8","harm 9","harm 10","harm 11","harm 12","harm 13","harm 14","harm 15","harm 16","cello","violin","trombone","horn","trumpet","c bassoon","bassoon","oboe","sax","b clarinet","clarinet","b flute","flute","piccolo","piano","guitar","ahhh")
combobox bounds(5,165,75,16) channel("fn32") value(2) text("sine","square","saw","pulse","Triangle","Ramp","harm 2","harm 3","harm 4","harm 5","harm 6","harm 7","harm 8","harm 9","harm 10","harm 11","harm 12","harm 13","harm 14","harm 15","harm 16","cello","violin","trombone","horn","trumpet","c bassoon","bassoon","oboe","sax","b clarinet","clarinet","b flute","flute","piccolo","piano","guitar","ahhh")
combobox bounds(5,145,75,16) channel("fn33") value(3) text("sine","square","saw","pulse","Triangle","Ramp","harm 2","harm 3","harm 4","harm 5","harm 6","harm 7","harm 8","harm 9","harm 10","harm 11","harm 12","harm 13","harm 14","harm 15","harm 16","cello","violin","trombone","horn","trumpet","c bassoon","bassoon","oboe","sax","b clarinet","clarinet","b flute","flute","piccolo","piano","guitar","ahhh")
combobox bounds(15,125,75,16) channel("fn34") value(4) text("sine","square","saw","pulse","Triangle","Ramp","harm 2","harm 3","harm 4","harm 5","harm 6","harm 7","harm 8","harm 9","harm 10","harm 11","harm 12","harm 13","harm 14","harm 15","harm 16","cello","violin","trombone","horn","trumpet","c bassoon","bassoon","oboe","sax","b clarinet","clarinet","b flute","flute","piccolo","piano","guitar","ahhh")
combobox bounds(110,125,75,16) channel("fn35") value(5) text("sine","square","saw","pulse","Triangle","Ramp","harm 2","harm 3","harm 4","harm 5","harm 6","harm 7","harm 8","harm 9","harm 10","harm 11","harm 12","harm 13","harm 14","harm 15","harm 16","cello","violin","trombone","horn","trumpet","c bassoon","bassoon","oboe","sax","b clarinet","clarinet","b flute","flute","piccolo","piano","guitar","ahhh")
combobox bounds(125,145,75,16) channel("fn36") value(6) text("sine","square","saw","pulse","Triangle","Ramp","harm 2","harm 3","harm 4","harm 5","harm 6","harm 7","harm 8","harm 9","harm 10","harm 11","harm 12","harm 13","harm 14","harm 15","harm 16","cello","violin","trombone","horn","trumpet","c bassoon","bassoon","oboe","sax","b clarinet","clarinet","b flute","flute","piccolo","piano","guitar","ahhh")
combobox bounds(125,165,75,16) channel("fn37") value(7) text("sine","square","saw","pulse","Triangle","Ramp","harm 2","harm 3","harm 4","harm 5","harm 6","harm 7","harm 8","harm 9","harm 10","harm 11","harm 12","harm 13","harm 14","harm 15","harm 16","cello","violin","trombone","horn","trumpet","c bassoon","bassoon","oboe","sax","b clarinet","clarinet","b flute","flute","piccolo","piano","guitar","ahhh")
combobox bounds(110,185,75,16) channel("fn38") value(8) text("sine","square","saw","pulse","Triangle","Ramp","harm 2","harm 3","harm 4","harm 5","harm 6","harm 7","harm 8","harm 9","harm 10","harm 11","harm 12","harm 13","harm 14","harm 15","harm 16","cello","violin","trombone","horn","trumpet","c bassoon","bassoon","oboe","sax","b clarinet","clarinet","b flute","flute","piccolo","piano","guitar","ahhh")
label channel("l13") bounds(5,210,50,14) text("Tuning:") $FONT
button bounds(60,210,37,15) text("Coarse") channel("maptc3") $MIDI
button bounds(97,210,9,15) text("") channel("maptc3X") $MIDIX
rslider bounds(50,226,65,45) channel("tc3") range(-24, 24, 0, 1, 1) $RSLIDER
button bounds(120,210,37,15) text("Fine") channel("maptf3") $MIDI
button bounds(157,210,9,15) text("") channel("maptf3X") $MIDIX
rslider bounds(110,226,65,45) channel("tf3") range(-1, 1, 0, 1, 0.001) $RSLIDER 
label channel("l14") bounds(5,275,165,14) text("Index:     Shape         Phase") $FONT
combobox bounds(45,290,75,16) channel("iw3") value(1) text("sinusoid","linear","triangle","saw","square","pulse") ;,"random")
combobox bounds(132,290,35,16) channel("ip3") value(3) text("0",".25",".5",".75")
button bounds(60,310,37,15) text("Offset") channel("mapioff3") $MIDI
button bounds(97,310,9,15) text("") channel("mapioff3X") $MIDIX
rslider bounds(50,326,65,45) channel("ioff3") range(0,1,.5,1,.001) $RSLIDER
button bounds(120,310,37,15) text("Amp") channel("mapiamp3") $MIDI
button bounds(157,310,9,15) text("") channel("mapiamp3X") $MIDIX
rslider bounds(110,326,65,45) channel("iamp3") range(.01,50,1,.25,0.001) $RSLIDER 
}
;4D
image channel("i4") bounds(628,20,205,375) plant("4D") $PLANT
{
label channel("l15") bounds(5,5,195,15) text("Terrain Axis 4 Wave") $FONT
gentable bounds(5,25,195,75) channel("gen4") identChannel("table99") tableNumber(99) ampRange(-1.0, 1.0, 1.0, 0.0100) outlineThickness(2) $FTABLES
button bounds(78,107,37,15) text("Morph") channel("mapmorph4") $MIDI
button bounds(115,107,9,15) text("") channel("mapmorph4X") $MIDIX
rslider bounds(80,139,45,45) channel("morph4") identChannel("ID4") range(0,7,0,1,.01) $BASIC
combobox bounds(15,185,75,16) channel("fn41") text("sine","square","saw","pulse","Triangle","Ramp","harm 2","harm 3","harm 4","harm 5","harm 6","harm 7","harm 8","harm 9","harm 10","harm 11","harm 12","harm 13","harm 14","harm 15","harm 16","cello","violin","trombone","horn","trumpet","c bassoon","bassoon","oboe","sax","b clarinet","clarinet","b flute","flute","piccolo","piano","guitar","ahhh")
combobox bounds(5,165,75,16) channel("fn42") value(2) text("sine","square","saw","pulse","Triangle","Ramp","harm 2","harm 3","harm 4","harm 5","harm 6","harm 7","harm 8","harm 9","harm 10","harm 11","harm 12","harm 13","harm 14","harm 15","harm 16","cello","violin","trombone","horn","trumpet","c bassoon","bassoon","oboe","sax","b clarinet","clarinet","b flute","flute","piccolo","piano","guitar","ahhh")
combobox bounds(5,145,75,16) channel("fn43") value(3) text("sine","square","saw","pulse","Triangle","Ramp","harm 2","harm 3","harm 4","harm 5","harm 6","harm 7","harm 8","harm 9","harm 10","harm 11","harm 12","harm 13","harm 14","harm 15","harm 16","cello","violin","trombone","horn","trumpet","c bassoon","bassoon","oboe","sax","b clarinet","clarinet","b flute","flute","piccolo","piano","guitar","ahhh")
combobox bounds(15,125,75,16) channel("fn44") value(4) text("sine","square","saw","pulse","Triangle","Ramp","harm 2","harm 3","harm 4","harm 5","harm 6","harm 7","harm 8","harm 9","harm 10","harm 11","harm 12","harm 13","harm 14","harm 15","harm 16","cello","violin","trombone","horn","trumpet","c bassoon","bassoon","oboe","sax","b clarinet","clarinet","b flute","flute","piccolo","piano","guitar","ahhh")
combobox bounds(110,125,75,16) channel("fn45") value(5) text("sine","square","saw","pulse","Triangle","Ramp","harm 2","harm 3","harm 4","harm 5","harm 6","harm 7","harm 8","harm 9","harm 10","harm 11","harm 12","harm 13","harm 14","harm 15","harm 16","cello","violin","trombone","horn","trumpet","c bassoon","bassoon","oboe","sax","b clarinet","clarinet","b flute","flute","piccolo","piano","guitar","ahhh")
combobox bounds(125,145,75,16) channel("fn46") value(6) text("sine","square","saw","pulse","Triangle","Ramp","harm 2","harm 3","harm 4","harm 5","harm 6","harm 7","harm 8","harm 9","harm 10","harm 11","harm 12","harm 13","harm 14","harm 15","harm 16","cello","violin","trombone","horn","trumpet","c bassoon","bassoon","oboe","sax","b clarinet","clarinet","b flute","flute","piccolo","piano","guitar","ahhh")
combobox bounds(125,165,75,16) channel("fn47") value(7) text("sine","square","saw","pulse","Triangle","Ramp","harm 2","harm 3","harm 4","harm 5","harm 6","harm 7","harm 8","harm 9","harm 10","harm 11","harm 12","harm 13","harm 14","harm 15","harm 16","cello","violin","trombone","horn","trumpet","c bassoon","bassoon","oboe","sax","b clarinet","clarinet","b flute","flute","piccolo","piano","guitar","ahhh")
combobox bounds(110,185,75,16) channel("fn48") value(8) text("sine","square","saw","pulse","Triangle","Ramp","harm 2","harm 3","harm 4","harm 5","harm 6","harm 7","harm 8","harm 9","harm 10","harm 11","harm 12","harm 13","harm 14","harm 15","harm 16","cello","violin","trombone","horn","trumpet","c bassoon","bassoon","oboe","sax","b clarinet","clarinet","b flute","flute","piccolo","piano","guitar","ahhh")
label channel("l16") bounds(5,210,50,14) text("Tuning:") $FONT
button bounds(60,210,37,15) text("Coarse") channel("maptc4") $MIDI
button bounds(97,210,9,15) text("") channel("maptc4X") $MIDIX
rslider bounds(50,226,65,45) channel("tc4") range(-24, 24, 0, 1, 1) $RSLIDER
button bounds(120,210,37,15) text("Fine") channel("maptf4") $MIDI
button bounds(157,210,9,15) text("") channel("maptf4X") $MIDIX
rslider bounds(110,226,65,45) channel("tf4") range(-1, 1, 0, 1, 0.001) $RSLIDER 
label channel("l17") bounds(5,275,165,14) text("Index:     Shape         Phase") $FONT
combobox bounds(45,290,75,16) channel("iw4") value(1) text("sinusoid","linear","triangle","saw","square","pulse") ;,"random")
combobox bounds(132,290,35,16) channel("ip4") value(4) text("0",".25",".5",".75")
button bounds(60,310,37,15) text("Offset") channel("mapioff4") $MIDI
button bounds(97,310,9,15) text("") channel("mapioff4X") $MIDIX
rslider bounds(50,326,65,45) channel("ioff4") range(0,1,.5,1,.001) $RSLIDER
button bounds(120,310,37,15) text("Amp") channel("mapiamp4") $MIDI
button bounds(157,310,9,15) text("") channel("mapiamp4X") $MIDIX
rslider bounds(110,326,65,45) channel("iamp4") range(.01,50,1,.25,0.001) $RSLIDER 
}
;5D
image channel("i5") bounds(836,20,205,375) plant("5D") $PLANT
{
label channel("l18") bounds(5,5,195,15) text("Terrain Axis 5 Wave") $FONT
gentable bounds(5,25,195,75) channel("gen5") identChannel("table100") tableNumber(100) ampRange(-1.0, 1.0, 1.0, 0.0100) outlineThickness(2) $FTABLES
button bounds(78,107,37,15) text("Morph") channel("mapmorph5") $MIDI
button bounds(115,107,9,15) text("") channel("mapmorph5X") $MIDIX
rslider bounds(80,139,45,45) channel("morph5") identChannel("ID5") range(0,7,0,1,.01) $BASIC
combobox bounds(15,185,75,16) channel("fn51") text("sine","square","saw","pulse","Triangle","Ramp","harm 2","harm 3","harm 4","harm 5","harm 6","harm 7","harm 8","harm 9","harm 10","harm 11","harm 12","harm 13","harm 14","harm 15","harm 16","cello","violin","trombone","horn","trumpet","c bassoon","bassoon","oboe","sax","b clarinet","clarinet","b flute","flute","piccolo","piano","guitar","ahhh")
combobox bounds(5,165,75,16) channel("fn52") value(2) text("sine","square","saw","pulse","Triangle","Ramp","harm 2","harm 3","harm 4","harm 5","harm 6","harm 7","harm 8","harm 9","harm 10","harm 11","harm 12","harm 13","harm 14","harm 15","harm 16","cello","violin","trombone","horn","trumpet","c bassoon","bassoon","oboe","sax","b clarinet","clarinet","b flute","flute","piccolo","piano","guitar","ahhh")
combobox bounds(5,145,75,16) channel("fn53") value(3) text("sine","square","saw","pulse","Triangle","Ramp","harm 2","harm 3","harm 4","harm 5","harm 6","harm 7","harm 8","harm 9","harm 10","harm 11","harm 12","harm 13","harm 14","harm 15","harm 16","cello","violin","trombone","horn","trumpet","c bassoon","bassoon","oboe","sax","b clarinet","clarinet","b flute","flute","piccolo","piano","guitar","ahhh")
combobox bounds(15,125,75,16) channel("fn54") value(4) text("sine","square","saw","pulse","Triangle","Ramp","harm 2","harm 3","harm 4","harm 5","harm 6","harm 7","harm 8","harm 9","harm 10","harm 11","harm 12","harm 13","harm 14","harm 15","harm 16","cello","violin","trombone","horn","trumpet","c bassoon","bassoon","oboe","sax","b clarinet","clarinet","b flute","flute","piccolo","piano","guitar","ahhh")
combobox bounds(110,125,75,16) channel("fn55") value(5) text("sine","square","saw","pulse","Triangle","Ramp","harm 2","harm 3","harm 4","harm 5","harm 6","harm 7","harm 8","harm 9","harm 10","harm 11","harm 12","harm 13","harm 14","harm 15","harm 16","cello","violin","trombone","horn","trumpet","c bassoon","bassoon","oboe","sax","b clarinet","clarinet","b flute","flute","piccolo","piano","guitar","ahhh")
combobox bounds(125,145,75,16) channel("fn56") value(6) text("sine","square","saw","pulse","Triangle","Ramp","harm 2","harm 3","harm 4","harm 5","harm 6","harm 7","harm 8","harm 9","harm 10","harm 11","harm 12","harm 13","harm 14","harm 15","harm 16","cello","violin","trombone","horn","trumpet","c bassoon","bassoon","oboe","sax","b clarinet","clarinet","b flute","flute","piccolo","piano","guitar","ahhh")
combobox bounds(125,165,75,16) channel("fn57") value(7) text("sine","square","saw","pulse","Triangle","Ramp","harm 2","harm 3","harm 4","harm 5","harm 6","harm 7","harm 8","harm 9","harm 10","harm 11","harm 12","harm 13","harm 14","harm 15","harm 16","cello","violin","trombone","horn","trumpet","c bassoon","bassoon","oboe","sax","b clarinet","clarinet","b flute","flute","piccolo","piano","guitar","ahhh")
combobox bounds(110,185,75,16) channel("fn58") value(8) text("sine","square","saw","pulse","Triangle","Ramp","harm 2","harm 3","harm 4","harm 5","harm 6","harm 7","harm 8","harm 9","harm 10","harm 11","harm 12","harm 13","harm 14","harm 15","harm 16","cello","violin","trombone","horn","trumpet","c bassoon","bassoon","oboe","sax","b clarinet","clarinet","b flute","flute","piccolo","piano","guitar","ahhh")
label channel("l19") bounds(5,210,50,14) text("Tuning:") $FONT
button bounds(60,210,37,15) text("Coarse") channel("maptc5") $MIDI
button bounds(97,210,9,15) text("") channel("maptc5X") $MIDIX
rslider bounds(50,226,65,45) channel("tc5") range(-24, 24, 0, 1, 1) $RSLIDER
button bounds(120,210,37,15) text("Fine") channel("maptf5") $MIDI
button bounds(157,210,9,15) text("") channel("maptf5X") $MIDIX
rslider bounds(110,226,65,45) channel("tf5") range(-1, 1, 0, 1, 0.001) $RSLIDER 
label channel("l20") bounds(5,275,165,14) text("Index:     Shape         Phase") $FONT
combobox bounds(45,290,75,16) channel("iw5") value(1) text("sinusoid","linear","triangle","saw","square","pulse") ;,"random")
combobox bounds(132,290,35,16) channel("ip5") text("0",".25",".5",".75")
button bounds(60,310,37,15) text("Offset") channel("mapioff5") $MIDI
button bounds(97,310,9,15) text("") channel("mapioff5X") $MIDIX
rslider bounds(50,326,65,45) channel("ioff5") range(0,1,.5,1,.001) $RSLIDER
button bounds(120,310,37,15) text("Amp") channel("mapiamp5") $MIDI
button bounds(157,310,9,15) text("") channel("mapiamp5X") $MIDIX
rslider bounds(110,326,65,45) channel("iamp5") range(.01,50,1,.25,0.001) $RSLIDER 
}

;Master Volume Control
image channel("i6") bounds(4,400,40,212) plant("Amp") $PLANT
{
label channel("l21") bounds(8,2,25,12) text("Amp") $FONT
vslider bounds(5,12,30,170) channel("MAmp") range(0.00, 1.5, 0.75, 1, 0.0001) $VBASIC
button bounds(2,190,27,15) text("Amp") channel("mapMamp") $MIDI
button bounds(29,190,9,15) text("") channel("mapMampX") $MIDIX
}

;ADSR Bank
image channel("i7") bounds(46,400,102,212) plant("ADSR") $PLANT
{
label channel("l22") bounds(20, 4, 20, 12) text("A") $FONT
label channel("l23") bounds(40, 4, 20, 12) text("D") $FONT
label channel("l24") bounds(60, 4, 20, 12) text("S") $FONT
label channel("l25") bounds(80, 4, 20, 12) text("R") $FONT
label channel("l26") bounds(5,21,15,12) text("1") $FONT
label channel("l27") bounds(5,40,15,12) text("2") $FONT
label channel("l28") bounds(5,59,15,12) text("3") $FONT
label channel("l29") bounds(5,78,15,12) text("4") $FONT
label channel("l30") bounds(5,97,15,12) text("5") $FONT
label channel("l31") bounds(5,116,15,12) text("6") $FONT
label channel("l32") bounds(5,135,15,12) text("7") $FONT
label channel("l33") bounds(5,154,15,12) text("8") $FONT
label channel("l34") bounds(5,173,15,12) text("9") $FONT
label channel("l35") bounds(0,192,25,12) text("10") $FONT
rslider bounds(20, 19, 20, 20) channel("1a") range(0.001, 5, 0.01, 0.75, 0.001) $BASIC
rslider bounds(40, 19, 20, 20) channel("1d") range(0.001, 5, 0.1, 0.75, 0.001) $BASIC 
rslider bounds(60, 19, 20, 20) channel("1s") range(0, 1, 0.85, 1, 0.01) $BASIC 
rslider bounds(80, 19, 20, 20) channel("1r") range(0.001, 5, 0.1, 0.75, 0.001) $BASIC 
rslider bounds(20, 38, 20, 20) channel("2a") range(0.001, 5, 0.02, 0.75, 0.001) $BASIC
rslider bounds(40, 38, 20, 20) channel("2d") range(0.001, 5, 0.1, 0.75, 0.001) $BASIC 
rslider bounds(60, 38, 20, 20) channel("2s") range(0, 1, 0.85, 1, 0.01) $BASIC 
rslider bounds(80, 38, 20, 20) channel("2r") range(0.001, 5, 0.1, 0.75, 0.001) $BASIC 
rslider bounds(20, 57, 20, 20) channel("3a") range(0.001, 5, 0.03, 0.75, 0.001) $BASIC
rslider bounds(40, 57, 20, 20) channel("3d") range(0.001, 5, 0.1, 0.75, 0.001) $BASIC 
rslider bounds(60, 57, 20, 20) channel("3s") range(0, 1, 0.85, 1, 0.01) $BASIC 
rslider bounds(80, 57, 20, 20) channel("3r") range(0.001, 5, 0.1, 0.75, 0.001) $BASIC 
rslider bounds(20, 76, 20, 20) channel("4a") range(0.001, 5, 0.05, 0.75, 0.001) $BASIC
rslider bounds(40, 76, 20, 20) channel("4d") range(0.001, 5, 0.1, 0.75, 0.001) $BASIC 
rslider bounds(60, 76, 20, 20) channel("4s") range(0, 1, 0.85, 1, 0.01) $BASIC 
rslider bounds(80, 76, 20, 20) channel("4r") range(0.001, 5, 0.1, 0.75, 0.001) $BASIC 
rslider bounds(20, 95, 20, 20) channel("5a") range(0.001, 5, 0.07, 0.75, 0.001) $BASIC
rslider bounds(40, 95, 20, 20) channel("5d") range(0.001, 5, 0.1, 0.75, 0.001) $BASIC 
rslider bounds(60, 95, 20, 20) channel("5s") range(0, 1, 0.85, 1, 0.01) $BASIC 
rslider bounds(80, 95, 20, 20) channel("5r") range(0.001, 5, 0.1, 0.75, 0.001) $BASIC 
rslider bounds(20, 114, 20, 20) channel("6a") range(0.001, 5, 0.1, 0.75, 0.001) $BASIC
rslider bounds(40, 114, 20, 20) channel("6d") range(0.001, 5, 0.1, 0.75, 0.001) $BASIC 
rslider bounds(60, 114, 20, 20) channel("6s") range(0, 1, 0.85, 1, 0.01) $BASIC 
rslider bounds(80, 114, 20, 20) channel("6r") range(0.001, 5, 0.1, 0.75, 0.001) $BASIC 
rslider bounds(20, 133, 20, 20) channel("7a") range(0.001, 5, 0.15, 0.75, 0.001) $BASIC
rslider bounds(40, 133, 20, 20) channel("7d") range(0.001, 5, 0.1, 0.75, 0.001) $BASIC 
rslider bounds(60, 133, 20, 20) channel("7s") range(0, 1, 0.85, 1, 0.01) $BASIC 
rslider bounds(80, 133, 20, 20) channel("7r") range(0.001, 5, 0.1, 0.75, 0.001) $BASIC 
rslider bounds(20, 152, 20, 20) channel("8a") range(0.001, 5, 0.2, 0.75, 0.001) $BASIC
rslider bounds(40, 152, 20, 20) channel("8d") range(0.001, 5, 0.15, 0.75, 0.001) $BASIC 
rslider bounds(60, 152, 20, 20) channel("8s") range(0, 1, 0.85, 1, 0.01) $BASIC 
rslider bounds(80, 152, 20, 20) channel("8r") range(0.001, 5, 0.2, 0.75, 0.001) $BASIC 
rslider bounds(20, 171, 20, 20) channel("9a") range(0.001, 5, 0.25, 0.75, 0.001) $BASIC
rslider bounds(40, 171, 20, 20) channel("9d") range(0.001, 5, 0.2, 0.75, 0.001) $BASIC 
rslider bounds(60, 171, 20, 20) channel("9s") range(0, 1, 0.85, 1, 0.01) $BASIC 
rslider bounds(80, 171, 20, 20) channel("9r") range(0.001, 5, 0.25, 0.75, 0.001) $BASIC 
rslider bounds(20, 190, 20, 20) channel("10a") range(0.001, 5, 0.5, 0.75, 0.001) $BASIC
rslider bounds(40, 190, 20, 20) channel("10d") range(0.001, 5, 0.25, 0.75, 0.001) $BASIC 
rslider bounds(60, 190, 20, 20) channel("10s") range(0, 1, 0.85, 1, 0.01) $BASIC 
rslider bounds(80, 190, 20, 20) channel("10r") range(0.001, 5, 0.5, 0.75, 0.001) $BASIC 
}

;LFO Bank
image channel("i8") bounds(151,400,173,212) plant("ADSR") $PLANT
{
label channel("l36") bounds(30, 4, 40, 12) text("Wave") $FONT
label channel("l37") bounds(70, 4, 40, 12) text("Rate") $FONT
label channel("l38") bounds(97,14,50,10) text("x10 x100") $FONT
label channel("l39") bounds(136, 4, 40, 12) text("Rand") $FONT
button bounds(5, 20, 20, 15) channel("lfo1") text("1", "1") value(0) $BUTTONS
button bounds(5, 39, 20, 15) channel("lfo2") text("2", "2") value(0) $BUTTONS
button bounds(5, 58, 20, 15) channel("lfo3") text("3", "3") value(0) $BUTTONS
button bounds(5, 77, 20, 15) channel("lfo4") text("4", "4") value(0) $BUTTONS
button bounds(5, 96, 20, 15) channel("lfo5") text("5", "5") value(0) $BUTTONS
button bounds(5, 115, 20, 15) channel("lfo6") text("6", "6") value(0) $BUTTONS
button bounds(5, 134, 20, 15) channel("lfo7") text("7", "7") value(0) $BUTTONS
button bounds(5, 153, 20, 15) channel("lfo8") text("8", "8") value(0) $BUTTONS
button bounds(5, 172, 20, 15) channel("lfo9") text("9", "9") value(0) $BUTTONS
button bounds(5, 191, 20, 15) channel("lfo10") text("10", "10") value(0) $BUTTONS
combobox bounds(29,21,50,15) channel("lfo1fn") text("sine", "triangle", "square", "rampup", "rampdown", "pulse", "S&H", "rand")
combobox bounds(29,40,50,15) channel("lfo2fn") text("sine", "triangle", "square", "rampup", "rampdown", "pulse", "S&H", "rand")
combobox bounds(29,59,50,15) channel("lfo3fn") text("sine", "triangle", "square", "rampup", "rampdown", "pulse", "S&H", "rand")
combobox bounds(29,78,50,15) channel("lfo4fn") text("sine", "triangle", "square", "rampup", "rampdown", "pulse", "S&H", "rand")
combobox bounds(29,97,50,15) channel("lfo5fn") text("sine", "triangle", "square", "rampup", "rampdown", "pulse", "S&H", "rand")
combobox bounds(29,116,50,15) channel("lfo6fn") text("sine", "triangle", "square", "rampup", "rampdown", "pulse", "S&H", "rand")
combobox bounds(29,135,50,15) channel("lfo7fn") text("sine", "triangle", "square", "rampup", "rampdown", "pulse", "S&H", "rand")
combobox bounds(29,154,50,15) channel("lfo8fn") text("sine", "triangle", "square", "rampup", "rampdown", "pulse", "S&H", "rand")
combobox bounds(29,173,50,15) channel("lfo9fn") text("sine", "triangle", "square", "rampup", "rampdown", "pulse", "S&H", "rand")
combobox bounds(29,192,50,15) channel("lfo10fn") text("sine", "triangle", "square", "rampup", "rampdown", "pulse", "S&H", "rand")
rslider bounds(81, 19, 20, 20) channel("lfo1r") range(0, 15, 0, .5, 0.01) $BASIC 
rslider bounds(81, 38, 20, 20) channel("lfo2r") range(0, 15, 0, .5, 0.01) $BASIC 
rslider bounds(81, 57, 20, 20) channel("lfo3r") range(0, 15, 0, .5, 0.01) $BASIC 
rslider bounds(81, 76, 20, 20) channel("lfo4r") range(0, 15, 0, .5, 0.01) $BASIC 
rslider bounds(81, 95, 20, 20) channel("lfo5r") range(0, 15, 0, .5, 0.01) $BASIC 
rslider bounds(81, 114, 20, 20) channel("lfo6r") range(0, 15, 0, .5, 0.01) $BASIC 
rslider bounds(81, 133, 20, 20) channel("lfo7r") range(0, 15, 0, .5, 0.01) $BASIC 
rslider bounds(81, 152, 20, 20) channel("lfo8r") range(0, 15, 0, .5, 0.01) $BASIC 
rslider bounds(81, 171, 20, 20) channel("lfo9r") range(0, 15, 0, .5, 0.01) $BASIC 
rslider bounds(81, 190, 20, 20) channel("lfo10r") range(0, 15, 0, .5, 0.01) $BASIC 
button bounds(102,24,20,10) channel("lfo1x10") text("", "10") $BUTTONS
button bounds(124,24,20,10) channel("lfo1x100") text("", "100") $BUTTONS
button bounds(102,43,20,10) channel("lfo2x10") text("", "10") $BUTTONS
button bounds(124,43,20,10) channel("lfo2x100") text("", "100") $BUTTONS
button bounds(102,62,20,10) channel("lfo3x10") text("", "10") $BUTTONS
button bounds(124,62,20,10) channel("lfo3x100") text("", "100") $BUTTONS
button bounds(102,81,20,10) channel("lfo4x10") text("", "10") $BUTTONS
button bounds(124,81,20,10) channel("lfo4x100") text("", "100") $BUTTONS
button bounds(102,100,20,10) channel("lfo5x10") text("", "10") $BUTTONS
button bounds(124,100,20,10) channel("lfo5x100") text("", "100") $BUTTONS
button bounds(102,119,20,10) channel("lfo6x10") text("", "10") $BUTTONS
button bounds(124,119,20,10) channel("lfo6x100") text("", "100") $BUTTONS
button bounds(102,138,20,10) channel("lfo7x10") text("", "10") $BUTTONS
button bounds(124,138,20,10) channel("lfo7x100") text("", "100") $BUTTONS
button bounds(102,157,20,10) channel("lfo8x10") text("", "10") $BUTTONS
button bounds(124,157,20,10) channel("lfo8x100") text("", "100") $BUTTONS
button bounds(102,176,20,10) channel("lfo9x10") text("", "10") $BUTTONS
button bounds(124,176,20,10) channel("lfo9x100") text("", "100") $BUTTONS
button bounds(102,195,20,10) channel("lfo10x10") text("", "10") $BUTTONS
button bounds(124,195,20,10) channel("lfo10x100") text("", "100") $BUTTONS
rslider bounds(147, 19, 20, 20) channel("lfo1j") range(0, 1, 0, 1, 0.01) $BASIC 
rslider bounds(147, 38, 20, 20) channel("lfo2j") range(0, 1, 0, 1, 0.01) $BASIC 
rslider bounds(147, 57, 20, 20) channel("lfo3j") range(0, 1, 0, 1, 0.01) $BASIC 
rslider bounds(147, 76, 20, 20) channel("lfo4j") range(0, 1, 0, 1, 0.01) $BASIC 
rslider bounds(147, 95, 20, 20) channel("lfo5j") range(0, 1, 0, 1, 0.01) $BASIC 
rslider bounds(147, 114, 20, 20) channel("lfo6j") range(0, 1, 0, 1, 0.01) $BASIC 
rslider bounds(147, 133, 20, 20) channel("lfo7j") range(0, 1, 0, 1, 0.01) $BASIC 
rslider bounds(147, 152, 20, 20) channel("lfo8j") range(0, 1, 0, 1, 0.01) $BASIC 
rslider bounds(147, 171, 20, 20) channel("lfo9j") range(0, 1, 0, 1, 0.01) $BASIC 
rslider bounds(147, 190, 20, 20) channel("lfo10j") range(0, 1, 0, 1, 0.01) $BASIC 
}

;Oscillators
image channel("i9") bounds(326,400,717,105) plant("Osc1") $PLANT
{
label channel("l40") bounds(0,4,25,12) text("Osc") $FONT
label channel("l41") bounds(28,6,25,10) text("Amp") $FONT
label channel("l42") bounds(55,6,25,10) text("Pan") $FONT
label channel("l43") bounds(95,4,130,12) text("Active Axes/Dimensions") $FONT
label channel("l44") bounds(245,4,30,12) text("ADSR") $FONT
label channel("l45") bounds(291,3,30,10) text("Tune") $FONT 
label channel("l46") bounds(285,11,45,8) text("Coarse/Fine") $FONT
label channel("l47") bounds(359,3,30,10) text("Bend") $FONT
label channel("l48") bounds(350,11,45,8) text("Up/Down") $FONT 
label channel("l49") bounds(430,4,25,12) text("FM") $FONT
label channel("l50") bounds(466,6,35,10) text("Depth") $FONT
label channel("l51") bounds(501,6,30,10) text("ADSR") $FONT
label channel("l52") bounds(550,4,25,12) text("AM") $FONT
label channel("l53") bounds(588,6,35,10) text("Depth") $FONT
label channel("l54") bounds(621,6,30,10) text("ADSR") $FONT
label channel("l55") bounds(673,4,25,12) text("RM") $FONT
button bounds(3, 20, 25, 20) channel("osc1") text("1", "1") value(1) $BUTTONS
button bounds(3, 50, 25, 20) channel("osc2") text("2", "2") value(1) $BUTTONS
button bounds(3, 80, 25, 20) channel("osc3") text("3", "3") value(1) $BUTTONS
rslider bounds(30, 17, 25, 25) channel("amp1") range(0, 1, .5, 1, 0.01) $BASIC 
rslider bounds(30, 47, 25, 25) channel("amp2") range(0, 1, .5, 1, 0.01) $BASIC 
rslider bounds(30, 77, 25, 25) channel("amp3") range(0, 1, .5, 1, 0.01) $BASIC 
rslider bounds(57, 17, 25, 25) channel("pan1") range(0, 1, .48, 1, 0.01) $BASIC 
rslider bounds(57, 47, 25, 25) channel("pan2") range(0, 1, .45, 1, 0.01) $BASIC 
rslider bounds(57, 77, 25, 25) channel("pan3") range(0, 1, .55, 1, 0.01) $BASIC 
button bounds(90,20,25,20) channel("ax11") text("1", "1") value(1) $BUTTONS
button bounds(120,20,25,20) channel("ax12") text("2", "2") value(1) $BUTTONS
button bounds(150,20,25,20) channel("ax13") text("3", "3") value(0) $BUTTONS
button bounds(180,20,25,20) channel("ax14") text("4", "4") value(0) $BUTTONS
button bounds(210,20,25,20) channel("ax15") text("5", "5") value(0) $BUTTONS
button bounds(90,50,25,20) channel("ax21") text("1", "1") value(1) $BUTTONS
button bounds(120,50,25,20) channel("ax22") text("2", "2") value(1) $BUTTONS
button bounds(150,50,25,20) channel("ax23") text("3", "3") value(0) $BUTTONS
button bounds(180,50,25,20) channel("ax24") text("4", "4") value(0) $BUTTONS
button bounds(210,50,25,20) channel("ax25") text("5", "5") value(0) $BUTTONS
button bounds(90,80,25,20) channel("ax31") text("1", "1") value(1) $BUTTONS
button bounds(120,80,25,20) channel("ax32") text("2", "2") value(1) $BUTTONS
button bounds(150,80,25,20) channel("ax33") text("3", "3") value(0) $BUTTONS
button bounds(180,80,25,20) channel("ax34") text("4", "4") value(0) $BUTTONS
button bounds(210,80,25,20) channel("ax35") text("5", "5") value(0) $BUTTONS
combobox bounds(245,22,35,16) channel("env1") text("1","2","3","4","5","6","7","8","9","10")
combobox bounds(245,53,35,16) channel("env2") text("1","2","3","4","5","6","7","8","9","10")
combobox bounds(245,82,35,16) channel("env3") text("1","2","3","4","5","6","7","8","9","10")
rslider bounds(286, 17, 25, 25) channel("otc1") range(-24, 24, 0, 1, 1) $BASIC 
rslider bounds(286, 47, 25, 25) channel("otc2") range(-24, 24, 0, 1, 1) $BASIC 
rslider bounds(286, 77, 25, 25) channel("otc3") range(-24, 24, 0, 1, 1) $BASIC 
rslider bounds(308, 17, 25, 25) channel("otf1") range(-1, 1, 0, 1, 0.01) $BASIC 
rslider bounds(308, 47, 25, 25) channel("otf2") range(-1, 1, 0, 1, 0.01) $BASIC 
rslider bounds(308, 77, 25, 25) channel("otf3") range(-1, 1, 0, 1, 0.01) $BASIC 
nslider bounds(341,20,35,20) channel("up1") range(-24,24,2,1,.01)
nslider bounds(341,50,35,20) channel("up2") range(-24,24,2,1,.01)
nslider bounds(341,80,35,20) channel("up3") range(-24,24,2,1,.01)
nslider bounds(377,20,35,20) channel("down1") range(-24,24,2,1,.01)
nslider bounds(377,50,35,20) channel("down2") range(-24,24,2,1,.01)
nslider bounds(377,80,35,20) channel("down3") range(-24,24,2,1,.01)
combobox bounds(421,21,50,16) channel("fm1") text("none", "Osc 2", "Osc 3", "LFO1", "LFO2", "LFO3", "LFO4", "LFO5", "LFO6", "LFO7", "LFO8", "LFO9", "LFO10", "Input")
combobox bounds(421,51,50,16) channel("fm2") text("none", "Osc 1", "Osc 3", "LFO1", "LFO2", "LFO3", "LFO4", "LFO5", "LFO6", "LFO7", "LFO8", "LFO9", "LFO10", "Input")
combobox bounds(421,81,50,16) channel("fm3") text("none", "Osc 1", "Osc 2", "LFO1", "LFO2", "LFO3", "LFO4", "LFO5", "LFO6", "LFO7", "LFO8", "LFO9", "LFO10", "Input")
rslider bounds(472, 17, 25, 25) channel("ind1") range(0, 75, 1, .5, 0.01) identChannel("fi1") visible(0) $BASIC 
rslider bounds(472, 47, 25, 25) channel("ind2") range(0, 75, 1, .5, 0.01) identChannel("fi2") visible(0) $BASIC 
rslider bounds(472, 77, 25, 25) channel("ind3") range(0, 75, 1, .5, 0.01) identChannel("fi3") visible(0) $BASIC 
combobox bounds(498,21,35,16) channel("fmenv1") text("1","2","3","4","5","6","7","8","9","10") identChannel("fe1") visible(0) 
combobox bounds(498,51,35,16) channel("fmenv2") text("1","2","3","4","5","6","7","8","9","10") identChannel("fe2") visible(0) 
combobox bounds(498,81,35,16) channel("fmenv3") text("1","2","3","4","5","6","7","8","9","10") identChannel("fe3") visible(0) 
combobox bounds(543,21,50,16) channel("am1") text("none", "Osc 2", "Osc 3", "LFO1", "LFO2", "LFO3", "LFO4", "LFO5", "LFO6", "LFO7", "LFO8", "LFO9", "LFO10", "Input")
combobox bounds(543,51,50,16) channel("am2") text("none", "Osc 1", "Osc 3", "LFO1", "LFO2", "LFO3", "LFO4", "LFO5", "LFO6", "LFO7", "LFO8", "LFO9", "LFO10", "Input")
combobox bounds(543,81,50,16) channel("am3") text("none", "Osc 1", "Osc 2", "LFO1", "LFO2", "LFO3", "LFO4", "LFO5", "LFO6", "LFO7", "LFO8", "LFO9", "LFO10", "Input")
rslider bounds(593, 17, 25, 25) channel("aind1") range(0, 5, 1, 1, 0.001) identChannel("ai1") visible(0) $BASIC 
rslider bounds(593, 47, 25, 25) channel("aind2") range(0, 5, 1, 1, 0.001) identChannel("ai2") visible(0) $BASIC 
rslider bounds(593, 77, 25, 25) channel("aind3") range(0, 5, 1, 1, 0.001) identChannel("ai3") visible(0) $BASIC 
combobox bounds(620,21,35,16) channel("amenv1") text("1","2","3","4","5","6","7","8","9","10") identChannel("ae1") visible(0) 
combobox bounds(620,51,35,16) channel("amenv2") text("1","2","3","4","5","6","7","8","9","10") identChannel("ae2") visible(0)
combobox bounds(620,81,35,16) channel("amenv3") text("1","2","3","4","5","6","7","8","9","10") identChannel("ae3") visible(0)
combobox bounds(663,21,50,16) channel("rm1") text("none", "Osc 2", "Osc 3", "LFO1", "LFO2", "LFO3", "LFO4", "LFO5", "LFO6", "LFO7", "LFO8", "LFO9", "LFO10", "Input")
combobox bounds(663,51,50,16) channel("rm2") text("none", "Osc 1", "Osc 3", "LFO1", "LFO2", "LFO3", "LFO4", "LFO5", "LFO6", "LFO7", "LFO8", "LFO9", "LFO10", "Input")
combobox bounds(663,81,50,16) channel("rm3") text("none", "Osc 1", "Osc 2", "LFO1", "LFO2", "LFO3", "LFO4", "LFO5", "LFO6", "LFO7", "LFO8", "LFO9", "LFO10", "Input")
}

;FX plants:
;Latched Lowpass 
image channel("i10") bounds(326,510,158,102) plant("LatchedLP") $PLANT
{
button bounds(2,2,70,18) channel("LLPon") text("Dynamic Filter","Dynamic Filter") value(0) $BUTTONS
button bounds(74,2,22,17) channel("LLPlp") text("LP","LP") value(1) $BUTTONS
button bounds(97,2,22,17) channel("LLPbp") text("BP","BP") value(0) $BUTTONS
button bounds(120,2,22,17) channel("LLPhp") text("HP","HP") value(0) $BUTTONS
label channel("l56") bounds(2,29,35,12) text("Freq") $FONT
label channel("l57") bounds(90,21,50,8) text("(pitch in MIDI)") $FONT
label channel("l58") bounds(59,31,25,10) text("ADSR") $FONT
combobox bounds(2,44,50,16) channel("LLPcfset") text("MIDI in","Static")
combobox bounds(57,44,32,16) channel("LLPadsr") text("1","2","3","4","5","6","7","8","9","10")
label channel("l59") bounds(85,31,35,8) text("Offset") identChannel("offsetlabel") visible(1) $FONT
rslider bounds(92,39,25,25) channel("offset") range(-36,36,12,1,.01) identChannel("LLPoffset") visible(1) $BASIC
label channel("l60") bounds(92,31,25,8) text("Base") identChannel("baselabel") visible(0) $FONT
rslider bounds(92,39,25,25) channel("base") range(20,120,84,1,.01) identChannel("LLPbase") visible(0) $BASIC
label channel("l61") bounds(110,31,35,8) text("Target") $FONT
rslider bounds(115,39,25,25) channel("target") range(-36,36,18,1,.01) $BASIC
label channel("l62") bounds(10,69,20,12) text("Q") $FONT
label channel("l63") bounds(59,61,25,10) text("ADSR") $FONT
combobox bounds(57,73,30,16) channel("LLPQadsr") text("1","2","3","4","5","6","7","8","9","10")
label channel("l64") bounds(92,60,25,8) text("Base") $FONT
rslider bounds(92,68,25,25) channel("LLPQbase") range(.5, 25, 5, 1, 0.01) $BASIC
label channel("l65") bounds(110,60,35,8) text("Target") $FONT
rslider bounds(115,68,25,25) channel("LLPQtarget") range(.5, 25, 10, 1, 0.01) $BASIC
}

;Noise Generators
;Static Noise Generator
image channel("i11") bounds(487,555,100,35) plant("Static") $PLANT
{
button bounds(5, 8, 40, 18) channel("duston") text("Static", "Static") value(0) $BUTTONS
label channel("l66") bounds(44,2,30,10) text("Amp") $FONT
rslider bounds(50,10,20,20) channel("dustamp") range(0,1.5,0,.5,.0001) $BASIC
label channel("l67") bounds(67,2,30,10) text("Rate") $FONT
rslider bounds(72,10,20,20) channel("dustrate") range(.5,250,25,.5,.1) $BASIC
}
;white noise generator
image channel("i12") bounds(590,555,72,35) plant("White") $PLANT
{
button bounds(3, 8, 40, 18) channel("whiteon") text("White", "White") value(0) $BUTTONS
label channel("l68") bounds(42,2,30,10) text("Amp") $FONT
rslider bounds(48,10,20,20) channel("whiteamp") range(0,1.5,0,.5,.0001) $BASIC
}
;pink noise generator
image channel("i13") bounds(665,555,72,35) plant("Pink") $PLANT
{
button bounds(3, 8, 40, 18) channel("pinkon") text("Pink", "Pink") value(0) $BUTTONS
label channel("l69") bounds(42,2,30,10) text("Amp") $FONT
rslider bounds(48,10,20,20) channel("pinkamp") range(0,1.5,0,.5,.0001) $BASIC
}
;gaussian noise generator
image channel("i14") bounds(740,555,82,35) plant("Gauss") $PLANT
{
button bounds(3, 8, 50, 18) channel("gausson") text("Gaussian", "Gaussian") value(0) $BUTTONS
label channel("l70") bounds(52,2,30,10) text("Amp") $FONT
rslider bounds(58,10,20,20) channel("gaussamp") range(0,1.5,0,.5,.0001) $BASIC
}

;Random Note Generator
image channel("i15") bounds(487,510,300,40) plant("Random Note Generator") $PLANT
{
button bounds(5,2,110,15) channel("RNGon") text("Random Note Generator", "Random Note Generator") value(0) $BUTTONS
combobox bounds(5,18,73,14) channel("RNGmicro") text("Equal Temp", "Microtonal", "1/4 Tone", "1/8 Tone", "Whole Tone", "Minor 3rds", "Major 3rds", "4ths", "Tritones", "5ths", "10 Tone", "13 Tone", "15 Tone", "7 Tone", "8 Tone")
button bounds(79,18,34,14) channel("RNGgliss") text("S&H", "Gliss") value(0) $BUTTONS
button bounds(117,10,27,15) text("Rate") channel("mapRNGrate") $MIDI
button bounds(144,10,9,15) text("") channel("mapRNGrateX") $MIDIX
button bounds(177,10,27,15) text("R Dev") channel("mapRNGraterand") $MIDI
button bounds(204,10,9,15) text("") channel("mapRNGraterandX") $MIDIX
button bounds(237,10,27,15) text("F Dev") channel("mapRNGdev") $MIDI
button bounds(264,10,9,15) text("") channel("mapRNGdevX") $MIDIX
rslider bounds(152,5,25,25) channel("RNGrate") range(0.01,100,3.3,.5,0.01) $BASIC
rslider bounds(212,5,25,25) channel("RNGraterand") range(0,.95,0,1,0.01) $BASIC
rslider bounds(272,5,25,25) channel("RNGdev") range(0,60,6,1,0.01) $BASIC
}

;Distortion
image channel("i16") bounds(790,510,253,40) plant("Distort") $PLANT
{
button bounds(5,8,50,18) channel("diston") text("Distort", "Distort") value(0) $BUTTONS
button bounds(58,10,27,15) text("Dist") channel("mapdist") $MIDI
button bounds(85,10,9,15) text("") channel("mapdistX") $MIDIX
button bounds(121,10,30,15) text("Shape") channel("mapdist2") $MIDI
button bounds(151,10,9,15) text("") channel("mapdist2X") $MIDIX
button bounds(187,10,27,15) text("Fold") channel("mapdist3") $MIDI
button bounds(214,10,9,15) text("") channel("mapdist3X") $MIDIX
rslider bounds(94,5,25,25) channel("dist") range(0,1,0,1,0.01) $BASIC 
rslider bounds(160,5,25,25) channel("dist2") range(0,.999,0,1,0.001) $BASIC 
rslider bounds(223,5,25,25) channel("dist3") range(1,25,1,.5,0.001) $BASIC 
}

;Vibrato (LFO Modulation, controller 1)
image channel("i17") bounds(4,615,93,222) plant("Vib") $PLANT
{
label channel("l71") bounds(0,2,50,12) text("Vibrato") $FONT
button bounds(53,15,27,15) text("R Dev") channel("mapvibrand") $MIDI
button bounds(80,15,9,15) text("") channel("mapvibrandX") $MIDIX
rslider bounds(33,12,20,20) channel("vibrand") range(0, .99, 0.05, .5, 0.001) $BASIC
button bounds(8,200,27,15) text("Rate") channel("mapvibcps") $MIDI
button bounds(35,200,9,15) text("") channel("mapvibcpsX") $MIDIX
vslider bounds(13,50,25,145) channel("vibcps") range(0, 1, 0, .5, .01) $VBASIC
button bounds(53,200,27,15) text("Depth") channel("mapvibdepth") $MIDI
button bounds(80,200,9,15) text("") channel("mapvibdepthX") $MIDIX
vslider bounds(55,50,25,145) channel("vibdepth") range(0, 1, .5, .5, 0.01) $VBASIC
label channel("l72") bounds(3,25,25,10) text("max:") fontColour(255,255,255,255)
nslider bounds(1,35,45,19) channel("vibcpsmax") range(0,2500,10,1,.01)
nslider bounds(45,35,45,19) channel("vibdepthmax") range(0,48,.75,1,.01)
}

;LP Filter
image channel("i18") bounds(150,615,82,108) plant("LP") $PLANT
{
button bounds(18,2,45,17) channel("LPon") text("Lowpass", "Lowpass") value(0) $BUTTONS
combobox bounds(11,20,60,14) channel("LPsel") text("-6 dB","-12 dB","-18 dB","-24 dB")
label channel("l73") bounds(33,35,55,8) text("rate depth") $FONT
label channel("l74") bounds(45,59,25,8) text("rand") $FONT
button bounds(3,35,27,13) text("Cutoff") channel("mapLPcps") $MIDI
button bounds(30,35,9,13) text("") channel("mapLPcpsX") $MIDIX
rslider bounds(8,46,25,25) channel("LPcps") range(2, 14, 11, 1, .001) $BASIC ;pitch expressed in oct
button bounds(3,70,27,13) text("Res") channel("mapLPres") $MIDI
button bounds(30,70,9,13) text("") channel("mapLPresX") $MIDIX
rslider bounds(8,81,25,25) channel("LPres") range(0.01, .99, 0.1, 1, 0.01) $BASIC
rslider bounds(40,42,20,20) channel("LPcfr") range(0,75,0,.5,.01) $BASIC
rslider bounds(58,42,20,20) channel("LPcfd") range(0,2.5,0,.5,.01) $BASIC
rslider bounds(49,65,20,20) channel("LPrand") range(0,.95,0,1,.01) $BASIC
rslider bounds(40,85,20,20) channel("LPresr") range(0,75,0,.5,.01) $BASIC
rslider bounds(58,85,20,20) channel("LPresd") range(0,2.5,0,.5,.01) $BASIC
}

;Parallel Filters (selectable)
image channel("i19") bounds(235,615,173,108) plant("parallel") $PLANT
{
button bounds(5,2,45,17) channel("paron") text("Filters") value(0) $BUTTONS
combobox bounds(53,3,80,15) channel("vpresets") text("Voice Formants","Soprano ah","Soprano eh","Soprano ih","Soprano oh","Soprano uh","Alto ah","Alto eh","Alto ih","Alto oh","Alto uh","Tenor ah","Tenor eh","Tenor ih","Tenor oh","Tenor uh","Bass ah","Bass eh","Bass ih","Bass oh","Bass uh", )
label channel("l75") bounds(131,5,25,8) text("port") $FONT
rslider bounds(153,0,20,20) channel("fport") range(0,5,.1,.25,0.01) $BASIC 
label channel("l76") bounds(5,20,35,10) text("Select") $FONT
label channel("l77") bounds(36,20,35,10) text("Cutoff") $FONT
label channel("l78") bounds(68,23,55,8) text("rate depth rand") $FONT
label channel("l79") bounds(118,20,35,10) text("Res") $FONT
label channel("l80") bounds(140,20,35,10) text("Amp") $FONT
combobox bounds(5,34,36,14) channel("parsel1") text("LP","BP","HP","off") value(1)
combobox bounds(5,53,36,14) channel("parsel2") text("LP","BP","HP","off") value(2)
combobox bounds(5,72,36,14) channel("parsel3") text("LP","BP","HP","off") value(2)
combobox bounds(5,91,36,14) channel("parsel4") text("LP","BP","HP","off") value(3)
rslider bounds(41,27,25,25) channel("parF1") range(2, 14, 8, 1, 0.001) $BASIC ;expressing pitch in oct and resonance needs to be between .5-25
rslider bounds(41,46,25,25) channel("parF2") range(2, 14, 9, 1, 0.001) $BASIC
rslider bounds(41,65,25,25) channel("parF3") range(2, 14, 10, 1, 0.001) $BASIC
rslider bounds(41,84,25,25) channel("parF4") range(2, 14, 11, 1, 0.001) $BASIC
rslider bounds(68,30,20,20) channel("parcfr1") range(0,75,0,.5,.01) $BASIC
rslider bounds(68,49,20,20) channel("parcfr2") range(0,75,0,.5,.01) $BASIC
rslider bounds(68,68,20,20) channel("parcfr3") range(0,75,0,.5,.01) $BASIC
rslider bounds(68,87,20,20) channel("parcfr4") range(0,75,0,.5,.01) $BASIC
rslider bounds(86,30,20,20) channel("parcfd1") range(0,2.5,0,.5,.001) $BASIC ;depth calculated in oct as well
rslider bounds(86,49,20,20) channel("parcfd2") range(0,2.5,0,.5,.001) $BASIC
rslider bounds(86,68,20,20) channel("parcfd3") range(0,2.5,0,.5,.001) $BASIC
rslider bounds(86,87,20,20) channel("parcfd4") range(0,2.5,0,.5,.001) $BASIC
rslider bounds(104,30,20,20) channel("parcfrnd1") range(0,.95,0,1,.01) $BASIC
rslider bounds(104,49,20,20) channel("parcfrnd2") range(0,.95,0,1,.01) $BASIC
rslider bounds(104,68,20,20) channel("parcfrnd3") range(0,.95,0,1,.01) $BASIC
rslider bounds(104,87,20,20) channel("parcfrnd4") range(0,.95,0,1,.01) $BASIC
rslider bounds(123,27,25,25) channel("parres1") range(.5, 25, 1, 1, 0.01) $BASIC 
rslider bounds(123,46,25,25) channel("parres2") range(.5, 25, 1, 1, 0.01) $BASIC 
rslider bounds(123,65,25,25) channel("parres3") range(.5, 25, 1, 1, 0.01) $BASIC 
rslider bounds(123,84,25,25) channel("parres4") range(.5, 25, 1, 1, 0.01) $BASIC 
rslider bounds(145,27,25,25) channel("paramp1") range(0, 1.5, 1, 1, 0.001) $BASIC 
rslider bounds(145,46,25,25) channel("paramp2") range(0, 1.5, 1, 1, 0.001) $BASIC 
rslider bounds(145,65,25,25) channel("paramp3") range(0, 1.5, 1, 1, 0.001) $BASIC 
rslider bounds(145,84,25,25) channel("paramp4") range(0, 1.5, 1, 1, 0.001) $BASIC 
}

;phaser
image channel("i20") bounds(411,615,72,108) plant("Phaser") $PLANT
{
button bounds(13,2,45,17) channel("phson") text("Phaser", "Phaser") $BUTTONS
button bounds(7,32,27,15) text("Speed") channel("mapphscps") $MIDI
button bounds(34,32,9,15) text("") channel("mapphscpsX") $MIDIX
rslider bounds(44,27,25,25) channel("phscps") range(0.01, 100, .4, 0.25, 0.01) $BASIC
button bounds(7,55,27,15) text("FB") channel("mapphsFB") $MIDI
button bounds(34,55,9,15) text("") channel("mapphsFBX") $MIDIX
rslider bounds(44,50,25,25) channel("phsFB") range(0, 1, 0.5, 1, 0.01) $BASIC
button bounds(7,78,27,15) text("Q") channel("mapphsQ") $MIDI
button bounds(34,78,9,15) text("") channel("mapphsQX") $MIDIX
rslider bounds(44,74,25,25) channel("phsQ") range(0.01, 100, 1, .25, 0.01) $BASIC
}

;flanger
image channel("i21") bounds(485,615,55,108) plant("Flanger") $PLANT
{
button bounds(7,2,40,17) channel("flon") text("Flanger", "Flanger") $BUTTONS
button bounds(10,28,27,15) text("Speed") channel("mapflcps") $MIDI
button bounds(37,28,9,15) text("") channel("mapflcpsX") $MIDIX
rslider bounds(15,41,25,25) channel("flcps") range(0.01, 100, .05, 0.25, 0.01) $BASIC
button bounds(10,64,27,15) text("FB") channel("mapflFB") $MIDI
button bounds(37,64,9,15) text("") channel("mapflFBX") $MIDIX
rslider bounds(15,77,25,25) channel("flFB") range(0, .99, 0.5, 1, 0.01) $BASIC
}

;Transposer/Harmonizer
image channel("i22") bounds(542,615,248,108) plant("Transposer") $PLANT
{
button bounds(4,2,58,17) channel("ton") text("Transposer", "Transposer") $BUTTONS
button bounds(87,6,27,12) text("Mix") channel("mapharmmix") $MIDI
button bounds(114,6,9,12) text("") channel("mapharmmixX") $MIDIX
rslider bounds(62, 0, 25, 25) channel("harmmix") range(0, 1, .5, 1, 0.01) $BASIC
combobox bounds(128,3,80,15) channel("Tpresets") text("Fat","Fatter","Warble","5ths","4ths","M3rds","Mi3rds","Cluster 1","Cluster 2","Whole Tones","Stacked 5ths","Stacked 4ths","Stacked M3rds","Stacked Mi3rds","8ves","Big 5ths","Major","Minor","V7","M7","M9","Mi7","Sus","V7sus","V7+9","V9","V7+9B","no T")
label channel("l81") bounds(206,5,25,8) text("port") $FONT
rslider bounds(228,0,20,20) channel("Tport") range(0,5,.02,.25,0.01) $BASIC 
 
button bounds(5,21,18,13) channel("harmon1") text("Off", "On") value(1) $BUTTONS
button bounds(5,35,27,13) text("Coarse") channel("mapharmon1C") $MIDI
button bounds(32,35,9,13) text("") channel("mapharmon1CX") $MIDIX
rslider bounds(8, 46, 25, 25) channel("harmon1C") range(-24, 24, 0, 1, 1) $BASIC
button bounds(7,70,27,13) text("Fine") channel("mapharmon1F") $MIDI
button bounds(34,70,9,13) text("") channel("mapharmon1FX") $MIDIX
rslider bounds(8, 81, 25, 25) channel("harmon1F") range(-1, 1, .14, 1, 0.01) $BASIC
button bounds(45,21,18,13) channel("harmon2") text("Off", "On") value(1) $BUTTONS
button bounds(45,35,27,13) text("Coarse") channel("mapharmon2C") $MIDI
button bounds(72,35,9,13) text("") channel("mapharmon2CX") $MIDIX
rslider bounds(48, 46, 25, 25) channel("harmon2C") range(-24, 24, 0, 1, 1) $BASIC
button bounds(45,70,27,13) text("Fine") channel("mapharmon2F") $MIDI
button bounds(72,70,9,13) text("") channel("mapharmon2FX") $MIDIX
rslider bounds(48, 81, 25, 25) channel("harmon2F") range(-1, 1, 0-.16, 1, 0.01) $BASIC
button bounds(85,21,18,13) channel("harmon3") text("Off", "On") value(1) $BUTTONS
button bounds(85,35,27,13) text("Coarse") channel("mapharmon3C") $MIDI
button bounds(112,35,9,13) text("") channel("mapharmon3CX") $MIDIX
rslider bounds(88, 46, 25, 25) channel("harmon3C") range(-24, 24, 0, 1, 1) $BASIC
button bounds(85,70,27,13) text("Fine") channel("mapharmon3F") $MIDI
button bounds(112,70,9,13) text("") channel("mapharmon3FX") $MIDIX
rslider bounds(88, 81, 25, 25) channel("harmon3F") range(-1, 1, .09, 1, 0.01) $BASIC
button bounds(125,21,18,13) channel("harmon4") text("Off", "On") value(1) $BUTTONS
button bounds(125,35,27,13) text("Coarse") channel("mapharmon4C") $MIDI
button bounds(152,35,9,13) text("") channel("mapharmon4CX") $MIDIX
rslider bounds(128, 46, 25, 25) channel("harmon4C") range(-24, 24, 0, 1, 1) $BASIC
button bounds(125,70,27,13) text("Fine") channel("mapharmon4F") $MIDI
button bounds(152,70,9,13) text("") channel("mapharmon4FX") $MIDIX
rslider bounds(128, 81, 25, 25) channel("harmon4F") range(-1, 1, 0-.12, 1, 0.01) $BASIC
button bounds(165,21,18,13) channel("harmon5") text("Off", "On") value(1) $BUTTONS
button bounds(165,35,27,13) text("Coarse") channel("mapharmon5C") $MIDI
button bounds(192,35,9,13) text("") channel("mapharmon5CX") $MIDIX
rslider bounds(168, 46, 25, 25) channel("harmon5C") range(-24, 24, 0, 1, 1) $BASIC
button bounds(165,70,27,13) text("Fine") channel("mapharmon5F") $MIDI
button bounds(202,70,9,13) text("") channel("mapharmon5FX") $MIDIX
rslider bounds(168, 81, 25, 25) channel("harmon5F") range(-1, 1, 0.11, 1, 0.01) $BASIC
button bounds(205,21,18,13) channel("harmon6") text("Off", "On") value(1) $BUTTONS
button bounds(205,35,27,13) text("Coarse") channel("mapharmon6C") $MIDI
button bounds(232,35,9,13) text("") channel("mapharmon6CX") $MIDIX
rslider bounds(208, 46, 25, 25) channel("harmon6C") range(-24, 24, 0, 1, 1) $BASIC
button bounds(205,70,27,13) text("Fine") channel("mapharmon6F") $MIDI
button bounds(232,70,9,13) text("") channel("mapharmon6FX") $MIDIX
rslider bounds(208, 81, 25, 25) channel("harmon6F") range(-1, 1, -.05, 1, 0.01) $BASIC
}

;Chorus
image channel("i23") bounds(792,615,123,108) plant("Chorus") $PLANT
{
button bounds(40,2,45,17) channel("chon") text("Chorus", "Chorus") $BUTTONS
button bounds(5,24,27,15) text("Mix") channel("mapchmix") $MIDI
button bounds(32,24,9,15) text("") channel("mapchmixX") $MIDIX
button bounds(44,24,27,15) text("Rate") channel("mapchcps") $MIDI
button bounds(71,24,9,15) text("") channel("mapchcpsX") $MIDIX
button bounds(83,24,27,15) text("FB") channel("mapchFB") $MIDI
button bounds(110,24,9,15) text("") channel("mapchFBX") $MIDIX
rslider bounds(9, 37, 25, 25) channel("chmix") range(0, 1, .5, 1, 0.01) $BASIC 
rslider bounds(48, 37, 25, 25) channel("chcps") range(.01, 25, .5, .5, 0.001) $BASIC 
rslider bounds(87, 37, 25, 25) channel("chFB") range(0, .999, .7, 1, 0.001) $BASIC 
button bounds(5,60,27,15) text("Depth") channel("mapchdepth") $MIDI
button bounds(32,60,9,15) text("") channel("mapchdepthX") $MIDIX
button bounds(43,60,27,15) text("Delay") channel("mapchdel") $MIDI
button bounds(71,60,9,15) text("") channel("mapchdelX") $MIDIX
button bounds(83,60,27,15) text("Rand") channel("mapchrand") $MIDI
button bounds(110,60,9,15) text("") channel("mapchrandX") $MIDIX
rslider bounds(9, 73, 25, 25) channel("chdepth") range(.1, 50, 1.5, .5, 0.01) $BASIC 
rslider bounds(48, 73, 25, 25) channel("chdel") range(.1, 50, 15, 1, 0.01) $BASIC 
rslider bounds(87, 73, 25, 25) channel("chrand") range(0, .9, .1, .5, 0.001) $BASIC 
}

;delay
image channel("i24") bounds(917,615,52,108) plant("Delay") $PLANT
{
button bounds(6,2,40,17) channel("delon") text("Delay", "Delay") $BUTTONS
button bounds(8,24,27,15) text("Time") channel("mapdeltime") $MIDI
button bounds(35,24,9,15) text("") channel("mapdeltimeX") $MIDIX
rslider bounds(13,37,25,25) channel("deltime") range(0.001, 4.99, .08, 0.25, 0.0001) $BASIC
button bounds(8,60,27,15) text("FB") channel("mapdelFB") $MIDI
button bounds(35,60,9,15) text("") channel("mapdelFBX") $MIDIX
rslider bounds(13,73,25,25) channel("delFB") range(0, .99, .35, 1, 0.01) $BASIC
}

;reverbsc
image channel("i25") bounds(971,615,72,108) plant("Reverb") $PLANT
{
button bounds(14,2,45,17) channel("revon") text("Reverb", "Reverb") $BUTTONS
button bounds(5,28,30,15) text("Mix") channel("maprevmix") $MIDI
button bounds(35,28,9,15) text("") channel("maprevmixX") $MIDIX
rslider bounds(44,23,25,25) channel("revmix") range(0,1, .35, 1, 0.01) $BASIC
button bounds(5,51,30,15) text("Decay") channel("maprevFB") $MIDI
button bounds(35,51,9,15) text("") channel("maprevFBX") $MIDIX
rslider bounds(44,46,25,25) channel("revFB") range(0.01,0.999, .75, 1.75, 0.001) $BASIC
button bounds(5,74,30,15) text("LP") channel("maprevLP") $MIDI
button bounds(35,74,9,15) text("") channel("maprevLPX") $MIDIX
rslider bounds(44,69,25,25) channel("revLP") range(200, 20000, 12500, .5, 10) $BASIC
}

;ribbon controller
image channel("i26") bounds(101,725,941,25) plant("ribbon") $PLANT
{
button bounds(5,4,30,17) channel("ribon") text("Off", "On") $BUTTONS
button bounds(40,5,40,15) text("Ribbon") channel("maprib") $MIDI
button bounds(80,5,9,15) text("") channel("mapribX") $MIDIX
hslider bounds(89,2,845,20) channel("ribbon") range(-36,36,0,1,.0001) identChannel("ribbonrange") valueTextBox(1) textBoxColour("black") textColour("Gainsboro") $VBASIC
}

</Cabbage>

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; CSOUND CODE ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
<CsoundSynthesizer>
<CsOptions>
-n -d -+rtmidi=NULL -M0 -m0d --midi-key=4 --midi-velocity-amp=5 --displays ;sends MIDI note number and velocity to instr 1 as p4 and p5 respectively
</CsOptions>
<CsInstruments>

; Initialize the global variables. 
;sr = 48000
gisr=sr
ksmps = 100
nchnls = 2
0dbfs = 1
massign	0,10

gaSynL,gaSynR init 0   ;global synth sends to effects, need global to send all instances of instr 1 to FX
gaChorL,gaChorR init 0  ;global audio for chorus effect
gaDelL,gaDelR init 0   ;global feedback delay lines sends to reverb
gaFXL,gaFXR init 0    ;send to global reverb and audio outs
gamicL, gamicR, gasfL, gasfR init 0
galiveL,galiveR,galiveRM,galiveAM init 0
gkliveFM init 0
galfo1,galfo2,galfo3,galfo4,galfo5,galfo6,galfo7,galfo8,galfo9,galfo10 init 0 ;bipolar LFO signals used for RM
galfo1u,galfo2u,galfo3u,galfo4u,galfo5u,galfo6u,galfo7u,galfo8u,galfo9u,galfo10u init 0 ;unipolar LFO signals used for AM
gkstatus,gkchan,gkdata1,gkdata2 init 0 ;initialize global MIDI settings
gichnls init 0 ;globals for soundfile table loading
giReady init 0
gSfilepath init ""
gkTabLen init 2
giTable init 501
gimorph1 ftgen 91,0,8,-2,101,102,103,104,105,106,107,108 ;f tables storing waveforms
gimorph2 ftgen 92,0,8,-2,101,102,103,104,105,106,107,108
gimorph3 ftgen 93,0,8,-2,101,102,103,104,105,106,107,108
gimorph4 ftgen 94,0,8,-2,101,102,103,104,105,106,107,108
gimorph5 ftgen 95,0,8,-2,101,102,103,104,105,106,107,108
gkRecordingActiveFlag,gkFileRecorded init 0

instr 1   ;live audio input and record/play control
kplay   chnget  "sfplay"
gSfilepath chnget "openFile"
    
if changed(gSfilepath) == 1 then ;loads soundfile
    SIdentString sprintfk "file(\"%s\")", gSfilepath
;    chnset SIdentString, "filer"
    event   "i",3,0,0
endif
        
if changed(kplay) == 1 then ;turns on soundfile player
    if kplay=1 then 
    event "i",2,0,10000
    else
    turnoff2  2,0,.05
    endif
endif

kliveon chnget "liveon"
kliveon port kliveon,.025
klivech chnget "livech"
kliveamp chnget "liveamp"

ainL,ainR ins
ainL=ainL*kliveon*kliveamp
ainR=ainR*kliveon*kliveamp
if klivech=1 then
gamicL=ainL
gamicR=ainR
else
gamicL=ainL+ainR
gamicR=ainL+ainR
endif

gkrecord	chnget	"record"
gkplay		chnget	"play"
kRecStart	trigger	gkrecord,0.5,0
  if kRecStart==1 && gkRecordingActiveFlag==0 then
    event	"i",600,0,-1
    gkRecordingActiveFlag	=	1
  endif
  kPlayStart	trigger	gkplay,0.5,0
  if kPlayStart==1 && gkFileRecorded==1 then
    event	"i",601,ksmps/sr,3600
  endif
  
;this final section loads the selected function table numbers to f91-5 to control ftmorf
kfn11 chnget "fn11"
kfn12 chnget "fn12"
kfn13 chnget "fn13"
kfn14 chnget "fn14"
kfn15 chnget "fn15"
kfn16 chnget "fn16"
kfn17 chnget "fn17"
kfn18 chnget "fn18"
ktrigger1 changed kfn11,kfn12,kfn13,kfn14,kfn15,kfn16,kfn17,kfn18
if ktrigger1=1 then
event "f",gimorph1,0,8,-2,kfn11+100,kfn12+100,kfn13+100,kfn14+100,kfn15+100,kfn16+100,kfn17+100,kfn18+100
endif
kfn21 chnget "fn21"
kfn22 chnget "fn22"
kfn23 chnget "fn23"
kfn24 chnget "fn24"
kfn25 chnget "fn25"
kfn26 chnget "fn26"
kfn27 chnget "fn27"
kfn28 chnget "fn28"
ktrigger2 changed kfn21,kfn22,kfn23,kfn24,kfn25,kfn26,kfn27,kfn28
if ktrigger2=1 then
event "f",gimorph2,0,8,-2,kfn21+100,kfn22+100,kfn23+100,kfn24+100,kfn25+100,kfn26+100,kfn27+100,kfn28+100
endif
kfn31 chnget "fn31"
kfn32 chnget "fn32"
kfn33 chnget "fn33"
kfn34 chnget "fn34"
kfn35 chnget "fn35"
kfn36 chnget "fn36"
kfn37 chnget "fn37"
kfn38 chnget "fn38"
ktrigger3 changed kfn31,kfn32,kfn33,kfn34,kfn35,kfn36,kfn37,kfn38
if ktrigger3=1 then
event "f",gimorph3,0,8,-2,kfn31+100,kfn32+100,kfn33+100,kfn34+100,kfn35+100,kfn36+100,kfn37+100,kfn38+100
endif
kfn41 chnget "fn41"
kfn42 chnget "fn42"
kfn43 chnget "fn43"
kfn44 chnget "fn44"
kfn45 chnget "fn45"
kfn46 chnget "fn46"
kfn47 chnget "fn47"
kfn48 chnget "fn48"
ktrigger4 changed kfn41,kfn42,kfn43,kfn44,kfn45,kfn46,kfn47,kfn48
if ktrigger4=1 then
event "f",gimorph4,0,8,-2,kfn41+100,kfn42+100,kfn43+100,kfn44+100,kfn45+100,kfn46+100,kfn47+100,kfn48+100
endif
kfn51 chnget "fn51"
kfn52 chnget "fn52"
kfn53 chnget "fn53"
kfn54 chnget "fn54"
kfn55 chnget "fn55"
kfn56 chnget "fn56"
kfn57 chnget "fn57"
kfn58 chnget "fn58"
ktrigger5 changed kfn51,kfn52,kfn53,kfn54,kfn55,kfn56,kfn57,kfn58
if ktrigger5=1 then
event "f",gimorph5,0,8,-2,kfn51+100,kfn52+100,kfn53+100,kfn54+100,kfn55+100,kfn56+100,kfn57+100,kfn58+100
endif

kmorph1 chnget "morph1" ;generates f96-100
kmorph1 port kmorph1,.05
ftmorf kmorph1,gimorph1,96
 if changed(kmorph1)==1 then
 chnset "tableNumber(96)","table96"
 endif
kmorph2 chnget "morph2"
kmorph2 port kmorph2,.05
ftmorf kmorph2,gimorph2,97
 if changed(kmorph2)==1 then
 chnset "tableNumber(97)","table97"
 endif
kmorph3 chnget "morph3"
kmorph3 port kmorph3,.05
ftmorf kmorph3,gimorph3,98
 if changed(kmorph3)==1 then
 chnset "tableNumber(98)","table98"
 endif
kmorph4 chnget "morph4"
kmorph4 port kmorph4,.05
ftmorf kmorph4,gimorph4,99
 if changed(kmorph4)==1 then
 chnset "tableNumber(99)","table99"
 endif
kmorph5 chnget "morph5"
kmorph5 port kmorph5,.05
ftmorf kmorph5,gimorph5,100
 if changed(kmorph5)==1 then
 chnset "tableNumber(100)","table100"
 endif

endin

instr 2
kloop chnget "sfloop"
iloop=i(kloop)
kingain chnget  "sfamp"
kEnv linsegr 0,.05,1,p3-.05,1,.1,0
    if  gichnls==1 then
    a1  loscil 1,1,giTable,1,iloop
    gasfL=a1*kingain*kEnv;*ksfon ;add output into global audio mix
    gasfR=a1*kingain*kEnv;*ksfon
    elseif  gichnls==2 then
    a1,a2   loscil  1,1,giTable,1,iloop
    gasfL=a1*kingain*kEnv;*ksfon
    gasfR=a2*kingain*kEnv;*ksfon
    endif
endin

instr 3
giTable ftgen   1,0,0,1,gSfilepath,0,0,0
gichnls filenchnls  gSfilepath
giReady=1 ;default if no string has been loaded yet
gkTabLen    init    ftlen(giTable)/gichnls
Smessage    sprintfk    "file(%s)", gSfilepath
endin

instr 4 ;mixes mic/line and soundfile player to create signal to send 
klivetoOsc chnget "livetoOsc"
klivetoOsc port klivetoOsc,.025
klivetoFX chnget "livetoFX"
klivetoFX port klivetoFX,.025
ainL=gamicL+gasfL
ainR=gamicR+gasfR
galiveL=ainL*klivetoFX
galiveR=ainR*klivetoFX
galiveRM=((ainL+ainR)*.7)*klivetoOsc
galiveAM=(galiveRM*.5*klivetoOsc)+.5
endin

instr 5    ;global LFO data
klfo1on chnget "lfo1"
klfo2on chnget "lfo2"
klfo3on chnget "lfo3"
klfo4on chnget "lfo4"
klfo5on chnget "lfo5"
klfo6on chnget "lfo6"
klfo7on chnget "lfo7"
klfo8on chnget "lfo8"
klfo9on chnget "lfo9"
klfo10on chnget "lfo10"
klfo1fn chnget "lfo1fn"
klfo2fn chnget "lfo2fn"
klfo3fn chnget "lfo3fn"
klfo4fn chnget "lfo4fn"
klfo5fn chnget "lfo5fn"
klfo6fn chnget "lfo6fn"
klfo7fn chnget "lfo7fn"
klfo8fn chnget "lfo8fn"
klfo9fn chnget "lfo9fn"
klfo10fn chnget "lfo10fn"
klfo1r chnget "lfo1r"
klfo2r chnget "lfo2r"
klfo3r chnget "lfo3r"
klfo4r chnget "lfo4r"
klfo5r chnget "lfo5r"
klfo6r chnget "lfo6r"
klfo7r chnget "lfo7r"
klfo8r chnget "lfo8r"
klfo9r chnget "lfo9r"
klfo10r chnget "lfo10r"
klfo1x10 chnget "lfo1x10"
klfo1x10=1+(klfo1x10*9)
klfo2x10 chnget "lfo2x10"
klfo2x10=1+(klfo2x10*9)
klfo3x10 chnget "lfo3x10"
klfo3x10=1+(klfo3x10*9)
klfo4x10 chnget "lfo4x10"
klfo4x10=1+(klfo4x10*9)
klfo5x10 chnget "lfo5x10"
klfo5x10=1+(klfo5x10*9)
klfo6x10 chnget "lfo6x10"
klfo6x10=1+(klfo6x10*9)
klfo7x10 chnget "lfo7x10"
klfo7x10=1+(klfo7x10*9)
klfo8x10 chnget "lfo8x10"
klfo8x10=1+(klfo8x10*9)
klfo9x10 chnget "lfo9x10"
klfo9x10=1+(klfo9x10*9)
klfo10x10 chnget "lfo10x10"
klfo10x10=1+(klfo10x10*9)
klfo1x100 chnget "lfo1x100"
klfo1x100=1+(klfo1x100*99)
klfo2x100 chnget "lfo2x100"
klfo2x100=1+(klfo2x100*99)
klfo3x100 chnget "lfo3x100"
klfo3x100=1+(klfo3x100*99)
klfo4x100 chnget "lfo4x100"
klfo4x100=1+(klfo4x100*99)
klfo5x100 chnget "lfo5x100"
klfo5x100=1+(klfo5x100*99)
klfo6x100 chnget "lfo6x100"
klfo6x100=1+(klfo6x100*99)
klfo7x100 chnget "lfo7x100"
klfo7x100=1+(klfo7x100*99)
klfo8x100 chnget "lfo8x100"
klfo8x100=1+(klfo8x100*99)
klfo9x100 chnget "lfo9x100"
klfo9x100=1+(klfo9x100*99)
klfo10x100 chnget "lfo10x100"
klfo10x100=1+(klfo10x100*99)
klfo1j chnget "lfo1j"
klfo2j chnget "lfo2j"
klfo3j chnget "lfo3j"
klfo4j chnget "lfo4j"
klfo5j chnget "lfo5j"
klfo6j chnget "lfo6j"
klfo7j chnget "lfo7j"
klfo8j chnget "lfo8j"
klfo9j chnget "lfo9j"
klfo10j chnget "lfo10j"

klfo1F=klfo1r*klfo1x10*klfo1x100 ;calculate base cps
kjit1 jitter klfo1j*klfo1F,4,10 ;create jitter relative to base cps
klfo1cps=klfo1F+kjit1 ;add together for final cps for oscillators
if klfo1fn = 1 then
galfo1 oscili 1,klfo1cps,25
elseif klfo1fn = 2 then 
galfo1 oscili 1,klfo1cps,30
elseif klfo1fn = 3 then 
galfo1 oscili 1,klfo1cps,31
elseif klfo1fn = 4 then 
galfo1 oscili 1,klfo1cps,32
elseif klfo1fn = 5 then 
galfo1 oscili 1,klfo1cps,33
elseif klfo1fn = 6 then 
galfo1 oscili 1,klfo1cps,34
elseif klfo1fn = 7 then 
galfo1 randh 1,klfo1cps
elseif klfo1fn = 8 then 
galfo1 randi 1,klfo1cps
endif
if klfo1r==0 goto Z1
galfo1=galfo1*klfo1on
goto NEXT1
Z1:
galfo1=0
NEXT1:
galfo1u=(galfo1*.5)+.5 ;a-rate LFO used for AM

klfo2F=klfo2r*klfo2x10*klfo2x100
kjit2 jitter klfo2j*klfo2F,4,10
klfo2cps=klfo2F+kjit2
if klfo2fn = 1 then
galfo2 oscili 1,klfo2cps,25
elseif klfo2fn = 2 then 
galfo2 oscili 1,klfo2cps,30
elseif klfo2fn = 3 then 
galfo2 oscili 1,klfo2cps,31
elseif klfo2fn = 4 then 
galfo2 oscili 1,klfo2cps,32
elseif klfo2fn = 5 then 
galfo2 oscili 1,klfo2cps,33
elseif klfo2fn = 6 then 
galfo2 oscili 1,klfo2cps,34
elseif klfo2fn = 7 then 
galfo2 randh 1,klfo2cps
elseif klfo2fn = 8 then 
galfo2 randi 1,klfo2cps
endif
if klfo2r==0 goto Z2
galfo2=galfo2*klfo2on
goto NEXT2
Z2:
galfo2=0
NEXT2:
galfo2u=(galfo2*.5)+.5

klfo3F=klfo3r*klfo3x10*klfo3x100
kjit3 jitter klfo3j*klfo3F,4,10
klfo3cps=klfo3F+kjit3
if klfo3fn = 1 then
galfo3 oscili 1,klfo3cps,25
elseif klfo3fn = 2 then 
galfo3 oscili 1,klfo3cps,30
elseif klfo3fn = 3 then 
galfo3 oscili 1,klfo3cps,31
elseif klfo3fn = 4 then 
galfo3 oscili 1,klfo3cps,32
elseif klfo3fn = 5 then 
galfo3 oscili 1,klfo3cps,33
elseif klfo3fn = 6 then 
galfo3 oscili 1,klfo3cps,34
elseif klfo3fn = 7 then 
galfo3 randh 1,klfo3cps
elseif klfo3fn = 8 then 
galfo3 randi 1,klfo3cps
endif
if klfo3r==0 goto Z3
galfo3=galfo3*klfo3on
goto NEXT3
Z3:
galfo3=0
NEXT3:
galfo3u=(galfo3*.5)+.5

klfo4F=klfo4r*klfo4x10*klfo4x100
kjit4 jitter klfo4j*klfo4F,4,10
klfo4cps=klfo4F+kjit4
if klfo4fn = 1 then
galfo4 oscili 1,klfo4cps,25
elseif klfo4fn = 2 then 
galfo4 oscili 1,klfo4cps,30
elseif klfo4fn = 3 then 
galfo4 oscili 1,klfo4cps,31
elseif klfo4fn = 4 then 
galfo4 oscili 1,klfo4cps,32
elseif klfo4fn = 5 then 
galfo4 oscili 1,klfo4cps,33
elseif klfo4fn = 6 then 
galfo4 oscili 1,klfo4cps,34
elseif klfo4fn = 7 then 
galfo4 randh 1,klfo4cps
elseif klfo4fn = 8 then 
galfo4 randi 1,klfo4cps
endif
if klfo4r==0 goto Z4
galfo4=galfo4*klfo4on
goto NEXT4
Z4:
galfo4=0
NEXT4:
galfo4u=(galfo4*.5)+.5

klfo5F=klfo5r*klfo5x10*klfo5x100
kjit5 jitter klfo5j*klfo5F,4,10
klfo5cps=klfo5F+kjit5
if klfo5fn = 1 then
galfo5 oscili 1,klfo5cps,25
elseif klfo5fn = 2 then 
galfo5 oscili 1,klfo5cps,30
elseif klfo5fn = 3 then 
galfo5 oscili 1,klfo5cps,31
elseif klfo5fn = 4 then 
galfo5 oscili 1,klfo5cps,32
elseif klfo5fn = 5 then 
galfo5 oscili 1,klfo5cps,33
elseif klfo5fn = 6 then 
galfo5 oscili 1,klfo5cps,34
elseif klfo5fn = 7 then 
galfo5 randh 1,klfo5cps
elseif klfo5fn = 8 then 
galfo5 randi 1,klfo5cps
endif
if klfo5r==0 goto Z5
galfo5=galfo5*klfo5on
goto NEXT5
Z5:
galfo5=0
NEXT5:
galfo5u=(galfo5*.5)+.5

klfo6F=klfo6r*klfo6x10*klfo6x100
kjit6 jitter klfo6j*klfo6F,4,10
klfo6cps=klfo6F+kjit6
if klfo6fn = 1 then
galfo6 oscili 1,klfo6cps,25
elseif klfo6fn = 2 then 
galfo6 oscili 1,klfo6cps,30
elseif klfo6fn = 3 then 
galfo6 oscili 1,klfo6cps,31
elseif klfo6fn = 4 then 
galfo6 oscili 1,klfo6cps,32
elseif klfo6fn = 5 then 
galfo6 oscili 1,klfo6cps,33
elseif klfo6fn = 6 then 
galfo6 oscili 1,klfo6cps,34
elseif klfo6fn = 7 then 
galfo6 randh 1,klfo6cps
elseif klfo6fn = 8 then 
galfo6 randi 1,klfo6cps
endif
if klfo6r==0 goto Z6
galfo6=galfo6*klfo6on
goto NEXT6
Z6:
galfo6=0
NEXT6:
galfo6u=(galfo6*.5)+.5

klfo7F=klfo7r*klfo7x10*klfo7x100
kjit7 jitter klfo7j*klfo7F,4,10
klfo7cps=klfo7F+kjit7
if klfo7fn = 1 then
galfo7 oscili 1,klfo7cps,25
elseif klfo7fn = 2 then 
galfo7 oscili 1,klfo7cps,30
elseif klfo7fn = 3 then 
galfo7 oscili 1,klfo7cps,31
elseif klfo7fn = 4 then 
galfo7 oscili 1,klfo7cps,32
elseif klfo7fn = 5 then 
galfo7 oscili 1,klfo7cps,33
elseif klfo7fn = 6 then 
galfo7 oscili 1,klfo7cps,34
elseif klfo7fn = 7 then 
galfo7 randh 1,klfo7cps
elseif klfo7fn = 8 then 
galfo7 randi 1,klfo7cps
endif
if klfo7r==0 goto Z7
galfo7=galfo7*klfo7on
goto NEXT7
Z7:
galfo7=0
NEXT7:
galfo7u=(galfo7*.5)+.5

klfo8F=klfo8r*klfo8x10*klfo8x100
kjit8 jitter klfo8j*klfo8F,4,10
klfo8cps=klfo8F+kjit8
if klfo8fn = 1 then
galfo8 oscili 1,klfo8cps,25
elseif klfo8fn = 2 then 
galfo8 oscili 1,klfo8cps,30
elseif klfo8fn = 3 then 
galfo8 oscili 1,klfo8cps,31
elseif klfo8fn = 4 then 
galfo8 oscili 1,klfo8cps,32
elseif klfo8fn = 5 then 
galfo8 oscili 1,klfo8cps,33
elseif klfo8fn = 6 then 
galfo8 oscili 1,klfo8cps,34
elseif klfo8fn = 7 then 
galfo8 randh 1,klfo8cps
elseif klfo8fn = 8 then 
galfo8 randi 1,klfo8cps
endif
if klfo8r==0 goto Z8
galfo8=galfo8*klfo8on
goto NEXT8
Z8:
galfo8=0
NEXT8:
galfo8u=(galfo8*.5)+.5

klfo9F=klfo9r*klfo9x10*klfo9x100
kjit9 jitter klfo9j*klfo9F,4,10
klfo9cps=klfo9F+kjit9
if klfo9fn = 1 then
galfo9 oscili 1,klfo9cps,25
elseif klfo9fn = 2 then 
galfo9 oscili 1,klfo9cps,30
elseif klfo9fn = 3 then 
galfo9 oscili 1,klfo9cps,31
elseif klfo9fn = 4 then 
galfo9 oscili 1,klfo9cps,32
elseif klfo9fn = 5 then 
galfo9 oscili 1,klfo9cps,33
elseif klfo9fn = 6 then 
galfo9 oscili 1,klfo9cps,34
elseif klfo9fn = 7 then 
galfo9 randh 1,klfo9cps
elseif klfo9fn = 8 then 
galfo9 randi 1,klfo9cps
endif
if klfo9r==0 goto Z9
galfo9=galfo9*klfo9on
goto NEXT9
Z9:
galfo9=0
NEXT9:
galfo9u=(galfo9*.5)+.5

klfo10F=klfo10r*klfo10x10*klfo10x100
kjit10 jitter klfo10j*klfo10F,4,10
klfo10cps=klfo10F+kjit10
if klfo10fn = 1 then
galfo10 oscili 1,klfo10cps,25
elseif klfo10fn = 2 then 
galfo10 oscili 1,klfo10cps,30
elseif klfo10fn = 3 then 
galfo10 oscili 1,klfo10cps,31
elseif klfo10fn = 4 then 
galfo10 oscili 1,klfo10cps,32
elseif klfo10fn = 5 then 
galfo10 oscili 1,klfo10cps,33
elseif klfo10fn = 6 then 
galfo10 oscili 1,klfo10cps,34
elseif klfo10fn = 7 then 
galfo10 randh 1,klfo10cps
elseif klfo10fn = 8 then 
galfo10 randi 1,klfo10cps
endif
if klfo10r==0 goto Z10
galfo10=galfo10*klfo10on
goto NEXT10
Z10:
galfo10=0
NEXT10:
galfo10u=(galfo10*.5)+.5
endin

instr	10
;pitch bend controller and pitch ribbon
kbend pchbend 0,1   ;default set at 1 semitones up and down, can modify for each oscillator (before converting MIDI to cps)
kmamp chnget "MAmp" ;master amplitude
kmjit chnget "Mjit" ;master oscillator jitter
kmjitrate chnget "Mjitrate" ;modify jitter speed
kribON chnget "ribon"
kribbon chnget "ribbon"
kribbon port kribbon,.025

if kribON==1 then
goto ribbon
elseif kribON==0 then
kribbon=0
endif
ribbon:

;initialize oscillator output for use as audio rate modulators and k-rate ones for FM
amod1 init 0
amod2 init 0
amod3 init 0
amod1u init 0
amod2u init 0
amod3u init 0
aosc1 init 0
aosc2 init 0
aosc3 init 0

;ADSR envelopes
i1a chnget "1a"
i1d chnget "1d"
i1s chnget "1s"
i1r chnget "1r"
i2a chnget "2a"
i2d chnget "2d"
i2s chnget "2s"
i2r chnget "2r"
i3a chnget "3a"
i3d chnget "3d"
i3s chnget "3s"
i3r chnget "3r"
i4a chnget "4a"
i4d chnget "4d"
i4s chnget "4s"
i4r chnget "4r"
i5a chnget "5a"
i5d chnget "5d"
i5s chnget "5s"
i5r chnget "5r"
i6a chnget "6a"
i6d chnget "6d"
i6s chnget "6s"
i6r chnget "6r"
i7a chnget "7a"
i7d chnget "7d"
i7s chnget "7s"
i7r chnget "7r"
i8a chnget "8a"
i8d chnget "8d"
i8s chnget "8s"
i8r chnget "8r"
i9a chnget "9a"
i9d chnget "9d"
i9s chnget "9s"
i9r chnget "9r"
i10a chnget "10a"
i10d chnget "10d"
i10s chnget "10s"
i10r chnget "10r"
kenv1 madsr i1a,i1d,i1s,i1r
kenv2 madsr i2a,i2d,i2s,i2r
kenv3 madsr i3a,i3d,i3s,i3r
kenv4 madsr i4a,i4d,i4s,i4r
kenv5 madsr i5a,i5d,i5s,i5r
kenv6 madsr i6a,i6d,i6s,i6r
kenv7 madsr i7a,i7d,i7s,i7r
kenv8 madsr i8a,i8d,i8s,i8r
kenv9 madsr i9a,i9d,i9s,i9r
kenv10 madsr i10a,i10d,i10s,i10r

;calculate vibrato
kvibdepth chnget "vibdepth"
kvibdepthmax chnget "vibdepthmax"
kvibcps chnget "vibcps"
kvibcpsmax chnget "vibcpsmax"
kvibrand chnget "vibrand"
kvcps randomi kvibcpsmax-(kvibcpsmax*kvibrand),kvibcpsmax+(kvibcpsmax*kvibrand),kvibcpsmax
kvamp randomi kvibdepthmax-(kvibdepthmax*kvibrand),kvibdepthmax+(kvibdepthmax*kvibrand),kvcps
avib oscili kvamp*kvibdepth,kvcps*kvibcps,25
if kvibcps=0 then
 avib=0
endif

kss chnget "ScaleStart" ;MIDI pitch number from which any selected scale is calculated
kscale chnget "MasterScale"
if kscale == 1 then 
ksc=1 ;12 tone scale
elseif kscale == 2 then
ksc=.25 ;1/8 tones
elseif kscale == 3 then
ksc=.33333 ;1/6 tones
elseif kscale == 4 then
ksc=.5 ;1/4 tones
elseif kscale == 5 then
ksc=.66666 ;1/3 tones
elseif kscale == 6 then
ksc=1.714 ;7 tone octave
elseif kscale == 7 then
ksc=1.5 ;8 tone
elseif kscale == 8 then
ksc=1.3333 ;9 tone
elseif kscale == 9 then
ksc=1.2 ;10 tone
elseif kscale == 10 then
ksc=1.09091 ;11 tone
elseif kscale == 11 then
ksc=1.03448 ;11.6 tone
elseif kscale == 12 then
ksc=1.01695 ;11.8 tone
elseif kscale == 13 then
ksc=.98361 ;12.2 tone
elseif kscale == 14 then
ksc=.96774 ;12.4 tone
elseif kscale == 15 then
ksc=.9231 ;13 tone
elseif kscale == 16 then
ksc=.85714 ;14 tone
elseif kscale == 17 then
ksc=.8 ;15 tone
endif

;Random Note Stream Generation
kRNGon chnget "RNGon"
kRNGcps chnget "RNGrate"
kRNGcpsrand chnget "RNGraterand"
kRNGdev chnget "RNGdev"
kmicro chnget "RNGmicro"
kgliss chnget "RNGgliss"

if kRNGon == 0 then
kRNGnote=0
goto INDEX
endif

krateA randh (kRNGcps*kRNGcpsrand),kRNGcps,5 ;seed > 1 = random seeded by the system clock
knoterate=kRNGcps+krateA   ;sets master rate
if kgliss == 1 then
kRNGnote randi kRNGdev,knoterate,-.15
else
kRNGnote randh kRNGdev,knoterate,10
endif

if kmicro == 1 then
kRNGnote=int(kRNGnote) ;12 tone scale
elseif kmicro == 2 then ;all possible frequencies
elseif kmicro == 3 then
kRNGnote=(int(kRNGnote*2)*.5) ;1/4 tones
elseif kmicro == 4 then
kRNGnote=(int(kRNGnote*4)*.25) ;1/8 tones
elseif kmicro == 5 then
kRNGnote=int(kRNGnote)*2 ;Whole tone
elseif kmicro == 6 then
kRNGnote=int(kRNGnote)*3 ;minor 3rds
elseif kmicro == 7 then
kRNGnote=int(kRNGnote)*4 ;major 3rds
elseif kmicro == 8 then
kRNGnote=int(kRNGnote)*5 ;4ths
elseif kmicro == 9 then
kRNGnote=int(kRNGnote)*6 ;tritones
elseif kmicro == 10 then
kRNGnote=int(kRNGnote)*7 ;5ths
elseif kmicro == 11 then
kRNGnote=int(kRNGnote)*1.2 ;10 tone scale
elseif kmicro == 12 then
kRNGnote=int(kRNGnote)*.923 ;13 tone scale
elseif kmicro == 13 then
kRNGnote=int(kRNGnote)*.8 ;15 tone scale
elseif kmicro == 14 then
kRNGnote=int(kRNGnote)*1.715 ;7 tone scale
elseif kmicro == 15 then
kRNGnote=int(kRNGnote)*1.5 ;8 tone scale
endif

INDEX:
;get axis channel data for use in all three oscillators
ktc1 chnget "tc1"
ktc2 chnget "tc2"
ktc3 chnget "tc3"
ktc4 chnget "tc4"
ktc5 chnget "tc5"
ktf1 chnget "tf1"
ktf2 chnget "tf2"
ktf3 chnget "tf3"
ktf4 chnget "tf4"
ktf5 chnget "tf5"
kiw1 chnget "iw1"
kiw2 chnget "iw2"
kiw3 chnget "iw3"
kiw4 chnget "iw4"
kiw5 chnget "iw5"
kip1 chnget "ip1"
kip2 chnget "ip2"
kip3 chnget "ip3"
kip4 chnget "ip4"
kip5 chnget "ip5"
kioff1 chnget "ioff1"
kioff2 chnget "ioff2"
kioff3 chnget "ioff3"
kioff4 chnget "ioff4"
kioff5 chnget "ioff5"
kiamp1 chnget "iamp1"
kiamp2 chnget "iamp2"
kiamp3 chnget "iamp3"
kiamp4 chnget "iamp4"
kiamp5 chnget "iamp5"

;set index phase values
if changed(kip1)==1 then
 if kip1=1 then
 kp1=0
 elseif kip1=2 then
 kp1=.25
 elseif kip1=3 then
 kp1=.5
 elseif kip1=4 then
 kp1=.75
 endif
endif
if changed(kip2)==1 then
 if kip2=1 then
 kp2=0
 elseif kip2=2 then
 kp2=.25
 elseif kip2=3 then
 kp2=.5
 elseif kip2=4 then
 kp2=.75
 endif
endif 
if changed(kip3)==1 then
 if kip3=1 then
 kp3=0
 elseif kip3=2 then
 kp3=.25
 elseif kip3=3 then
 kp3=.5
 elseif kip3=4 then
 kp3=.75
 endif
endif
if changed(kip4)==1 then
 if kip4=1 then
 kp4=0
 elseif kip4=2 then
 kp4=.25
 elseif kip4=3 then
 kp4=.5
 elseif kip4=4 then
 kp4=.75
 endif
endif
if changed(kip5)==1 then
 if kip5=1 then
 kp5=0
 elseif kip5=2 then
 kp5=.25
 elseif kip5=3 then
 kp5=.5
 elseif kip5=4 then
 kp5=.75
 endif
endif

;assign index waveforms ;;;(IF I ADD A RANDOM FUNCTION, THIS MUST BE DONE WITHIN EACH OF THE THREE OSCILLATORS)
if changed(kiw1)==1 then
 if kiw1=1 then
 kw1=101
 elseif kiw1=2 then
 kw1=106
 elseif kiw1=3 then
 kw1=105
 elseif kiw1=4 then
 kw1=103
 elseif kiw1=5 then
 kw1=102
 elseif kiw1=6 then
 kw1=104
 endif
endif
if changed(kiw2)==1 then
 if kiw2=1 then
 kw2=101
 elseif kiw2=2 then
 kw2=106
 elseif kiw2=3 then
 kw2=105
 elseif kiw2=4 then
 kw2=103
 elseif kiw2=5 then
 kw2=102
 elseif kiw2=6 then
 kw2=104
 endif
endif
if changed(kiw3)==1 then
 if kiw3=1 then
 kw3=101
 elseif kiw3=2 then
 kw3=106
 elseif kiw3=3 then
 kw3=105
 elseif kiw3=4 then
 kw3=103
 elseif kiw3=5 then
 kw3=102
 elseif kiw3=6 then
 kw3=104
 endif
endif
if changed(kiw4)==1 then
 if kiw4=1 then
 kw4=101
 elseif kiw4=2 then
 kw4=106
 elseif kiw4=3 then
 kw4=105
 elseif kiw4=4 then
 kw4=103
 elseif kiw4=5 then
 kw4=102
 elseif kiw4=6 then
 kw4=104
 endif
endif
if changed(kiw5)==1 then
 if kiw5=1 then
 kw5=101
 elseif kiw5=2 then
 kw5=106
 elseif kiw5=3 then
 kw5=105
 elseif kiw5=4 then
 kw5=103
 elseif kiw5=5 then
 kw5=102
 elseif kiw5=6 then
 kw5=104
 endif
endif

;OSCILLATOR 1 DEFINED IN THIS LARGE SECTION
OSC1:
;;get GUI data
kon1 chnget "osc1"
kon1 port kon1,.05
kamp1 chnget "amp1"
kpan1 chnget "pan1"
kax11 chnget "ax11" ;on/off
kax12 chnget "ax12"
kax13 chnget "ax13"
kax14 chnget "ax14"
kax15 chnget "ax15"
kesel1 chnget "env1"
kotc1 chnget "otc1"
kotf1 chnget "otf1"
kup1 chnget "up1"
kdown1 chnget "down1"
kfm1 chnget "fm1"
kind1 chnget "ind1"
kfmenv1 chnget "fmenv1"
kam1 chnget "am1"
kaind1 chnget "aind1"
kamenv1 chnget "amenv1"
krm1 chnget "rm1"

;if kon1=0 goto OSC2

;calculate bend
if kbend >= 0 then 
kbend1=kbend*kup1
else
kbend1=kbend*kdown1
endif
kbend1 port kbend1,.025

;generate k-rate FM pitch modulator envelopes
if kfmenv1 = 1 then
kfmodenv1=kenv1
elseif kfmenv1 = 2 then
kfmodenv1=kenv2
elseif kfmenv1 = 3 then
kfmodenv1=kenv3
elseif kfmenv1 = 4 then
kfmodenv1=kenv4
elseif kfmenv1 = 5 then
kfmodenv1=kenv5
elseif kfmenv1 = 6 then
kfmodenv1=kenv6
elseif kfmenv1 = 7 then
kfmodenv1=kenv7
elseif kfmenv1 = 8 then
kfmodenv1=kenv8
elseif kfmenv1 = 9 then
kfmodenv1=kenv9
elseif kfmenv1 = 10 then
kfmodenv1=kenv10
endif

if kfm1 = 1 then
afmod1=0
elseif kfm1 = 2 then
afmod1 = aosc2*kind1*kfmodenv1
elseif kfm1 = 3 then
afmod1 = aosc3*kind1*kfmodenv1
elseif kfm1 = 4 then
afmod1 = galfo1*kind1*kfmodenv1
elseif kfm1 = 5 then
afmod1 = galfo2*kind1*kfmodenv1
elseif kfm1 = 6 then
afmod1 = galfo3*kind1*kfmodenv1
elseif kfm1 = 7 then
afmod1 = galfo4*kind1*kfmodenv1
elseif kfm1 = 8 then
afmod1 = galfo5*kind1*kfmodenv1
elseif kfm1 = 9 then
afmod1 = galfo6*kind1*kfmodenv1
elseif kfm1 = 10 then
afmod1 = galfo7*kind1*kfmodenv1
elseif kfm1 = 11 then
afmod1 = galfo8*kind1*kfmodenv1
elseif kfm1 = 12 then
afmod1 = galfo9*kind1*kfmodenv1
elseif kfm1 = 13 then
afmod1 = galfo10*kind1*kfmodenv1
elseif kfm1 = 14 then
afmod1 = galiveAM*kind1*kfmodenv1
endif

;calculate cps, index, and actual audio for each axis
if kax11==0 goto AXIS11B
kcps11=cpsmidinn(kss+((p4-kss)*ksc)+kbend1+kotf1+kotc1+kRNGnote+kribbon+ktc1+ktf1) ;calculates cps from MIDI values
kjit11 jitter kcps11*.004*kmjit,2*kmjitrate,7*kmjitrate ;add jitter
acps11=kjit11+(a(kcps11)*exp((avib+afmod1)*.083333)) ;FM and vibrato
a11ind1 phasor acps11 ;establishes independent phasor for each indexes
a11i tablekt a11ind1+kp1,kw1,1,0,1 ;uses pre-calculated waveforms as indexes
a11 table (a11i*.5*kiamp1)+kioff1,96,1,0,1 ;generate actual audio for terrain axis using index, .5 normalizes index to scan entire table when index amp is set to 1
goto AXIS12
AXIS11B:
a11=1

AXIS12:
if kax12==0 goto AXIS12B
kcps12=cpsmidinn(kss+((p4-kss)*ksc)+kbend1+kotf1+kotc1+kRNGnote+kribbon+ktc2+ktf2)
kjit12 jitter kcps12*.004*kmjit,2*kmjitrate,7*kmjitrate ;add jitter
acps12=kjit12+(a(kcps12)*exp((avib+afmod1)*.083333)) ;FM and vibrato
a12ind1 phasor acps12
a12i tablekt a12ind1+kp2,kw2,1,0,1
a12 table (a12i*.5*kiamp2)+kioff2,97,1,0,1 
goto AXIS13
AXIS12B:
a12=1

AXIS13:
if kax13==0 goto AXIS13B
kcps13=cpsmidinn(kss+((p4-kss)*ksc)+kbend1+kotf1+kotc1+kRNGnote+kribbon+ktc3+ktf3)
kjit13 jitter kcps13*.004*kmjit,2*kmjitrate,7*kmjitrate ;add jitter
acps13=kjit13+(a(kcps13)*exp((avib+afmod1)*.083333)) ;FM and vibrato
a13ind1 phasor acps13
a13i tablekt a13ind1+kp3,kw3,1,0,1
a13 table (a13i*.5*kiamp3)+kioff3,98,1,0,1 
goto AXIS14
AXIS13B:
a13=1

AXIS14:
if kax14==0 goto AXIS14B
kcps14=cpsmidinn(kss+((p4-kss)*ksc)+kbend1+kotf1+kotc1+kRNGnote+kribbon+ktc4+ktf4)
kjit14 jitter kcps14*.004*kmjit,2*kmjitrate,7*kmjitrate ;add jitter
acps14=kjit14+(a(kcps14)*exp((avib+afmod1)*.083333)) ;FM and vibrato
a14ind1 phasor acps14
a14i tablekt a14ind1+kp4,kw4,1,0,1
a14 table (a14i*.5*kiamp4)+kioff4,99,1,0,1
goto AXIS15
AXIS14B:
a14=1

AXIS15:
if kax15==0 goto AXIS15B
kcps15=cpsmidinn(kss+((p4-kss)*ksc)+kbend1+kotf1+kotc1+kRNGnote+kribbon+ktc5+ktf5)
kjit15 jitter kcps15*.004*kmjit,2*kmjitrate,7*kmjitrate ;add jitter
acps15=kjit15+(a(kcps15)*exp((avib+afmod1)*.083333)) ;FM and vibrato
a15ind1 phasor acps15
a15i tablekt a15ind1+kp5,kw5,1,0,1
a15 table (a15i*.5*kiamp5)+kioff5,100,1,0,1 
goto TERRAIN1
AXIS15B:
a15=1

TERRAIN1:
;perform the terrain calculation by multiplying each axis
aosc1=a11*a12*a13*a14*a15 
DWNSMP1:
amod1u=(aosc1*.5)+.5

ENV1:
if kesel1 = 1 then  ;ADSR selection
ke1=kenv1
elseif kesel1 = 2 then
ke1=kenv2
elseif kesel1 = 3 then
ke1=kenv3
elseif kesel1 = 4 then
ke1=kenv4
elseif kesel1 = 5 then
ke1=kenv5
elseif kesel1 = 6 then
ke1=kenv6
elseif kesel1 = 7 then
ke1=kenv7
elseif kesel1 = 8 then
ke1=kenv8
elseif kesel1 = 9 then
ke1=kenv9
elseif kesel1 = 10 then
ke1=kenv10
endif

a1 gain aosc1,ke1*kamp1*p5*kon1

;AM env and source selection
if kamenv1 = 1 then
kamodenv1=kenv1
elseif kamenv1 = 2 then
kamodenv1=kenv2
elseif kamenv1 = 3 then
kamodenv1=kenv3
elseif kamenv1 = 4 then
kamodenv1=kenv4
elseif kamenv1 = 5 then
kamodenv1=kenv5
elseif kamenv1 = 6 then
kamodenv1=kenv6
elseif kamenv1 = 7 then
kamodenv1=kenv7
elseif kamenv1 = 8 then
kamodenv1=kenv8
elseif kamenv1 = 9 then
kamodenv1=kenv9
elseif kamenv1 = 10 then
kamodenv1=kenv10
endif

if kam1 = 1 then
a1=a1
elseif kam1 = 2 then
a1=a1*(1+(amod2u*kaind1*kamodenv1))
elseif kam1 = 3 then
a1=a1*(1+(amod3u*kaind1*kamodenv1))
elseif kam1 = 4 then
a1=a1*(1+(galfo1u*kaind1*kamodenv1))
elseif kam1 = 5 then
a1=a1*(1+(galfo2u*kaind1*kamodenv1))
elseif kam1 = 6 then
a1=a1*(1+(galfo3u*kaind1*kamodenv1))
elseif kam1 = 7 then
a1=a1*(1+(galfo4u*kaind1*kamodenv1))
elseif kam1 = 8 then
a1=a1*(1+(galfo5u*kaind1*kamodenv1))
elseif kam1 = 9 then
a1=a1*(1+(galfo6u*kaind1*kamodenv1))
elseif kam1 = 10 then
a1=a1*(1+(galfo7u*kaind1*kamodenv1))
elseif kam1 = 11 then
a1=a1*(1+(galfo8u*kaind1*kamodenv1))
elseif kam1 = 12 then
a1=a1*(1+(galfo9u*kaind1*kamodenv1))
elseif kam1 = 13 then
a1=a1*(1+(galfo10u*kaind1*kamodenv1))
elseif kam1 = 14 then
a1=a1*(1+(galiveAM*kaind1*kamodenv1))
endif

if krm1 = 1 then
goto NO_RM1
elseif krm1 = 2 then
a1=a1*aosc2
elseif krm1 = 3 then
a1=a1*aosc3
elseif krm1 = 4 then
a1=a1*galfo1
elseif krm1 = 5 then
a1=a1*galfo2
elseif krm1 = 6 then
a1=a1*galfo3
elseif krm1 = 7 then
a1=a1*galfo4
elseif krm1 = 8 then
a1=a1*galfo5
elseif krm1 = 9 then
a1=a1*galfo6
elseif krm1 = 10 then
a1=a1*galfo7
elseif krm1 = 11 then
a1=a1*galfo8
elseif krm1 = 12 then
a1=a1*galfo9
elseif krm1 = 13 then
a1=a1*galfo10
elseif krm1 = 14 then
a1=a1*galiveRM
endif

NO_RM1:
a1L=a1*(1-kpan1)
a1R=a1*kpan1

OSC2:
;OSCILLATOR 2 DEFINED IN THIS LARGE SECTION
;;get GUI data
kon2 chnget "osc2"
kon2 port kon2,.05
kamp2 chnget "amp2"
kpan2 chnget "pan2"
kax21 chnget "ax21"
kax22 chnget "ax22"
kax23 chnget "ax23"
kax24 chnget "ax24"
kax25 chnget "ax25"
kesel2 chnget "env2"
kotc2 chnget "otc2"
kotf2 chnget "otf2"
kup2 chnget "up2"
kdown2 chnget "down2"
kfm2 chnget "fm2"
kind2 chnget "ind2"
kfmenv2 chnget "fmenv2"
kam2 chnget "am2"
kaind2 chnget "aind2"
kamenv2 chnget "amenv2"
krm2 chnget "rm2"

;if kon2=0 goto OSC3

;calculate bend
if kbend >= 0 then 
kbend2=kbend*kup2
else
kbend2=kbend*kdown2
endif
kbend2 port kbend2,.025

;generate k-rate FM pitch modulators
if kfmenv2 = 1 then
kfmodenv2=kenv1
elseif kfmenv2 = 2 then
kfmodenv2=kenv2
elseif kfmenv2 = 3 then
kfmodenv2=kenv3
elseif kfmenv2 = 4 then
kfmodenv2=kenv4
elseif kfmenv2 = 5 then
kfmodenv2=kenv5
elseif kfmenv2 = 6 then
kfmodenv2=kenv6
elseif kfmenv2 = 7 then
kfmodenv2=kenv7
elseif kfmenv2 = 8 then
kfmodenv2=kenv8
elseif kfmenv2 = 9 then
kfmodenv2=kenv9
elseif kfmenv2 = 10 then
kfmodenv2=kenv10
endif

if kfm2 = 1 then
afmod2=0
elseif kfm2 = 2 then
afmod2 = aosc1*kind2*kfmodenv2
elseif kfm2 = 3 then
afmod2 = aosc3*kind2*kfmodenv2
elseif kfm2 = 4 then
afmod2 = galfo1*kind2*kfmodenv2
elseif kfm2 = 5 then
afmod2 = galfo2*kind2*kfmodenv2
elseif kfm2 = 6 then
afmod2 = galfo3*kind2*kfmodenv2
elseif kfm2 = 7 then
afmod2 = galfo4*kind2*kfmodenv2
elseif kfm2 = 8 then
afmod2 = galfo5*kind2*kfmodenv2
elseif kfm2 = 9 then
afmod2 = galfo6*kind2*kfmodenv2
elseif kfm2 = 10 then
afmod2 = galfo7*kind2*kfmodenv2
elseif kfm2 = 11 then
afmod2 = galfo8*kind2*kfmodenv2
elseif kfm2 = 12 then
afmod2 = galfo9*kind2*kfmodenv2
elseif kfm2 = 13 then
afmod2 = galfo10*kind2*kfmodenv2
elseif kfm2 = 14 then
afmod2 = galiveAM*kind2*kfmodenv2
endif

;calculate cps, index, and actual audio for each axis
if kax21==0 goto AXIS21B
kcps21=cpsmidinn(kss+((p4-kss)*ksc)+kbend2+kotf2+kotc2+kRNGnote+kribbon+ktc1+ktf1) ;calculates cps from MIDI values
kjit21 jitter kcps21*.004*kmjit,2*kmjitrate,7*kmjitrate ;add jitter
acps21=kjit21+(a(kcps21)*exp((avib+afmod2)*.083333)) ;FM and vibrato
a21ind1 phasor acps21 ;establishes independent phasor for each indexes
a21i tablekt a21ind1+kp1,kw1,1,0,1 ;uses pre-calculated waveforms as indexes
a21 table (a21i*.5*kiamp1)+kioff1,96,1,0,1 ;generate actual audio for terrain axis using index
goto AXIS22
AXIS21B:
a21=1

AXIS22:
if kax22==0 goto AXIS22B
kcps22=cpsmidinn(kss+((p4-kss)*ksc)+kbend2+kotf2+kotc2+kRNGnote+kribbon+ktc2+ktf2)
kjit22 jitter kcps22*.004*kmjit,2*kmjitrate,7*kmjitrate ;add jitter
acps22=kjit22+(a(kcps22)*exp((avib+afmod2)*.083333)) ;FM and vibrato
a22ind1 phasor acps22
a22i tablekt a22ind1+kp2,kw2,1,0,1
a22 table (a22i*.5*kiamp2)+kioff2,97,1,0,1 
goto AXIS23
AXIS22B:
a22=1

AXIS23:
if kax23==0 goto AXIS23B
kcps23=cpsmidinn(kss+((p4-kss)*ksc)+kbend2+kotf2+kotc2+kRNGnote+kribbon+ktc3+ktf3)
kjit23 jitter kcps23*.004*kmjit,2*kmjitrate,7*kmjitrate ;add jitter
acps23=kjit23+(a(kcps23)*exp((avib+afmod2)*.083333)) ;FM and vibrato
a23ind1 phasor acps23
a23i tablekt a23ind1+kp3,kw3,1,0,1
a23 table (a23i*.5*kiamp3)+kioff3,98,1,0,1 
goto AXIS24
AXIS23B:
a23=1

AXIS24:
if kax24==0 goto AXIS24B
kcps24=cpsmidinn(kss+((p4-kss)*ksc)+kbend2+kotf2+kotc2+kRNGnote+kribbon+ktc4+ktf4)
kjit24 jitter kcps24*.004*kmjit,2*kmjitrate,7*kmjitrate ;add jitter
acps24=kjit24+(a(kcps24)*exp((avib+afmod2)*.083333)) ;FM and vibrato
a24ind1 phasor acps24
a24i tablekt a24ind1+kp4,kw4,1,0,1
a24 table (a24i*.5*kiamp4)+kioff4,99,1,0,1
goto AXIS25
AXIS24B:
a24=1

AXIS25:
if kax25==0 goto AXIS25B
kcps25=cpsmidinn(kss+((p4-kss)*ksc)+kbend2+kotf2+kotc2+kRNGnote+kribbon+ktc5+ktf5)
kjit25 jitter kcps25*.004*kmjit,2*kmjitrate,7*kmjitrate ;add jitter
acps25=kjit25+(a(kcps25)*exp((avib+afmod2)*.083333)) ;FM and vibrato
a25ind1 phasor acps25
a25i tablekt a25ind1+kp5,kw5,1,0,1
a25 table (a25i*.5*kiamp5)+kioff5,100,1,0,1 
goto TERRAIN2
AXIS25B:
a25=1

TERRAIN2:
;perform the terrain calculation by multiplying each axis
aosc2=a21*a22*a23*a24*a25 
DWNSMP2:
amod2u=(aosc2*.5)+.5

if kesel2 = 1 then  ;ADSR selection
ke2=kenv1
elseif kesel2 = 2 then
ke2=kenv2
elseif kesel2 = 3 then
ke2=kenv3
elseif kesel2 = 4 then
ke2=kenv4
elseif kesel2 = 5 then
ke2=kenv5
elseif kesel2 = 6 then
ke2=kenv6
elseif kesel2 = 7 then
ke2=kenv7
elseif kesel2 = 8 then
ke2=kenv8
elseif kesel2 = 9 then
ke2=kenv9
elseif kesel2 = 10 then
ke2=kenv10
endif

a2 gain aosc2,ke2*kamp2*p5*kon2

;AM env and source selection
if kamenv2 = 1 then
kamodenv2=kenv1
elseif kamenv2 = 2 then
kamodenv2=kenv2
elseif kamenv2 = 3 then
kamodenv2=kenv3
elseif kamenv2 = 4 then
kamodenv2=kenv4
elseif kamenv2 = 5 then
kamodenv2=kenv5
elseif kamenv2 = 6 then
kamodenv2=kenv6
elseif kamenv2 = 7 then
kamodenv2=kenv7
elseif kamenv2 = 8 then
kamodenv2=kenv8
elseif kamenv2 = 9 then
kamodenv2=kenv9
elseif kamenv2 = 10 then
kamodenv2=kenv10
endif

if kam2 = 1 then
a2=a2
elseif kam2 = 2 then
a2=a2*(1+(amod1u*kaind2*kamodenv2))
elseif kam2 = 3 then
a2=a2*(1+(amod3u*kaind2*kamodenv2))
elseif kam2 = 4 then
a2=a2*(1+(galfo1u*kaind2*kamodenv2))
elseif kam2 = 5 then
a2=a2*(1+(galfo2u*kaind2*kamodenv2))
elseif kam2 = 6 then
a2=a2*(1+(galfo3u*kaind2*kamodenv2))
elseif kam2 = 7 then
a2=a2*(1+(galfo4u*kaind2*kamodenv2))
elseif kam2 = 8 then
a2=a2*(1+(galfo5u*kaind2*kamodenv2))
elseif kam2 = 9 then
a2=a2*(1+(galfo6u*kaind2*kamodenv2))
elseif kam2 = 10 then
a2=a2*(1+(galfo7u*kaind2*kamodenv2))
elseif kam2 = 11 then
a2=a2*(1+(galfo8u*kaind2*kamodenv2))
elseif kam2 = 12 then
a2=a2*(1+(galfo9u*kaind2*kamodenv2))
elseif kam2 = 13 then
a2=a2*(1+(galfo10u*kaind2*kamodenv2))
elseif kam2 = 14 then
a2=a2*(1+(galiveAM*kaind2*kamodenv2))
endif

;RM source selection
if krm2 = 1 then
goto NO_RM2
elseif krm2 = 2 then
a2=a2*aosc1
elseif krm2 = 3 then
a2=a2*aosc3
elseif krm2 = 4 then
a2=a2*galfo1
elseif krm2 = 5 then
a2=a2*galfo2
elseif krm2 = 6 then
a2=a2*galfo3
elseif krm2 = 7 then
a2=a2*galfo4
elseif krm2 = 8 then
a2=a2*galfo5
elseif krm2 = 9 then
a2=a2*galfo6
elseif krm2 = 10 then
a2=a2*galfo7
elseif krm2 = 11 then
a2=a2*galfo8
elseif krm2 = 12 then
a2=a2*galfo9
elseif krm2 = 13 then
a2=a2*galfo10
elseif krm2 = 14 then
a2=a2*galiveRM
endif

NO_RM2:
a2L=a2*(1-kpan2)
a2R=a2*kpan2

OSC3:
;OSCILLATOR 3 DEFINED IN THIS LARGE SECTION
;;get GUI data
kon3 chnget "osc3"
kon3 port kon3,.05
kamp3 chnget "amp3"
kpan3 chnget "pan3"
kax31 chnget "ax31"
kax32 chnget "ax32"
kax33 chnget "ax33"
kax34 chnget "ax34"
kax35 chnget "ax35"
kesel3 chnget "env3"
kotc3 chnget "otc3"
kotf3 chnget "otf3"
kup3 chnget "up3"
kdown3 chnget "down3"
kfm3 chnget "fm3"
kind3 chnget "ind3"
kfmenv3 chnget "fmenv3"
kam3 chnget "am3"
kaind3 chnget "aind3"
kamenv3 chnget "amenv3"
krm3 chnget "rm3"

;if kon3==0 goto SUM

;calculate bend
if kbend >= 0 then 
kbend3=kbend*kup3
else
kbend3=kbend*kdown3
endif
kbend3 port kbend3,.025

;generate k-rate FM pitch modulators
if kfmenv3 = 1 then
kfmodenv3=kenv1
elseif kfmenv3 = 2 then
kfmodenv3=kenv2
elseif kfmenv3 = 3 then
kfmodenv3=kenv3
elseif kfmenv3 = 4 then
kfmodenv3=kenv4
elseif kfmenv3 = 5 then
kfmodenv3=kenv5
elseif kfmenv3 = 6 then
kfmodenv3=kenv6
elseif kfmenv3 = 7 then
kfmodenv3=kenv7
elseif kfmenv3 = 8 then
kfmodenv3=kenv8
elseif kfmenv3 = 9 then
kfmodenv3=kenv9
elseif kfmenv3 = 10 then
kfmodenv3=kenv10
endif

if kfm3 = 1 then
afmod3=0
elseif kfm3 = 2 then
afmod3 = aosc1*kind3*kfmodenv3
elseif kfm3 = 3 then
afmod3 = aosc2*kind3*kfmodenv3
elseif kfm3 = 4 then
afmod3 = galfo1*kind3*kfmodenv3
elseif kfm3 = 5 then
afmod3 = galfo2*kind3*kfmodenv3
elseif kfm3 = 6 then
afmod3 = galfo3*kind3*kfmodenv3
elseif kfm3 = 7 then
afmod3 = galfo4*kind3*kfmodenv3
elseif kfm3 = 8 then
afmod3 = galfo5*kind3*kfmodenv3
elseif kfm3 = 9 then
afmod3 = galfo6*kind3*kfmodenv3
elseif kfm3 = 10 then
afmod3 = galfo7*kind3*kfmodenv3
elseif kfm3 = 11 then
afmod3 = galfo8*kind3*kfmodenv3
elseif kfm3 = 12 then
afmod3 = galfo9*kind3*kfmodenv3
elseif kfm3 = 13 then
afmod3 = galfo10*kind3*kfmodenv3
elseif kfm3 = 14 then
afmod3 = galiveAM*kind3*kfmodenv3
endif

;calculate cps, index, and actual audio for each axis
if kax31==0 goto AXIS31B
kcps31=cpsmidinn(kss+((p4-kss)*ksc)+kbend3+kotf3+kotc3+kRNGnote+kribbon+ktc1+ktf1) ;calculates cps from MIDI values
kjit31 jitter kcps31*.004*kmjit,2*kmjitrate,7*kmjitrate ;add jitter
acps31=kjit31+(a(kcps31)*exp((avib+afmod3)*.083333)) ;FM and vibrato
a31ind1 phasor acps31 ;establishes independent phasor for each indexes
a31i tablekt a31ind1+kp1,kw1,1,0,1 ;uses pre-calculated waveforms as indexes
a31 table (a31i*.5*kiamp1)+kioff1,96,1,0,1 ;generate actual audio for terrain axis using index
goto AXIS32
AXIS31B:
a31=1

AXIS32:
if kax32==0 goto AXIS32B
kcps32=cpsmidinn(kss+((p4-kss)*ksc)+kbend3+kotf3+kotc3+kRNGnote+kribbon+ktc2+ktf2)
kjit32 jitter kcps32*.004*kmjit,2*kmjitrate,7*kmjitrate ;add jitter
acps32=kjit32+(a(kcps32)*exp((avib+afmod3)*.083333)) ;FM and vibrato
a32ind1 phasor acps32
a32i tablekt a32ind1+kp2,kw2,1,0,1
a32 table (a32i*.5*kiamp2)+kioff2,97,1,0,1 
goto AXIS33
AXIS32B:
a32=1

AXIS33:
if kax33==0 goto AXIS33B
kcps33=cpsmidinn(kss+((p4-kss)*ksc)+kbend3+kotf3+kotc3+kRNGnote+kribbon+ktc3+ktf3)
kjit33 jitter kcps33*.004*kmjit,2*kmjitrate,7*kmjitrate ;add jitter
acps33=kjit33+(a(kcps33)*exp((avib+afmod3)*.083333)) ;FM and vibrato
a33ind1 phasor acps33
a33i tablekt a33ind1+kp3,kw3,1,0,1
a33 table (a33i*.5*kiamp3)+kioff3,98,1,0,1 
goto AXIS34
AXIS33B:
a33=1

AXIS34:
if kax34==0 goto AXIS34B
kcps34=cpsmidinn(kss+((p4-kss)*ksc)+kbend3+kotf3+kotc3+kRNGnote+kribbon+ktc4+ktf4)
kjit34 jitter kcps34*.004*kmjit,2*kmjitrate,7*kmjitrate ;add jitter
acps34=kjit34+(a(kcps34)*exp((avib+afmod3)*.083333)) ;FM and vibrato
a34ind1 phasor acps34
a34i tablekt a34ind1+kp4,kw4,1,0,1
a34 table (a34i*.5*kiamp4)+kioff4,99,1,0,1
goto AXIS35
AXIS34B:
a34=1

AXIS35:
if kax35==0 goto AXIS35B
kcps35=cpsmidinn(kss+((p4-kss)*ksc)+kbend3+kotf3+kotc3+kRNGnote+kribbon+ktc5+ktf5)
kjit35 jitter kcps35*.004*kmjit,2*kmjitrate,7*kmjitrate ;add jitter
acps35=kjit35+(a(kcps35)*exp((avib+afmod3)*.083333)) ;FM and vibrato
a35ind1 phasor acps35
a35i tablekt a35ind1+kp5,kw5,1,0,1
a35 table (a35i*.5*kiamp5)+kioff5,100,1,0,1 
goto TERRAIN3
AXIS35B:
a35=1

TERRAIN3:
;perform the terrain calculation by multiplying each axis
aosc3=a31*a32*a33*a34*a35 
DWNSMP3:
amod3u=(aosc3*.5)+.5

if kesel3 = 1 then  ;ADSR selection
ke3=kenv1
elseif kesel3 = 2 then
ke3=kenv2
elseif kesel3 = 3 then
ke3=kenv3
elseif kesel3 = 4 then
ke3=kenv4
elseif kesel3 = 5 then
ke3=kenv5
elseif kesel3 = 6 then
ke3=kenv6
elseif kesel3 = 7 then
ke3=kenv7
elseif kesel3 = 8 then
ke3=kenv8
elseif kesel3 = 9 then
ke3=kenv9
elseif kesel3 = 10 then
ke3=kenv10
endif

a3 gain aosc3,ke3*kamp3*p5*kon3

;AM env and source selection
if kamenv3 = 1 then
kamodenv3=kenv1
elseif kamenv3 = 2 then
kamodenv3=kenv2
elseif kamenv3 = 3 then
kamodenv3=kenv3
elseif kamenv3 = 4 then
kamodenv3=kenv4
elseif kamenv3 = 5 then
kamodenv3=kenv5
elseif kamenv3 = 6 then
kamodenv3=kenv6
elseif kamenv3 = 7 then
kamodenv3=kenv7
elseif kamenv3 = 8 then
kamodenv3=kenv8
elseif kamenv3 = 9 then
kamodenv3=kenv9
elseif kamenv3 = 10 then
kamodenv3=kenv10
endif

if kam3 = 1 then
a3=a3
elseif kam3 = 2 then
a3=a3*(1+(amod1u*kaind3*kamodenv3))
elseif kam3 = 3 then
a3=a3*(1+(amod2u*kaind3*kamodenv3))
elseif kam3 = 4 then
a3=a3*(1+(galfo1u*kaind3*kamodenv3))
elseif kam3 = 5 then
a3=a3*(1+(galfo2u*kaind3*kamodenv3))
elseif kam3 = 6 then
a3=a3*(1+(galfo3u*kaind3*kamodenv3))
elseif kam3 = 7 then
a3=a3*(1+(galfo4u*kaind3*kamodenv3))
elseif kam3 = 8 then
a3=a3*(1+(galfo5u*kaind3*kamodenv3))
elseif kam3 = 9 then
a3=a3*(1+(galfo6u*kaind3*kamodenv3))
elseif kam3 = 10 then
a3=a3*(1+(galfo7u*kaind3*kamodenv3))
elseif kam3 = 11 then
a3=a3*(1+(galfo8u*kaind3*kamodenv3))
elseif kam3 = 12 then
a3=a3*(1+(galfo9u*kaind3*kamodenv3))
elseif kam3 = 13 then
a3=a3*(1+(galfo10u*kaind3*kamodenv3))
elseif kam3 = 14 then
a3=a3*(1+(galiveAM*kaind3*kamodenv3))
endif

;RM source selection
if krm3 = 1 then
goto NO_RM3
elseif krm3 = 2 then
a3=a3*aosc1
elseif krm3 = 3 then
a3=a3*aosc2
elseif krm3 = 4 then
a3=a3*galfo1
elseif krm3 = 5 then
a3=a3*galfo2
elseif krm3 = 6 then
a3=a3*galfo3
elseif krm3 = 7 then
a3=a3*galfo4
elseif krm3 = 8 then
a3=a3*galfo5
elseif krm3 = 9 then
a3=a3*galfo6
elseif krm3 = 10 then
a3=a3*galfo7
elseif krm3 = 11 then
a3=a3*galfo8
elseif krm3 = 12 then
a3=a3*galfo9
elseif krm3 = 13 then
a3=a3*galfo10
elseif krm3 = 14 then
a3=a3*galiveRM
endif

NO_RM3:
a3L=a3*(1-kpan3)
a3R=a3*kpan3

SUM:       ;sum all oscillators
aL=a1L+a2L+a3L ;+a4L+a5L+a6L+a7L+a8L+a9L+a10L
aR=a1R+a2R+a3R ;+a4R+a5R+a6R+a7R+a8R+a9R+a10R
aLd delay1 aL
aRd delay1 aR
aL=kmamp*.1*(aL+aLd)    ;simple LP at Nyquist F
aR=kmamp*.1*(aR+aRd)

;dynamic filter section
kLLPon chnget "LLPon"
kLLPlp chnget "LLPlp"
kLLPlp port kLLPlp,.05
kLLPbp chnget "LLPbp"
kLLPbp port kLLPbp,.05
kLLPhp chnget "LLPhp"
kLLPhp port kLLPhp,.05
kLLPcfset chnget "LLPcfset"
kLLPadsr chnget "LLPadsr"
koffset chnget "offset"
kbase chnget "base"
ktarget chnget "target"
kLLPQadsr chnget "LLPQadsr"
kLLPQbase chnget "LLPQbase"
kLLPQtarget chnget "LLPQtarget"
if kLLPon==0 goto noLLP

if kLLPadsr = 1 then
kcfenv=kenv1
elseif kLLPadsr = 2 then
kcfenv=kenv2
elseif kLLPadsr = 3 then
kcfenv=kenv3
elseif kLLPadsr = 4 then
kcfenv=kenv4
elseif kLLPadsr = 5 then
kcfenv=kenv5
elseif kLLPadsr = 6 then
kcfenv=kenv6
elseif kLLPadsr = 7 then
kcfenv=kenv7
elseif kLLPadsr = 8 then
kcfenv=kenv8
elseif kLLPadsr = 9 then
kcfenv=kenv9
elseif kLLPadsr = 10 then
kcfenv=kenv10
endif
if kLLPcfset==1 then
kLLPcf=cpsmidinn(p4+koffset+(kcfenv*(p4+koffset+ktarget-(p4+koffset))))
else 
kLLPcf=cpsmidinn(kbase+(kcfenv*((kbase+ktarget)-kbase)))
endif
kLLPcf limit kLLPcf,50,25000

if kLLPQadsr = 1 then
kQenv=kenv1
elseif kLLPQadsr = 2 then
kQenv=kenv2
elseif kLLPQadsr = 3 then
kQenv=kenv3
elseif kLLPQadsr = 4 then
kQenv=kenv4
elseif kLLPQadsr = 5 then
kQenv=kenv5
elseif kLLPQadsr = 6 then
kQenv=kenv6
elseif kLLPQadsr = 7 then
kQenv=kenv7
elseif kLLPQadsr = 8 then
kQenv=kenv8
elseif kLLPQadsr = 9 then
kQenv=kenv9
elseif kLLPQadsr = 10 then
kQenv=kenv10
endif
kQenv=kenv1
kLLPQ=kLLPQbase+(kQenv*(kLLPQtarget-kLLPQbase))
kLLPQ limit kLLPQ,.5,25

alpL,abpL,ahpL zdf_2pole_mode aL,kLLPcf,kLLPQ
alpR,abpR,ahpR zdf_2pole_mode aR,kLLPcf,kLLPQ

aLLPL=(alpL*kLLPlp)+(abpL*kLLPbp)+(ahpL*kLLPhp)
aLLPR=(alpR*kLLPlp)+(abpR*kLLPbp)+(ahpR*kLLPhp)
aL balance aLLPL,aL
aR balance aLLPR,aR

noLLP:
gaSynL=dcblock2(gaSynL+aL)
gaSynR=dcblock2(gaSynR+aR)

endin

instr 20    ;always on for noise generators
kduston chnget "duston"
kdustamp chnget "dustamp"
kdustrate chnget "dustrate"
kwhiteon chnget "whiteon"
kwhiteamp chnget "whiteamp"
kpinkon chnget "pinkon"
kpinkamp chnget "pinkamp"
kgausson chnget "gausson"
kgaussamp chnget "gaussamp"

adust1 dust2 kdustamp,kdustrate 
adust2 dust2 kdustamp,kdustrate  
awhite1 rand kwhiteamp 
awhite2 rand kwhiteamp
apink1 pinkish kpinkamp 
apink2 pinkish kpinkamp
agauss1 gauss kgaussamp 
agauss2 gauss kgaussamp
gaSynL=gaSynL+(adust1*kduston)+(awhite1*kwhiteon)+(apink1*kpinkon)+(agauss1*kgausson)
gaSynR=gaSynR+(adust2*kduston)+(awhite2*kwhiteon)+(apink2*kpinkon)+(agauss2*kgausson)
DUSTEND:
endin

instr 25 ;GUI control for FM/AM controls, and Dynamic Filter CF Offset vs. Base
kfm1 chnget "fm1"
kfm2 chnget "fm2"
kfm3 chnget "fm3"
kfm4 chnget "fm4"
kfm5 chnget "fm5"
kfm6 chnget "fm6"
kfm7 chnget "fm7"
kfm8 chnget "fm8"
kfm9 chnget "fm9"
kfm10 chnget "fm10"
kam1 chnget "am1"
kam2 chnget "am2"
kam3 chnget "am3"
kam4 chnget "am4"
kam5 chnget "am5"
kam6 chnget "am6"
kam7 chnget "am7"
kam8 chnget "am8"
kam9 chnget "am9"
kam10 chnget "am10"
kLLPcfset chnget "LLPcfset"
if changed(kLLPcfset)==1 then
  if kLLPcfset==1 then
  chnset "visible(1)", "LLPoffset"
  chnset "visible(1)", "offsetlabel"
  chnset "visible(0)", "LLPbase"
  chnset "visible(0)", "baselabel"
  elseif kLLPcfset==2 then
  chnset "visible(0)", "LLPoffset"
  chnset "visible(0)", "offsetlabel"
  chnset "visible(1)", "LLPbase"
  chnset "visible(1)", "baselabel"
  endif
endif
if changed(kfm1)==1 then
  if kfm1==1 then
  chnset "visible(0)","fi1"
  chnset "visible(0)","fe1"
  else
  chnset "visible(1)","fi1"
  chnset "visible(1)","fe1"
  endif
endif
if changed(kfm2)==1 then
  if kfm2==1 then
  chnset "visible(0)","fi2"
  chnset "visible(0)","fe2"
  else
  chnset "visible(1)","fi2"
  chnset "visible(1)","fe2"
  endif
endif
if changed(kfm3)==1 then
  if kfm3==1 then
  chnset "visible(0)","fi3"
  chnset "visible(0)","fe3"
  else
  chnset "visible(1)","fi3"
  chnset "visible(1)","fe3"
  endif
endif
if changed(kfm4)==1 then
  if kfm4==1 then
  chnset "visible(0)","fi4"
  chnset "visible(0)","fe4"
  else
  chnset "visible(1)","fi4"
  chnset "visible(1)","fe4"
  endif
endif
if changed(kfm5)==1 then
  if kfm5==1 then
  chnset "visible(0)","fi5"
  chnset "visible(0)","fe5"
  else
  chnset "visible(1)","fi5"
  chnset "visible(1)","fe5"
  endif
endif
if changed(kfm6)==1 then
  if kfm6==1 then
  chnset "visible(0)","fi6"
  chnset "visible(0)","fe6"
  else
  chnset "visible(1)","fi6"
  chnset "visible(1)","fe6"
  endif
endif
if changed(kfm7)==1 then
  if kfm7==1 then
  chnset "visible(0)","fi7"
  chnset "visible(0)","fe7"
  else
  chnset "visible(1)","fi7"
  chnset "visible(1)","fe7"
  endif
endif
if changed(kfm8)==1 then
  if kfm8==1 then
  chnset "visible(0)","fi8"
  chnset "visible(0)","fe8"
  else
  chnset "visible(1)","fi8"
  chnset "visible(1)","fe8"
  endif
endif
if changed(kfm9)==1 then
  if kfm9==1 then
  chnset "visible(0)","fi9"
  chnset "visible(0)","fe9"
  else
  chnset "visible(1)","fi9"
  chnset "visible(1)","fe9"
  endif
endif
if changed(kfm10)==1 then
  if kfm10==1 then
  chnset "visible(0)","fi10"
  chnset "visible(0)","fe10"
  else
  chnset "visible(1)","fi10"
  chnset "visible(1)","fe10"
  endif
endif
if changed(kam1)==1 then
  if kam1==1 then
  chnset "visible(0)","ai1"
  chnset "visible(0)","ae1"
  else
  chnset "visible(1)","ai1"
  chnset "visible(1)","ae1"
  endif
endif
if changed(kam2)==1 then
  if kam2==1 then
  chnset "visible(0)","ai2"
  chnset "visible(0)","ae2"
  else
  chnset "visible(1)","ai2"
  chnset "visible(1)","ae2"
  endif
endif
if changed(kam3)==1 then
  if kam3==1 then
  chnset "visible(0)","ai3"
  chnset "visible(0)","ae3"
  else
  chnset "visible(1)","ai3"
  chnset "visible(1)","ae3"
  endif
endif
if changed(kam4)==1 then
  if kam4==1 then
  chnset "visible(0)","ai4"
  chnset "visible(0)","ae4"
  else
  chnset "visible(1)","ai4"
  chnset "visible(1)","ae4"
  endif
endif
if changed(kam5)==1 then
  if kam5==1 then
  chnset "visible(0)","ai5"
  chnset "visible(0)","ae5"
  else
  chnset "visible(1)","ai5"
  chnset "visible(1)","ae5"
  endif
endif
if changed(kam6)==1 then
  if kam6==1 then
  chnset "visible(0)","ai6"
  chnset "visible(0)","ae6"
  else
  chnset "visible(1)","ai6"
  chnset "visible(1)","ae6"
  endif
endif
if changed(kam7)==1 then
  if kam7==1 then
  chnset "visible(0)","ai7"
  chnset "visible(0)","ae7"
  else
  chnset "visible(1)","ai7"
  chnset "visible(1)","ae7"
  endif
endif
if changed(kam8)==1 then
  if kam8==1 then
  chnset "visible(0)","ai8"
  chnset "visible(0)","ae8"
  else
  chnset "visible(1)","ai8"
  chnset "visible(1)","ae8"
  endif
endif
if changed(kam9)==1 then
  if kam9==1 then
  chnset "visible(0)","ai9"
  chnset "visible(0)","ae9"
  else
  chnset "visible(1)","ai9"
  chnset "visible(1)","ae9"
  endif
endif
if changed(kam10)==1 then
  if kam10==1 then
  chnset "visible(0)","ai10"
  chnset "visible(0)","ae10"
  else
  chnset "visible(1)","ai10"
  chnset "visible(1)","ae10"
  endif
endif
endin

instr 60 ;vocal filter preset controller
 gkvpreset	chnget	"vpresets"
 ktrig		changed	gkvpreset 

 #define SET_PRESET(N'set1'set2'set3'set4'set5'set6'set7'set8'set9'set10'set11'set12'set13'set14'set15'set16)
 #
 if i(gkvpreset)==$N then
  chnset	$set1,"parsel1"	  
  chnset	$set2,"parsel2"    
  chnset	$set3,"parsel3"   
  chnset	$set4,"parsel4"
  chnset	$set5,"parF1"
  chnset	$set6,"parF2"  
  chnset	$set7,"parF3"
  chnset	$set8,"parF4"
  chnset	$set9,"parres1"
  chnset	$set10,"parres2"
  chnset	$set11,"parres3"   
  chnset	$set12,"parres4"   
  chnset	$set13,"paramp1" 
  chnset	$set14,"paramp2" 
  chnset	$set15,"paramp3"
  chnset	$set16,"paramp4"
 endif
 #
 if ktrig==1 then
  reinit SEND_PRESET
 endif
 SEND_PRESET: ;1-21=default, Sop a,e,i,o,u, Alto a,e,i,o,u, Tenor a,e,i,o,u, and Bass a,e,i,o,u
 ;           N'set1'set2'set3'set4'set5'set6'set7'set8'set9'set10'set11'set12'set13'set14'set15'set16
 $SET_PRESET(1'1'2'2'3'8'9'10'11'1'1'1'1'1'1'1'1)
 $SET_PRESET(2'2'2'2'2'octmidinn(79.4)'octmidinn(85.6)'octmidinn(101.6)'octmidinn(106.85)'800/80'1150/120'2900/200'3900/130'ampdbfs(0)'ampdbfs(-6)'ampdbfs(-32)'ampdbfs(-20)) ;soprano
 $SET_PRESET(3'2'2'2'2'octmidinn(65)'octmidinn(95.2)'octmidinn(101.1)'octmidinn(105.45)'350/60'2000/100'2800/120'3600/150'ampdbfs(0)'ampdbfs(-20)'ampdbfs(-15)'ampdbfs(-40))
 $SET_PRESET(4'2'2'2'2'octmidinn(60.6)'octmidinn(96.4)'octmidinn(101.9)'octmidinn(106.85)'270/60'2140/90'2950/100'3900/120'ampdbfs(0)'ampdbfs(-12)'ampdbfs(-26)'ampdbfs(-26))
 $SET_PRESET(5'2'2'2'2'octmidinn(69.4)'octmidinn(79.4)'octmidinn(101.2)'octmidinn(106.4)'450/40'800/80'2830/100'3800/120'ampdbfs(0)'ampdbfs(-11)'ampdbfs(-22)'ampdbfs(-22))
 $SET_PRESET(6'2'2'2'2'octmidinn(63.75)'octmidinn(77)'octmidinn(100.45)'octmidinn(106.4)'325/50'700/60'2700/170'3800/180'ampdbfs(0)'ampdbfs(-16)'ampdbfs(-35)'ampdbfs(-40))
 $SET_PRESET(7'2'2'2'2'octmidinn(79.4)'octmidinn(85.6)'octmidinn(101.1)'octmidinn(104.9)'800/80'1150/90'2800/120'3500/130'ampdbfs(0)'ampdbfs(-4)'ampdbfs(-20)'ampdbfs(-36)) ;alto
 $SET_PRESET(8'2'2'2'2'octmidinn(67.4)'octmidinn(91.4)'octmidinn(100.45)'octmidinn(103.85)'400/60'1600/80'2700/120'3300/150'ampdbfs(0)'ampdbfs(-24)'ampdbfs(-30)'ampdbfs(-35))
 $SET_PRESET(9'2'2'2'2'octmidinn(65)'octmidinn(92.4)'octmidinn(100.45)'octmidinn(105.9)'350/50'1700/100'2700/120'3700/150'ampdbfs(0)'ampdbfs(-20)'ampdbfs(-30)'ampdbfs(-36))
 $SET_PRESET(10'2'2'2'2'octmidinn(69.4)'octmidinn(79.4)'octmidinn(101.2)'octmidinn(104.9)'450/70'800/80'2830/100'3500/130'ampdbfs(0)'ampdbfs(-9)'ampdbfs(-16)'ampdbfs(-28))
 $SET_PRESET(11'2'2'2'2'octmidinn(63.75)'octmidinn(77)'octmidinn(99.3)'octmidinn(104.9)'325/50'700/60'2530/170'3500/180'ampdbfs(0)'ampdbfs(-12)'ampdbfs(-30)'ampdbfs(-40))
 $SET_PRESET(12'2'2'2'2'octmidinn(75.75)'octmidinn(84.6)'octmidinn(100.1)'octmidinn(101.6)'650/80'1080/90'2650/120'2900/130'ampdbfs(0)'ampdbfs(-6)'ampdbfs(-7)'ampdbfs(-8)) ;tenor
 $SET_PRESET(13'2'2'2'2'octmidinn(67.4)'octmidinn(92.4)'octmidinn(99.7)'octmidinn(103.4)'400/70'1700/80'2600/100'3200/120'ampdbfs(0)'ampdbfs(-14)'ampdbfs(-12)'ampdbfs(-14))
 $SET_PRESET(14'2'2'2'2'octmidinn(61.66)'octmidinn(94.1)'octmidinn(101.1)'octmidinn(103.6)'290/40'1870/90'2800/100'3250/120'ampdbfs(0)'ampdbfs(-15)'ampdbfs(-18)'ampdbfs(-20))
 $SET_PRESET(15'2'2'2'2'octmidinn(67.4)'octmidinn(79.4)'octmidinn(99.7)'octmidinn(101.1)'400/70'800/80'2600/100'2800/130'ampdbfs(0)'ampdbfs(-10)'ampdbfs(-12)'ampdbfs(-12))
 $SET_PRESET(16'2'2'2'2'octmidinn(65)'octmidinn(74.3)'octmidinn(100.45)'octmidinn(101.6)'350/40'600/60'2700/100'2900/120'ampdbfs(0)'ampdbfs(-20)'ampdbfs(-17)'ampdbfs(-14))
 $SET_PRESET(17'2'2'2'2'octmidinn(74.3)'octmidinn(83.9)'octmidinn(97.2)'octmidinn(98.6)'600/60'1040/70'2250/110'2450/120'ampdbfs(0)'ampdbfs(-7)'ampdbfs(-9)'ampdbfs(-9)) ;bass
 $SET_PRESET(18'2'2'2'2'octmidinn(67.4)'octmidinn(91.6)'octmidinn(98.4)'octmidinn(101.1)'400/40'1620/80'2400/100'2800/120'ampdbfs(0)'ampdbfs(-12)'ampdbfs(-9)'ampdbfs(-12))
 $SET_PRESET(19'2'2'2'2'octmidinn(59.33)'octmidinn(92.9)'octmidinn(99.7)'octmidinn(102.5)'250/60'1750/90'2600/100'3050/120'ampdbfs(0)'ampdbfs(-30)'ampdbfs(-16)'ampdbfs(-22))
 $SET_PRESET(20'2'2'2'2'octmidinn(67.4)'octmidinn(78.25)'octmidinn(98.4)'octmidinn(99.7)'400/40'750/80'2400/100'2600/120'ampdbfs(0)'ampdbfs(-11)'ampdbfs(-21)'ampdbfs(-20))
 $SET_PRESET(21'2'2'2'2'octmidinn(65)'octmidinn(74.3)'octmidinn(98.4)'octmidinn(100.3)'350/40'600/80'2400/100'2675/120'ampdbfs(0)'ampdbfs(-20)'ampdbfs(-32)'ampdbfs(-28))

endin

instr 61 ;Transposer preset controller
 gkTpreset	chnget	"Tpresets"
 ktrig		changed	gkTpreset 

 #define SET_PRESET(N'set1'set2'set3'set4'set5'set6'set7'set8'set9'set10'set11'set12)
 #
 if i(gkTpreset)==$N then
  chnset	$set1,"harmon1C"	  
  chnset	$set2,"harmon1F"    
  chnset	$set3,"harmon2C"   
  chnset	$set4,"harmon2F"
  chnset	$set5,"harmon3C"
  chnset	$set6,"harmon3F"  
  chnset	$set7,"harmon4C"
  chnset	$set8,"harmon4F"
  chnset	$set9,"harmon5C"
  chnset	$set10,"harmon5F"
  chnset	$set11,"harmon6C"   
  chnset	$set12,"harmon6F"
 endif
 #
 if ktrig==1 then
  reinit SEND_PRESET
 endif
 SEND_PRESET:
 ;           N'set1'set2'set3'set4'set5'set6'set7'set8'set9'set10'set11'set12'set13'set14'set15'set16
 $SET_PRESET(1'0'.14'0'-.16'0'.09'0'-.12'0'.11'0'-.05)
 $SET_PRESET(2'0'.15'0'-.16'0'.18'0'-.25'0'.24'0'-.21)
 $SET_PRESET(3'0'-.32'0'.67'0'-.65'-1'.01'1'-.06'0'.34)
 $SET_PRESET(4'7'-.05'7'.1'7'-.08'7'.01'7'-.06'7'.03)
 $SET_PRESET(5'5'.05'5'-.1'5'.08'5'-.03'5'.06'5'-.05)
 $SET_PRESET(6'4'-.07'4'.04'4'-.02'4'.06'4'-.08'4'.09)
 $SET_PRESET(7'3'.05'3'.11'3'.08'3'-.01'3'-.06'3'-.09)
 $SET_PRESET(8'0'.5'0'-.5'1'0'-1'.01'1'-.51'-1'.53)
 $SET_PRESET(9'-1'-.05'1'.1'-2'-.08'2'.01'-3'-.06'3'.03)
 $SET_PRESET(10'4'-.05'-4'.1'6'-.08'-6'.01'2'-.06'-2'.03)
 $SET_PRESET(11'21'-.05'-21'.1'7'-.08'-7'.01'14'-.06'-14'.03)
 $SET_PRESET(12'-10'-.05'10'.1'-15'-.08'15'.01'-5'-.06'5'.03)
 $SET_PRESET(13'4'-.05'-4'.1'12'-.08'-12'.01'8'-.06'-8'.03)
 $SET_PRESET(14'-9'-.05'9'.1'-6'-.08'6'.01'-3'-.06'3'.03)
 $SET_PRESET(15'-12'-.15'-24'.19'-12'.18'24'-.17'12'.1'12'-.13)
 $SET_PRESET(16'-12'-.05'-5'.1'-12'-.08'-5'.01'7'-.06'12'.03)
 $SET_PRESET(17'16'-.05'-12'.1'7'-.08'-5'.01'12'-.06'-12'.03)
 $SET_PRESET(18'12'-.05'-5'.1'3'-.08'-12'.01'7'-.06'15'.03)
 $SET_PRESET(19'4'-.05'12'.1'10'-.08'-12'.01'-5'-.06'10'.03)
 $SET_PRESET(20'7'-.05'-12'.1'-5'-.08'11'.01'4'-.06'12'.03)
 $SET_PRESET(21'11'-.05'4'.1'12'-.08'2'.01'-12'-.06'-5'.03)
 $SET_PRESET(22'10'-.05'12'.1'7'-.08'3'.01'-5'-.06'-12'.03)
 $SET_PRESET(23'-12'-.05'-5'.1'5'-.08'7'.01'0'-.06'12'.03)
 $SET_PRESET(24'7'-.05'10'.1'12'-.08'-12'.01'-5'-.06'5'.03)
 $SET_PRESET(25'12'-.05'10'.1'-12'-.08'-5'.01'4'-.06'15'.03)
 $SET_PRESET(26'10'-.05'-12'.1'12'-.08'4'.01'-5'-.06'14'.03)
 $SET_PRESET(27'0'-.05'4'.1'-12'-.08'10'.01'15'-.06'4'.03)
 $SET_PRESET(28'0'0'0'0'0'0'0'0'0'0'0'0)

endin

instr 100   ;instrument to monitor MIDI controller numbers, creates global MIDI outputs that are evaluated by instr 110-300         
            ;also controls popup for latched LowPass and soundfile string management
gkstatus,gkchan,gkdata1,gkdata2 midiin
if changed(gkstatus)==1 then  
    if gkstatus==176 then
    chnset gkdata1,"CtrlNum" ;displays current controller number in GUI
    endif
endif
endin

instr 101 ;master volume MIDI mapping
kmapMamp chnget "mapMamp"
kmapMampX chnget "mapMampX"
if changed(gkstatus)==1 then
  if gkstatus==176 then
    if kmapMamp==1 then
      turnoff2 102,2,0
      event "i",102,0,999999999
    endif
  endif
endif
if kmapMampX==1 then
  turnoff2 102,2,0
endif
endin

instr 102
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1.5000 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "MAmp"
endin

instr 103 ;pitch ribbon MIDI mapping
kmaprib chnget "maprib"
kmapribX chnget "mapribX"
if changed(gkstatus)==1 then
  if gkstatus==176 then
    if kmaprib==1 then
      turnoff2 104,2,0
      event "i",104,0,999999999
    endif
  endif
endif
if kmapribX==1 then
  turnoff2 104,2,0
endif
endin

instr 104
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-36,36 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "ribbon"
endin

instr 105 ;Live Audio Amp MIDI mapping
kmapliveamp chnget "mapliveamp"
kmapliveampX chnget "mapliveampX"
if changed(gkstatus)==1 then
  if gkstatus==176 then
    if kmapliveamp==1 then
      turnoff2 106,2,0
      event "i",106,0,999999999
    endif
  endif
endif
if kmapliveampX==1 then
  turnoff2 106,2,0
endif
endin

instr 106
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,2.5 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "liveamp"
endin

instr 110;MIDI control for axis1
kmapmorph1 chnget "mapmorph1"
kmapmorph1X chnget "mapmorph1X"
kmaptc1 chnget "maptc1"
kmaptc1X chnget "maptc1X"
kmaptf1 chnget "maptf1"
kmaptf1X chnget "maptf1X"
kmapioff1 chnget "mapioff1"
kmapioff1X chnget "mapioff1X"
kmapiamp1 chnget "mapiamp1"
kmapiamp1X chnget "mapiamp1X"

;monitor controller changes and assign
if changed(gkstatus)==1 then  
    if gkstatus==176 then
        if kmapmorph1 == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 111, 2, 0
            event "i", 111, 0, 999999999
        elseif kmaptc1 == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 112, 2, 0
            event "i", 112, 0, 999999999
        elseif kmaptf1 == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 113, 2, 0
            event "i", 113, 0, 999999999
        elseif kmapioff1 == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 114, 2, 0
            event "i", 114, 0, 999999999
        elseif kmapiamp1 == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 115, 2, 0
            event "i", 115, 0, 999999999
        endif
    endif
endif

;turn off MIDI controller GUI control for individual rsliders
if kmapmorph1X == 1 then
    turnoff2 111, 2, 0
elseif kmaptc1X == 1 then
    turnoff2 112, 2, 0
elseif kmaptf1X == 1 then
    turnoff2 113, 2, 0
elseif kmapioff1X == 1 then
    turnoff2 114, 2, 0
elseif kmapiamp1X == 1 then
    turnoff2 115, 2, 0
endif
endin

instr 111 
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,7
chnset ktr1, "morph1"
endin

instr 112
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-24,24
chnset ktr1, "tc1"
endin

instr 113
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-1,1
chnset ktr1, "tf1"
endin

instr 114
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1
chnset ktr1, "ioff1"
endin

instr 115
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.01,50
chnset ktr1, "iamp1"
endin

instr 120;MIDI control for axis1
kmapmorph2 chnget "mapmorph2"
kmapmorph2X chnget "mapmorph2X"
kmaptc2 chnget "maptc2"
kmaptc2X chnget "maptc2X"
kmaptf2 chnget "maptf2"
kmaptf2X chnget "maptf2X"
kmapioff2 chnget "mapioff2"
kmapioff2X chnget "mapioff2X"
kmapiamp2 chnget "mapiamp2"
kmapiamp2X chnget "mapiamp2X"

;monitor controller changes and assign
if changed(gkstatus)==1 then  
    if gkstatus==176 then
        if kmapmorph2 == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 121, 2, 0
            event "i", 121, 0, 999999999
        elseif kmaptc2 == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 122, 2, 0
            event "i", 122, 0, 999999999
        elseif kmaptf2 == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 123, 2, 0
            event "i", 123, 0, 999999999
        elseif kmapioff2 == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 124, 2, 0
            event "i", 124, 0, 999999999
        elseif kmapiamp2 == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 125, 2, 0
            event "i", 125, 0, 999999999
        endif
    endif
endif

;turn off MIDI controller GUI control for individual rsliders
if kmapmorph2X == 1 then
    turnoff2 121, 2, 0
elseif kmaptc2X == 1 then
    turnoff2 122, 2, 0
elseif kmaptf2X == 1 then
    turnoff2 123, 2, 0
elseif kmapioff2X == 1 then
    turnoff2 124, 2, 0
elseif kmapiamp2X == 1 then
    turnoff2 125, 2, 0
endif
endin

instr 121 
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,7
chnset ktr1, "morph2"
endin

instr 122
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-24,24
chnset ktr1, "tc2"
endin

instr 123
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-1,1
chnset ktr1, "tf2"
endin

instr 124
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1
chnset ktr1, "ioff2"
endin

instr 125
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.01,50
chnset ktr1, "iamp2"
endin

instr 130;MIDI control for axis1
kmapmorph3 chnget "mapmorph3"
kmapmorph3X chnget "mapmorph3X"
kmaptc3 chnget "maptc3"
kmaptc3X chnget "maptc3X"
kmaptf3 chnget "maptf3"
kmaptf3X chnget "maptf3X"
kmapioff3 chnget "mapioff3"
kmapioff3X chnget "mapioff3X"
kmapiamp3 chnget "mapiamp3"
kmapiamp3X chnget "mapiamp3X"

;monitor controller changes and assign
if changed(gkstatus)==1 then  
    if gkstatus==176 then
        if kmapmorph3 == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 131, 2, 0
            event "i", 131, 0, 999999999
        elseif kmaptc3 == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 132, 2, 0
            event "i", 132, 0, 999999999
        elseif kmaptf3 == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 133, 2, 0
            event "i", 133, 0, 999999999
        elseif kmapioff3 == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 134, 2, 0
            event "i", 134, 0, 999999999
        elseif kmapiamp3 == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 135, 2, 0
            event "i", 135, 0, 999999999
        endif
    endif
endif

;turn off MIDI controller GUI control for individual rsliders
if kmapmorph3X == 1 then
    turnoff2 131, 2, 0
elseif kmaptc3X == 1 then
    turnoff2 132, 2, 0
elseif kmaptf3X == 1 then
    turnoff2 133, 2, 0
elseif kmapioff3X == 1 then
    turnoff2 134, 2, 0
elseif kmapiamp3X == 1 then
    turnoff2 135, 2, 0
endif
endin

instr 131 
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,7
chnset ktr1, "morph3"
endin

instr 132
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-24,24
chnset ktr1, "tc3"
endin

instr 133
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-1,1
chnset ktr1, "tf3"
endin

instr 134
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1
chnset ktr1, "ioff3"
endin

instr 135
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.01,50
chnset ktr1, "iamp3"
endin

instr 140;MIDI control for axis1
kmapmorph4 chnget "mapmorph4"
kmapmorph4X chnget "mapmorph4X"
kmaptc4 chnget "maptc4"
kmaptc4X chnget "maptc4X"
kmaptf4 chnget "maptf4"
kmaptf4X chnget "maptf4X"
kmapioff4 chnget "mapioff4"
kmapioff4X chnget "mapioff4X"
kmapiamp4 chnget "mapiamp4"
kmapiamp4X chnget "mapiamp4X"

;monitor controller changes and assign
if changed(gkstatus)==1 then  
    if gkstatus==176 then
        if kmapmorph4 == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 141, 2, 0
            event "i", 141, 0, 999999999
        elseif kmaptc4 == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 142, 2, 0
            event "i", 142, 0, 999999999
        elseif kmaptf4 == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 143, 2, 0
            event "i", 143, 0, 999999999
        elseif kmapioff4 == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 144, 2, 0
            event "i", 144, 0, 999999999
        elseif kmapiamp4 == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 145, 2, 0
            event "i", 145, 0, 999999999
        endif
    endif
endif

;turn off MIDI controller GUI control for individual rsliders
if kmapmorph4X == 1 then
    turnoff2 141, 2, 0
elseif kmaptc4X == 1 then
    turnoff2 142, 2, 0
elseif kmaptf4X == 1 then
    turnoff2 143, 2, 0
elseif kmapioff4X == 1 then
    turnoff2 144, 2, 0
elseif kmapiamp4X == 1 then
    turnoff2 145, 2, 0
endif
endin

instr 141 
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,7
chnset ktr1, "morph4"
endin

instr 142
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-24,24
chnset ktr1, "tc4"
endin

instr 143
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-1,1
chnset ktr1, "tf4"
endin

instr 144
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1
chnset ktr1, "ioff4"
endin

instr 145
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.01,50
chnset ktr1, "iamp4"
endin

instr 150;MIDI control for axis1
kmapmorph5 chnget "mapmorph5"
kmapmorph5X chnget "mapmorph5X"
kmaptc5 chnget "maptc5"
kmaptc5X chnget "maptc5X"
kmaptf5 chnget "maptf5"
kmaptf5X chnget "maptf5X"
kmapioff5 chnget "mapioff5"
kmapioff5X chnget "mapioff5X"
kmapiamp5 chnget "mapiamp5"
kmapiamp5X chnget "mapiamp5X"

;monitor controller changes and assign
if changed(gkstatus)==1 then  
    if gkstatus==176 then
        if kmapmorph5 == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 151, 2, 0
            event "i", 151, 0, 999999999
        elseif kmaptc5 == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 152, 2, 0
            event "i", 152, 0, 999999999
        elseif kmaptf5 == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 153, 2, 0
            event "i", 153, 0, 999999999
        elseif kmapioff5 == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 154, 2, 0
            event "i", 154, 0, 999999999
        elseif kmapiamp5 == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 155, 2, 0
            event "i", 155, 0, 999999999
        endif
    endif
endif

;turn off MIDI controller GUI control for individual rsliders
if kmapmorph5X == 1 then
    turnoff2 151, 2, 0
elseif kmaptc5X == 1 then
    turnoff2 152, 2, 0
elseif kmaptf5X == 1 then
    turnoff2 153, 2, 0
elseif kmapioff5X == 1 then
    turnoff2 154, 2, 0
elseif kmapiamp5X == 1 then
    turnoff2 155, 2, 0
endif
endin

instr 151 
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,7
chnset ktr1, "morph5"
endin

instr 152
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-24,24
chnset ktr1, "tc5"
endin

instr 153
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-1,1
chnset ktr1, "tf5"
endin

instr 154
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1
chnset ktr1, "ioff5"
endin

instr 155
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.01,50
chnset ktr1, "iamp5"
endin

instr 200
;receive MIDI mapping buttons for RNG
kmapRNGrate chnget "mapRNGrate"
kmapRNGrateX chnget "mapRNGrateX"
kmapRNGraterand chnget "mapRNGraterand"
kmapRNGraterandX chnget "mapRNGraterandX"
kmapRNGdev chnget "mapRNGdev"
kmapRNGdevX chnget "mapRNGdevX"

;monitor controller changes and assign
if changed(gkstatus)==1 then  
    if gkstatus==176 then
        if kmapRNGrate == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 201, 2, 0
            event "i", 201, 0, 999999999
        elseif kmapRNGraterand == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 202, 2, 0
            event "i", 202, 0, 999999999
        elseif kmapRNGdev == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 204, 2, 0
            event "i", 204, 0, 999999999
        endif
    endif
endif

;turn off MIDI controller GUI control for individual rsliders
if kmapRNGrateX == 1 then
    turnoff2 201, 2, 0
elseif kmapRNGraterandX == 1 then
    turnoff2 202, 2, 0
elseif kmapRNGdevX == 1 then
    turnoff2 204, 2, 0
endif
endin

instr 201 ;MIDI mapping for RNG
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.01,100 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "RNGrate"
endin

instr 202 ;MIDI mapping for RNG
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,.95 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "RNGraterand"
endin

instr 204 ;MIDI mapping for RNG
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,60 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "RNGdev"
endin

instr 210
;receive MIDI mapping buttons for Distortion
kmapdist chnget "mapdist"
kmapdistX chnget "mapdistX"
kmapdist2 chnget "mapdist2"
kmapdist2X chnget "mapdist2X"
kmapdist3 chnget "mapdist3"
kmapdist3X chnget "mapdist3X"

;monitor controller changes and assign
if changed(gkstatus)==1 then  
    if gkstatus==176 then
        if kmapdist == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 211,2,0
            event "i",211,0,999999999
        elseif kmapdist2 == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 212,2,0
            event "i",212,0,999999999
        elseif kmapdist3 == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 213,2,0
            event "i",213,0,999999999
        endif
    endif
endif

;turn off MIDI controller GUI control for individual rsliders
if kmapdistX == 1 then
    turnoff2 211, 2, 0
elseif kmapdist2X == 1 then
    turnoff2 212, 2, 0
elseif kmapdist3X == 1 then
    turnoff2 213, 2, 0
endif
endin

instr 211 ;MIDI mapping for Distortion
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1,"dist"
endin

instr 212 ;MIDI mapping for Distortion
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,.999 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1,"dist2"
endin

instr 213 ;MIDI mapping for Distortion
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,1,25 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1,"dist3"
endin

instr 220
;receive MIDI mapping buttons for Vibrato
kmapvibrand chnget "mapvibrand"
kmapvibrandX chnget "mapvibrandX"
kmapvibcps chnget "mapvibcps"
kmapvibcpsX chnget "mapvibcpsX"
kmapvibdepth chnget "mapvibdepth"
kmapvibdepthX chnget "mapvibdepthX"

;monitor controller changes and assign
if changed(gkstatus)==1 then  
    if gkstatus==176 then
        if kmapvibrand == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 221, 2, 0
            event "i", 221, 0, 999999999
        elseif kmapvibcps == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 222, 2, 0
            event "i", 222, 0, 999999999
        elseif kmapvibdepth == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 223, 2, 0
            event "i", 223, 0, 999999999
        endif
    endif
endif

;turn off MIDI controller GUI control for individual rsliders
if kmapvibrandX == 1 then
    turnoff2 221, 2, 0
elseif kmapvibcpsX == 1 then
    turnoff2 222, 2, 0
elseif kmapvibdepthX == 1 then
    turnoff2 223, 2, 0
endif
endin

instr 221 ;MIDI mapping for Vibrato
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,.99 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "vibrand"
endin

instr 222 ;MIDI mapping for Vibrato
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "vibcps"
endin

instr 223 ;MIDI mapping for Vibrato
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "vibdepth"
endin

instr 230
;receive MIDI mapping buttons for Lowpass
kmapLPcps chnget "mapLPcps"
kmapLPcpsX chnget "mapLPcpsX"
kmapLPres chnget "mapLPres"
kmapLPresX chnget "mapLPresX"

;monitor controller changes and assign
if changed(gkstatus)==1 then  
    if gkstatus==176 then
        if kmapLPcps == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 231, 2, 0
            event "i", 231, 0, 999999999
        elseif kmapLPres == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 232, 2, 0
            event "i", 232, 0, 999999999
        endif
    endif
endif

;turn off MIDI controller GUI control for individual rsliders
if kmapLPcpsX == 1 then
    turnoff2 231, 2, 0
elseif kmapLPresX == 1 then
    turnoff2 232, 2, 0
endif
endin

instr 231 ;MIDI mapping for Lowpass
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,2,14 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "LPcps"
endin

instr 232 ;MIDI mapping for Lowpass
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.01,.99 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "LPres"
endin

instr 240
;receive MIDI mapping buttons for Phaser
kmapphscps chnget "mapphscps"
kmapphscpsX chnget "mapphscpsX"
kmapphsFB chnget "mapphsFB"
kmapphsFBX chnget "mapphsFBX"
kmapphsQ chnget "mapphsQ"
kmapphsQX chnget "mapphsQX"


;monitor controller changes and assign
if changed(gkstatus)==1 then  
    if gkstatus==176 then
        if kmapphscps == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 241, 2, 0
            event "i", 241, 0, 999999999
        elseif kmapphsFB == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 242, 2, 0
            event "i", 242, 0, 999999999
        elseif kmapphsQ == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 243, 2, 0
            event "i", 243, 0, 999999999
        endif
    endif
endif

;turn off MIDI controller GUI control for individual rsliders
if kmapphscpsX == 1 then
    turnoff2 241, 2, 0
elseif kmapphsFBX == 1 then
    turnoff2 242, 2, 0
elseif kmapphsQX == 1 then
    turnoff2 243, 2, 0
endif
endin

instr 241 ;MIDI mapping for Phaser
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.01,100 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "phscps"
endin

instr 242 ;MIDI mapping for Phaser
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "phsFB"
endin

instr 243 ;MIDI mapping for Phaser
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.01,100 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "phsQ"
endin

instr 250
;receive MIDI mapping buttons for Flanger
kmapflcps chnget "mapflcps"
kmapflcpsX chnget "mapflcpsX"
kmapflFB chnget "mapflFB"
kmapflFBX chnget "mapflFBX"

;monitor controller changes and assign
if changed(gkstatus)==1 then  
    if gkstatus==176 then
        if kmapflcps == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 251, 2, 0
            event "i", 251, 0, 999999999
        elseif kmapflFB == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 252, 2, 0
            event "i", 252, 0, 999999999
        endif
    endif
endif

;turn off MIDI controller GUI control for individual rsliders
if kmapflcpsX == 1 then
    turnoff2 251, 2, 0
elseif kmapflFBX == 1 then
    turnoff2 252, 2, 0
endif
endin

instr 251 ;MIDI mapping for Flanger
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.01,100 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "flcps"
endin

instr 252 ;MIDI mapping for Flanger
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,.99 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "flFB"
endin

instr 260
;receive MIDI mapping buttons for Transposer
kmapharmmix chnget "mapharmmix"
kmapharmmixX chnget "mapharmmixX"
kmapharmon1C chnget "mapharmon1C"
kmapharmon1CX chnget "mapharmon1CX"
kmapharmon1F chnget "mapharmon1F"
kmapharmon1FX chnget "mapharmon1FX"
kmapharmon2C chnget "mapharmon2C"
kmapharmon2CX chnget "mapharmon2CX"
kmapharmon2F chnget "mapharmon2F"
kmapharmon2FX chnget "mapharmon2FX"
kmapharmon3C chnget "mapharmon3C"
kmapharmon3CX chnget "mapharmon3CX"
kmapharmon3F chnget "mapharmon3F"
kmapharmon3FX chnget "mapharmon3FX"
kmapharmon4C chnget "mapharmon4C"
kmapharmon4CX chnget "mapharmon4CX"
kmapharmon4F chnget "mapharmon4F"
kmapharmon4FX chnget "mapharmon4FX"
kmapharmon5C chnget "mapharmon5C"
kmapharmon5CX chnget "mapharmon5CX"
kmapharmon5F chnget "mapharmon5F"
kmapharmon5FX chnget "mapharmon5FX"
kmapharmon6C chnget "mapharmon6C"
kmapharmon6CX chnget "mapharmon6CX"
kmapharmon6F chnget "mapharmon6F"
kmapharmon6FX chnget "mapharmon6FX"


;monitor controller changes and assign
if changed(gkstatus)==1 then  
    if gkstatus==176 then
        if kmapharmmix == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 261, 2, 0
            event "i", 261, 0, 999999999
        elseif kmapharmon1C == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 262, 2, 0
            event "i", 262, 0, 999999999
        elseif kmapharmon1F == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 263, 2, 0
            event "i", 263, 0, 999999999
        elseif kmapharmon2C == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 264, 2, 0
            event "i", 264, 0, 999999999
        elseif kmapharmon2F == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 265, 2, 0
            event "i", 265, 0, 999999999
        elseif kmapharmon3C == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 266, 2, 0
            event "i", 266, 0, 999999999
        elseif kmapharmon3F == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 267, 2, 0
            event "i", 267, 0, 999999999
        elseif kmapharmon4C == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 268, 2, 0
            event "i", 268, 0, 999999999
        elseif kmapharmon4F == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 269, 2, 0
            event "i", 269, 0, 999999999
        elseif kmapharmon5C == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 270, 2, 0
            event "i", 270, 0, 999999999
        elseif kmapharmon5F == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 271, 2, 0
            event "i", 271, 0, 999999999
        elseif kmapharmon6C == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 272, 2, 0
            event "i", 272, 0, 999999999
        elseif kmapharmon6F == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 273, 2, 0
            event "i", 273, 0, 999999999
        endif
    endif
endif

;turn off MIDI controller GUI control for individual rsliders
if kmapharmmixX == 1 then
    turnoff2 261, 2, 0
elseif kmapharmon1CX == 1 then
    turnoff2 262, 2, 0
elseif kmapharmon1FX == 1 then
    turnoff2 263, 2, 0
elseif kmapharmon2CX == 1 then
    turnoff2 264, 2, 0
elseif kmapharmon2FX == 1 then
    turnoff2 265, 2, 0
elseif kmapharmon3CX == 1 then
    turnoff2 266, 2, 0
elseif kmapharmon3FX == 1 then
    turnoff2 267, 2, 0
elseif kmapharmon4CX == 1 then
    turnoff2 268, 2, 0
elseif kmapharmon4FX == 1 then
    turnoff2 269, 2, 0
elseif kmapharmon5CX == 1 then
    turnoff2 270, 2, 0
elseif kmapharmon5FX == 1 then
    turnoff2 271, 2, 0
elseif kmapharmon6CX == 1 then
    turnoff2 272, 2, 0
elseif kmapharmon6FX == 1 then
    turnoff2 273, 2, 0
endif
endin

instr 261 ;MIDI mapping for Transposer
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "harmmix"
endin

instr 262 ;MIDI mapping for Transposer
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-24,24 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "harmon1C"
endin

instr 263 ;MIDI mapping for Transposer
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-1,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "harmon1F"
endin

instr 264 ;MIDI mapping for Transposer
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-24,24 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "harmon2C"
endin

instr 265 ;MIDI mapping for Transposer
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-1,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "harmon2F"
endin

instr 266 ;MIDI mapping for Transposer
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-24,24 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "harmon3C"
endin

instr 267 ;MIDI mapping for Transposer
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-1,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "harmon3F"
endin

instr 268 ;MIDI mapping for Transposer
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-24,24 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "harmon4C"
endin

instr 269 ;MIDI mapping for Transposer
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-1,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "harmon4F"
endin

instr 270 ;MIDI mapping for Transposer
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-24,24 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "harmon5C"
endin

instr 271 ;MIDI mapping for Transposer
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-1,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "harmon5F"
endin

instr 272 ;MIDI mapping for Transposer
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-24,24 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "harmon6C"
endin

instr 273 ;MIDI mapping for Transposer
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-1,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "harmon6F"
endin

instr 280
;receive MIDI mapping buttons for Chorus
kmapchmix chnget "mapchmix"
kmapchmixX chnget "mapchmixX"
kmapchcps chnget "mapchcps"
kmapchcpsX chnget "mapchcpsX"
kmapchFB chnget "mapchFB"
kmapchFBX chnget "mapchFBX"
kmapchdepth chnget "mapchdepth"
kmapchdepthX chnget "mapchdepthX"
kmapchdel chnget "mapchdel"
kmapchdelX chnget "mapchdelX"
kmapchrand chnget "mapchrand"
kmapchrandX chnget "mapchrandX"

;monitor controller changes and assign
if changed(gkstatus)==1 then  
    if gkstatus==176 then
        if kmapchmix == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 281, 2, 0
            event "i", 281, 0, 999999999
        elseif kmapchcps == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 282, 2, 0
            event "i", 282, 0, 999999999
        elseif kmapchFB == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 283, 2, 0
            event "i", 283, 0, 999999999
        elseif kmapchdepth == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 284, 2, 0
            event "i", 284, 0, 999999999
        elseif kmapchdel == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 285, 2, 0
            event "i", 285, 0, 999999999
        elseif kmapchrand == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 286, 2, 0
            event "i", 286, 0, 999999999
        endif
    endif
endif

;turn off MIDI controller GUI control for individual rsliders
if kmapchmixX == 1 then
    turnoff2 281, 2, 0
elseif kmapchcpsX == 1 then
    turnoff2 282, 2, 0
elseif kmapchFBX == 1 then
    turnoff2 283, 2, 0
elseif kmapchdepthX == 1 then
    turnoff2 284, 2, 0
elseif kmapchdelX == 1 then
    turnoff2 285, 2, 0
elseif kmapchrandX == 1 then
    turnoff2 286, 2, 0
endif
endin

instr 281 ;MIDI mapping for Chorus
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "chmix"
endin

instr 282 ;MIDI mapping for Chorus
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.01,25 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "chcps"
endin

instr 283 ;MIDI mapping for Chorus
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,.999 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "chFB"
endin

instr 284 ;MIDI mapping for Chorus
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.1,50 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "chdepth"
endin

instr 285 ;MIDI mapping for Chorus
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.1,50 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "chdel"
endin

instr 286 ;MIDI mapping for Chorus
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,.9 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "chrand"
endin

instr 290
;receive MIDI mapping buttons for Delay
kmapdeltime chnget "mapdeltime"
kmapdeltimeX chnget "mapdeltimeX"
kmapdelFB chnget "mapdelFB"
kmapdelFBX chnget "mapdelFBX"

;monitor controller changes and assign
if changed(gkstatus)==1 then  
    if gkstatus==176 then
        if kmapdeltime == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 291, 2, 0
            event "i", 291, 0, 999999999
        elseif kmapdelFB == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 292, 2, 0
            event "i", 292, 0, 999999999
        endif
    endif
endif

;turn off MIDI controller GUI control for individual rsliders
if kmapdeltimeX == 1 then
    turnoff2 291, 2, 0
elseif kmapdelFBX == 1 then
    turnoff2 292, 2, 0
endif
endin

instr 291 ;MIDI mapping for Delay
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.001,4.99 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "deltime"
endin

instr 292 ;MIDI mapping for Delay
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,.99 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "delFB"
endin

instr 300
;receive MIDI mapping buttons for Reverb
kmaprevmix chnget "maprevmix"
kmaprevmixX chnget "maprevmixX"
kmaprevFB chnget "maprevFB"
kmaprevFBX chnget "maprevFBX"
kmaprevLP chnget "maprevLP"
kmaprevLPX chnget "maprevLPX"

;monitor controller changes and assign
if changed(gkstatus)==1 then  
    if gkstatus==176 then
        if kmaprevmix == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 301, 2, 0
            event "i", 301, 0, 999999999
        elseif kmaprevFB == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 302, 2, 0
            event "i", 302, 0, 999999999
        elseif kmaprevLP == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 303, 2, 0
            event "i", 303, 0, 999999999
        endif
    endif
endif

;turn off MIDI controller GUI control for individual rsliders
if kmaprevmixX == 1 then
    turnoff2 301, 2, 0
elseif kmaprevFBX == 1 then
    turnoff2 302, 2, 0
elseif kmaprevLPX == 1 then
    turnoff2 303, 2, 0
endif
endin

instr 301 ;MIDI mapping for Reverb
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "revmix"
endin

instr 302 ;MIDI mapping for Reverb
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.01,.999 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "revFB"
endin

instr 303 ;MIDI mapping for Reverb
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,200,20000 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "revLP"
endin

instr 500   ;global FX for EQ, distortion, LP, Phaser, Flanger, etc
;input gaSynL and gaSynR, output gaFXL and gaFXR
;master effects section

aL=gaSynL+galiveL
aR=gaSynR+galiveR

;distortion
kdiston chnget "diston"
if kdiston==0 goto nodist
kdist chnget "distA"
kdist port kdist,.05
ad1L distort aL,kdist,26
ad1R distort aR,kdist,26
aL balance2 ad1L,aL
aR balance2 ad1R,aR

kdist2 chnget "distB"
kdist2=1-kdist2
kdist2 port kdist2,.05
ad2L powershape aL,kdist2
ad2R powershape aR,kdist2
aL balance2 ad2L,aL
aR balance2 ad2R,aR

kdist3 chnget "distC"
kdist3 port kdist3,.05
ad3L fold aL,kdist3
ad3R fold aR,kdist3
aL balance2 ad3L,aL
aR balance2 ad3R,aR

nodist:
;LP filter
kLPon chnget "LPon"
if kLPon==0 goto noLP
kLPsel chnget "LPsel"
kLPcps chnget "LPcps"
kLPcps port kLPcps,.1
kLPcfr chnget "LPcfr"
kLPcfd chnget "LPcfd"
kLPcfrand chnget "LPrand"
kLPres chnget "LPres"
kLPresr chnget "LPresr"
kLPresd chnget "LPresd"
kLPjit jitter kLPcfr*kLPcfrand,3,11
kLPcf oscili kLPcfd,kLPcfr+kLPjit,25
kLPQ oscili kLPresd,kLPresr,25
a1L,a2L,a3L,a4L mvclpf4 aL,cpsoct(kLPcf+kLPcps),kLPQ+kLPres
a1R,a2R,a3R,a4R mvclpf4 aR,cpsoct(kLPcf+kLPcps),kLPQ+kLPres
if kLPsel=1 then
alpL=a1L
alpR=a1R
elseif kLPsel=2 then
alpL=a2L
alpR=a2R
elseif kLPsel=3 then
alpL=a3L
alpR=a3R
elseif kLPsel=4 then
alpL=a4L
alpR=a4R
endif
aL balance alpL,aL
aR balance alpR,aR

noLP:
;4 Parallel Filters
kparon chnget "paron"
kfport chnget "fport"
if kparon==0 goto nopar
kparsel1 chnget "parsel1"
kparsel2 chnget "parsel2"
kparsel3 chnget "parsel3"
kparsel4 chnget "parsel4"
kparF1 chnget "parF1"
kparF2 chnget "parF2"
kparF3 chnget "parF3"
kparF4 chnget "parF4"
kparF1 portk kparF1,kfport
kparF2 portk kparF2,kfport
kparF3 portk kparF3,kfport
kparF4 portk kparF4,kfport
kparcfr1 chnget "parcfr1"
kparcfr2 chnget "parcfr2"
kparcfr3 chnget "parcfr3"
kparcfr4 chnget "parcfr4"
kparcfd1 chnget "parcfd1"
kparcfd2 chnget "parcfd2"
kparcfd3 chnget "parcfd3"
kparcfd4 chnget "parcfd4"
kparcfrnd1 chnget "parcfrnd1"
kparcfrnd2 chnget "parcfrnd2"
kparcfrnd3 chnget "parcfrnd3"
kparcfrnd4 chnget "parcfrnd4"
kparres1 chnget "parres1"
kparres2 chnget "parres2"
kparres3 chnget "parres3"
kparres4 chnget "parres4"
kparres1 portk kparres1,kfport
kparres2 portk kparres2,kfport
kparres3 portk kparres3,kfport
kparres4 portk kparres4,kfport
kparamp1 chnget "paramp1"
kparamp2 chnget "paramp2"
kparamp3 chnget "paramp3"
kparamp4 chnget "paramp4"
kparamp1 portk kparamp1,kfport
kparamp2 portk kparamp2,kfport
kparamp3 portk kparamp3,kfport
kparamp4 portk kparamp4,kfport
kparjit1 jitter kparcfr1*kparcfrnd1,2.5,8
kparjit2 jitter kparcfr2*kparcfrnd2,3.5,11
kparjit3 jitter kparcfr3*kparcfrnd3,3,10
kparjit4 jitter kparcfr4*kparcfrnd4,2.1,9
kpardev1 oscili kparcfd1,kparcfr1+kparjit1,25
kpardev2 oscili kparcfd2,kparcfr2+kparjit2,25
kpardev3 oscili kparcfd3,kparcfr3+kparjit3,25
kpardev4 oscili kparcfd4,kparcfr4+kparjit4,25
a1lpL,a1bpL,a1hpL zdf_2pole_mode aL,cpsoct(kparF1+kpardev1),kparres1
a1lpR,a1bpR,a1hpR zdf_2pole_mode aR,cpsoct(kparF1+kpardev1),kparres1
a2lpL,a2bpL,a2hpL zdf_2pole_mode aL,cpsoct(kparF2+kpardev2),kparres2
a2lpR,a2bpR,a2hpR zdf_2pole_mode aR,cpsoct(kparF2+kpardev2),kparres2
a3lpL,a3bpL,a3hpL zdf_2pole_mode aL,cpsoct(kparF3+kpardev3),kparres3
a3lpR,a3bpR,a3hpR zdf_2pole_mode aR,cpsoct(kparF3+kpardev3),kparres3
a4lpL,a4bpL,a4hpL zdf_2pole_mode aL,cpsoct(kparF4+kpardev4),kparres4
a4lpR,a4bpR,a4hpR zdf_2pole_mode aR,cpsoct(kparF4+kpardev4),kparres4
if kparsel1=1 then
apar1L=a1lpL
apar1R=a1lpR
elseif kparsel1=2 then
apar1L=a1bpL
apar1R=a1bpR
elseif kparsel1=3 then
apar1L=a1hpL
apar1R=a1hpR
elseif kparsel1=4 then
apar1L=0
apar1R=0
endif
if kparsel2=1 then
apar2L=a2lpL
apar2R=a2lpR
elseif kparsel2=2 then
apar2L=a2bpL
apar2R=a2bpR
elseif kparsel2=3 then
apar2L=a2hpL
apar2R=a2hpR
elseif kparsel2=4 then
apar2L=0
apar2R=0
endif
if kparsel3=1 then
apar3L=a3lpL
apar3R=a3lpR
elseif kparsel3=2 then
apar3L=a3bpL
apar3R=a3bpR
elseif kparsel3=3 then
apar3L=a3hpL
apar3R=a3hpR
elseif kparsel3=4 then
apar3L=0
apar3R=0
endif
if kparsel3=1 then
apar4L=a4lpL
apar4R=a4lpR
elseif kparsel4=2 then
apar4L=a4bpL
apar4R=a4bpR
elseif kparsel4=3 then
apar4L=a4hpL
apar4R=a4hpR
elseif kparsel4=4 then
apar4L=0
apar4R=0
endif
aparsumL=(apar1L*kparamp1)+(apar2L*kparamp2)+(apar3L*kparamp3)+(apar4L*kparamp4)
aparsumR=(apar1R*kparamp1)+(apar2R*kparamp2)+(apar3R*kparamp3)+(apar4R*kparamp4)
aL balance aparsumL,aL
aR balance aparsumR,aR

nopar:
;phaser
kphson chnget "phson"
if kphson==0 goto nophaser
kphscps chnget "phscps"
kphsQ chnget "phsQ"
kphsFB chnget "phsFB"
kphsdev oscil 25,kphscps,25
aLphs phaser2 aL,100+kphsdev,kphsQ,20,1,1,kphsFB
aRphs phaser2 aR,100+kphsdev,kphsQ,20,1,1,kphsFB
aL=(aL+aLphs)*.5
aR=(aR+aRphs)*.5

nophaser:
;flanger
kflon chnget "flon"
if kflon==0 goto noflanger
kflcps chnget "flcps"
kflFB chnget "flFB"
adel oscil .02,kflcps,27
aLfl flanger aL,adel*.05,kflFB,.1
aLfl clip aLfl,1,1
aRfl flanger aR,adel*.05,kflFB,.1
aRfl clip aRfl,1,1
aL=(aL+aLfl)*.5
aR=(aR+aRfl)*.5

noflanger:
;global transposer with 6 voices
kton chnget "ton"
if kton==0 goto noharmon
kharmon1 chnget "harmon1" ;on/off button
kharmon2 chnget "harmon2"
kharmon3 chnget "harmon3"
kharmon4 chnget "harmon4"
kharmon5 chnget "harmon5"
kharmon6 chnget "harmon6"
kharm1 port kharmon1,.05
kharm2 port kharmon2,.05
kharm3 port kharmon3,.05
kharm4 port kharmon4,.05
kharm5 port kharmon5,.05
kharm6 port kharmon6,.05

kTport chnget "Tport"
kT1C chnget "harmon1C"
kT1F chnget "harmon1F"
kT2C chnget "harmon2C"
kT2F chnget "harmon2F"
kT3C chnget "harmon3C"
kT3F chnget "harmon3F"
kT4C chnget "harmon4C"
kT4F chnget "harmon4F"
kT5C chnget "harmon5C"
kT5F chnget "harmon5F"
kT6C chnget "harmon6C"
kT6F chnget "harmon6F"
kT1C portk kT1C,kTport
kT1F portk kT1F,kTport
kT2C portk kT2C,kTport
kT2F portk kT2F,kTport
kT3C portk kT3C,kTport
kT3F portk kT3F,kTport
kT4C portk kT4C,kTport
kT4F portk kT4F,kTport
kT5C portk kT5C,kTport
kT5F portk kT5F,kTport
kT6C portk kT6C,kTport
kT6F portk kT6F,kTport

kshift1=kT1C+kT1F
kshift2=kT2C+kT2F
kshift3=kT3C+kT3F
kshift4=kT4C+kT4F
kshift5=kT5C+kT5F
kshift6=kT6C+kT6F
kharmmix chnget "harmmix"
ibase=cpsoct(8) ;middle C as base frequency

kratio1=cpsoct(8+(kshift1/12))/ibase ;Transposition ratio
kratio2=cpsoct(8+(kshift2/12))/ibase 
kratio3=cpsoct(8+(kshift3/12))/ibase 
kratio4=cpsoct(8+(kshift4/12))/ibase 
kratio5=cpsoct(8+(kshift5/12))/ibase 
kratio6=cpsoct(8+(kshift6/12))/ibase 

kjit1 jitter .002,.75,3.7
kjit2 jitter .001,.15,2.11
kjit3 jitter .0023,.1,1.4
kjit4 jitter .0025,.4,4.7
kjit5 jitter .0016,.6,3.8
kjit6 jitter .0019,.31,5.6

kratio1=kratio1+kjit1
kratio2=kratio2+kjit2
kratio3=kratio3+kjit3
kratio4=kratio4+kjit4
kratio5=kratio5+kjit5
kratio6=kratio6+kjit6

fftinL pvsanal aL,512,128,512,1 ;FFT analysis
fftinR pvsanal aR,512,128,512,1

fftT1L pvscale fftinL,kratio1 ;pitch scaling and resynthesis
fftT1R pvscale fftinR,kratio1
aT1L pvsynth fftT1L
aT1R pvsynth fftT1R

fftT2L pvscale fftinL,kratio2
fftT2R pvscale fftinR,kratio2
aT2L pvsynth fftT2L
aT2R pvsynth fftT2R

fftT3L pvscale fftinL,kratio3
fftT3R pvscale fftinR,kratio3
aT3L pvsynth fftT3L
aT3R pvsynth fftT3R

fftT4L pvscale fftinL,kratio4
fftT4R pvscale fftinR,kratio4
aT4L pvsynth fftT4L
aT4R pvsynth fftT4R

fftT5L pvscale fftinL,kratio5
fftT5R pvscale fftinR,kratio5
aT5L pvsynth fftT5L
aT5R pvsynth fftT5R

fftT6L pvscale fftinL,kratio6
fftT6R pvscale fftinR,kratio6
aT6L pvsynth fftT6L
aT6R pvsynth fftT6R

asumL=(aT1L*kharm1)+(aT2L*kharm2)+(aT3L*kharm3)+(aT4L*kharm4)+(aT5L*kharm5)+(aT6L*kharm6)
asumR=(aT1R*kharm1)+(aT2R*kharm2)+(aT3R*kharm3)+(aT4R*kharm4)+(aT5R*kharm5)+(aT6R*kharm6)
aL=(aL*(1-kharmmix))+(asumL*kharmmix)
aR=(aR*(1-kharmmix))+(asumR*kharmmix)

noharmon:
gaFXL=aL
gaFXR=aR

endin

;does global harmonizer with 6 voices need to be its own instrument here?

instr 502   ;global chorus
kchon chnget "chon"
kchmix chnget "chmix"
kchFB chnget "chFB"
kchdepth chnget "chdepth"
kchcps chnget "chcps"
kchrand chnget "chrand"
kchdel chnget "chdel"
if kchon==0 goto NOCHOR
achorusFBL init 0
achorusFBR init 0
afeedL=gaFXL+achorusFBL
afeedR=gaFXR+achorusFBR
kdepthrand=kchdepth*kchrand*.001
kchdel=kchdel*.001
kcpsrand=kchcps*kchrand
kchcps randomi kchcps-kcpsrand,kchcps+kcpsrand,kchcps
kchdepth randomi kchdepth-kdepthrand,kchdepth+kdepthrand,kchcps
kchdepth port kchdepth,.1
ardelL oscili kchdepth,kchcps,25
ardelR oscili kchdepth,kchcps,25,.25
ardel3 oscili kchdepth,kchcps,25,.5
ardel4 oscili kchdepth,kchcps,25,.75
ardelL=ardelL+(kchdepth*2.1+kchdel)
ardelR=ardelR+(kchdepth*2.1+kchdel)
ardel3=ardel3+(kchdepth*2.1+kchdel)
ardel4=ardel4+(kchdepth*2.1+kchdel)
amodL vdelay afeedL,ardelL,200
amodR vdelay afeedR,ardelR,200
amod3 vdelay afeedL*.33+afeedR*.66,ardel3,200
amod4 vdelay afeedR*.33+afeedL*.66,ardel4,200
achorusFBL=dcblock(((amodL*.6)+(amod4*.3)+(amod3*.15))*-kchFB)
achorusFBR=dcblock(((amodR*.6)+(amod3*.3)+(amod4*.15))*-kchFB)
gaChorL=((afeedL*.7+amodL)*kchmix)+((1-kchmix)*gaFXL)
gaChorR=((afeedR*.7+amodR)*kchmix)+((1-kchmix)*gaFXR)
goto LAST
NOCHOR:
gaChorL=gaFXL
gaChorR=gaFXR
LAST:
endin

instr 505   ;global FB delay FX
kdelon chnget "delon"
if kdelon==0 goto NODEL
aFBL init 0
aFBR init 0
kdel chnget "deltime"
kdel port kdel,.05
adel interp kdel*1000
kDelFB chnget "delFB"
aLdel vdelay gaChorL+aFBL,adel,5000
aRdel vdelay gaChorR+aFBR,adel,5000
aFBL=dcblock((aLdel*kDelFB)+gaChorL)
aFBR=dcblock((aRdel*kDelFB)+gaChorR)
gaDelL=aFBL
gaDelR=aFBR
goto LAST
NODEL:
gaDelL=gaChorL
gaDelR=gaChorR
LAST:
endin

instr 510   ;global reverb, always on
krevon chnget "revon"
if krevon==0 goto NOREV
krevmix chnget "revmix"
krevmix port krevmix,.05
krevFB chnget "revFB"
krevLP chnget "revLP"
aLrev,aRrev reverbsc gaDelL,gaDelR,krevFB,krevLP,gisr,.075
gafinalL=(gaDelL*(1-krevmix))+(aLrev*krevmix)
gafinalR=(gaDelR*(1-krevmix))+(aRrev*krevmix)
goto FINALOUT
NOREV:
gafinalL=gaDelL
gafinalR=gaDelR
FINALOUT:
outs gafinalL,gafinalR
endin

instr 600	; record file
irecch chnget "recch"
ibit chnget "bit"
 print	p1
 if gkplay==1 then
  chnset	k(0),"record"
  turnoff
 endif
 gkFileRecorded		init	1
 itim     date
 Stim     dates     itim
 itim     date
 Stim     dates     itim
 Syear    strsub    Stim, 20, 24
 Smonth   strsub    Stim, 4, 7
 Sday     strsub    Stim, 8, 10
 iday     strtod    Sday
 Shor     strsub    Stim, 11, 13
 Smin     strsub    Stim, 14, 16
 Ssec     strsub    Stim, 17, 19
 Sfilnam  sprintf  "%s_%s_%02d_%s_%s_%s.wav", Syear, Smonth, iday, Shor,Smin, Ssec
 gSname   sprintf "WaveTerrainSynth_%s", Sfilnam
 if gkrecord==1 then			; record
  if ibit=1 then
   imode=4
  elseif ibit=2 then
   imode=8
  elseif ibit=3 then
   imode=5
  endif
  if irecch=1 then
   fout gSname,imode,(gafinalL+gafinalR)*.7
  elseif irecch=2 then
   fout gSname,imode,gafinalL, gafinalR
  endif
 endif
 gkRecordingActiveFlag	=	1 - release()
endin

instr	601	; play file
 if gkplay==0 then
  turnoff
 endif 
   aL,aR	diskin2	gSname,1
  	outs	aL,aR
 iFileLen	filelen	gSname
 p3	=	iFileLen
 xtratim	0.1 
 krelease	release
 	chnset	1-krelease,"play"
endin

instr 750   ;clear global audio paths that include feedback (don't need to clear the global LFO outputs)
clear   gaSynL,gaSynR,gaDelL,gaDelR,gaFXL,gaFXR,galiveL,galiveR,galiveRM,galiveAM,gafinalL,gafinalR
endin

</CsInstruments>

<CsScore>
f0 z ;causes Csound to run infinitely
f25 0 8192 10 1   ;sine for FM and AM
f26 0 8192 7 -1 3500 -1 1193 1 3500 1   ;for distort opcode waveshaping
f27 0 16385 7 0 8192 1 8193 0   ;used to control flanger delay
f28 0 8192 10 1 0 .333 0 .2 0 .144 0 .1111 ;square wave
f29 0 8192 20 3 ;triangle envelope for harmonizer
f30 0 8192 7 0 2048 1 4097 -1 2048 0 ;triangle for LFO
f31 0 8192 7 1 4096 1 0 -1 4097 -1 ;square for LFO
f32 0 8192 7 0 8193 1 ;ramp up for LFO
f33 0 8192 7 0 8193 -1 ;ramp down for LFO
f34 0 8192 10 1 1 1 1 1 1 1 1 1 1 .9 .7 .5 .3 .1 ;pulse for LFO
f35 0 8192 10 1 -.5 .33333 -.25 .2 -.1666 .14286 -.125 .11111 -.1 ;saw

;morphing function tables
f91 0 8 -2 101 102 103 104 105 106 107 108 ;tables contain ftable numbers for morphing, get re-instantiated each time a function is selected
f92 0 8 -2 101 102 103 104 105 106 107 108 ;for each of the 8 wave slots
f93 0 8 -2 101 102 103 104 105 106 107 108
f94 0 8 -2 101 102 103 104 105 106 107 108
f95 0 8 -2 101 102 103 104 105 106 107 108

f96 0 8192 10 1 ;these are the target ftmorf function tables with the mixed waveform, just a table with the appropriate size
f97 0 8192 10 1 
f98 0 8192 10 1 
f99 0 8192 10 1 
f100 0 8192 10 1 

;function tables for waveform select
f101 0 8193 10 1 ;sine
f102 0 8193 10 1 0 .3333 0 .2 0 .14285 0 .11111 0 .09090909 0 .076923 0 .066666 0 .0588235 0 .0526315 0 .047619 0 .04347826 0 .04 ;square wave
f103 0 8193 10 1 [-1/2] [1/3] [-1/4] [1/5] [-1/6] [1/7] [-1/8] [1/9] [-1/10] [1/11] [-1/12] [1/13] [-1/14] [1/15] [-1/16] [1/17] [-1/18] [1/19] [-1/20] [1/21] [-1/22] [1/23] [-1/24] [1/25] ;saw
f104 0 8193 10 1 .99 .98 .97 .96 .95 .9 .85 .8 .75 .7 .65 .6 .55 .5 .45 .4 .35 .3 .2 .1 ;pulse
f105 0 8193 7 0 2048 1 4097 -1 2048 0 ;triangle
f106 0 8193 7 -1 8193 1 ;ramp
f107 0 8193 10 0 1 ;harmonic 1
f108 0 8193 10 0 0 1 ;harmonic 2
f109 0 8193 10 0 0 0 1 ;harmonic 3
f110 0 8193 10 0 0 0 0 1 ;harmonic 4
f111 0 8193 10 0 0 0 0 0 1 ;harmonic 5
f112 0 8193 10 0 0 0 0 0 0 1 ;harmonic 6
f113 0 8193 10 0 0 0 0 0 0 0 1 ;harmonic 7
f114 0 8193 10 0 0 0 0 0 0 0 0 1 ;harmonic 8
f115 0 8193 10 0 0 0 0 0 0 0 0 0 1 ;harmonic 9
f116 0 8193 10 0 0 0 0 0 0 0 0 0 0 1 ;harmonic 10
f117 0 8193 10 0 0 0 0 0 0 0 0 0 0 0 1 ;harmonic 11
f118 0 8193 10 0 0 0 0 0 0 0 0 0 0 0 0 1 ;harmonic 12
f119 0 8193 10 0 0 0 0 0 0 0 0 0 0 0 0 0 1 ;harmonic 13
f120 0 8193 10 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 ;harmonic 14
f121 0 8193 10 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 ;harmonic 15
;cello
f122 0 8193 10 0.022943 0.412962 0.548431 0.578468 0.092241 0.116378 0.052974 0.029585 0.093977 0.119660 0.064074 0.051807 0.015094 0.094184 0.015488 0.006640 0.007091 0.011557 0.043467 0.023330 0.018118 0.026921 0.010285 0.007653 0.015306 0.023175
;violin
f123 0 8193 10 0.403041 0.281156 0.259204 0.392900 0.236559 0.108769 0.117288 0.063588 0.039483 0.018245 0.012717 0.020183 0.008506 0.017915 0.008925 0.008575 0.006947 0.008142 0.005487 0.005970 0.004402 0.003161 0.002361 0.001942
;bass tbn
f124 0 8193 10 0.102601 0.100887 0.167098 0.516781 0.330986 0.422868 0.412850 0.397849 0.628756 0.686835 0.929709 0.845577 0.935266 0.508059 0.792158 0.281350 0.378308 0.568489 0.346813 0.566233 0.413541 0.405762 0.359363 0.216505
;F horn
f125 0 8193 10 10 0.150333 0.205756 0.869097 0.723941 0.707935 0.116871 0.238125 0.330962 0.443031 0.325212 0.131256 0.267361 0.273576 0.146568 0.209758 0.158564 0.179271 0.084668 0.112177 0.118845 0.124993 0.096945 0.128906 0.125534 0.125534
;trumpet
f126 0 8193 10 .569 .543 .633 .7 .67 .675 .555 .41 .46 .305 .31 .365 .315 .25 .21 .24 .225 .175 .155 .185 .155 .16 .245
;contra bassoon
f127 0 8193 10 0.076357 0.137793 0.174617 0.207802 0.302523 0.705801 0.162577 0.073808 0.224559 0.050465 0.066110 0.181682 0.062409 0.052317 0.037698 0.029936 0.042341 0.053436 0.135414 0.059248 0.025689 0.033567 0.051201 0.029910 0.028697 0.052991
;bassoon
f128 0 8193 10 0.147763 0.340255 0.879202 0.404023 0.259274 0.130887 0.095096 0.039056 0.091976 0.009828 0.004879 0.013408 0.016090 0.015931 0.012402 0.003430 0.006421 0.004323 0.002018 0.001465 0.003012 0.001397 0.002446 0.002683 0.002425 0.004828
;oboe
f129 0 8193 10 0.297865 0.916220 0.218345 0.030903 0.016039 0.045984 0.003571 0.006255 0.007310 0.003701 0.001306 0.001355 0.000361 0.001108 0.001552 0.000991 0.000588 0.000780 0.000678 0.001103 0.000615 0.000264 0.000310 0.000464 0.000464
;saxophone
f130 0 8193 10 .14 .23 .142 .18 .2 .07 .015 .05 .062 .09 .043 .01 .025 .037 .056 .06 .057 .049 .062 .048 .03 .023 .02 .011 .017
;contrabass clarinet
f131 0 8193 10 0.227476 0.006718 0.707706 0.018101 0.539432 0.018848 0.590242 0.029143 0.512926 0.035712 0.324304 0.035306 0.035964 0.050992 0.096916 0.025035 0.098203 0.072427 0.068155 0.060324 0.042818 0.074538 0.049430 0.100999 0.052956 0.109337
; bass clarinet
f132 0 8193 10 0.819856 0.006052 0.508263 0.007439 0.271031 0.012967 0.059374 0.017922 0.016997 0.004014 0.027132 0.014921 0.020230 0.012123 0.021066 0.004875 0.016894 0.004428 0.004157 0.007603 0.004211 0.011103 0.005054 0.007329 0.004043 0.002169
;clarinet
f133 0 8193 10 0.753504 0.011446 0.501720 0.055791 0.241768 0.037889 0.027203 0.062793 0.102494 0.030506 0.042453 0.050202 0.031077 0.027208 0.020897 0.022205 0.012154 0.008160 0.004886 0.005076 0.003805 0.001322 0.001149 0.001450 0.001450
;bass flute
f134 0 8193 10 0.801592 0.068816 0.032303 0.012614 0.002660 0.014692 0.002493 0.006175 0.001826 0.001416 0.002607 0.001063 0.001542 0.001053 0.001293 0.001226 0.000781 0.001142 0.000975 0.000922 0.000693 0.000570 0.000538 0.000429 0.000587
;flute
f135 0 8193 10 0.925667 0.059839 0.214284 0.013980 0.026778 0.008733 0.019436 0.002640 0.004217 0.002126 0.003513 0.002455 0.001336 0.001508 0.001589 0.002155 0.002549 0.001951 0.001614 0.001076 0.001253 0.001138 0.001073 0.000990 0.000990
;piccolo
f136 0 8193 10 0.730803 0.323120 0.277720 0.044844 0.009400 0.022785 0.004602 0.005762 0.006400 0.002483 0.001490 0.002354 0.004728 0.002669 0.003175 0.001177 0.000761 0.000509 0.000449 0.000703 0.001078 0.002471 0.003905 0.004114 0.004114
;piano (low res)
f137 0 8193 10 1 .11 .333 .07 .055 .055 .003 .025 .002 .003 0 .003 .004 .001 .0005
;guitar
f138 0 8193 10 1 .675 1.265 .125 .12 .115 .005 .01 .185 .055 .015 .008 .009 .01 .003 .002 .002
;ahhh
f139 0 8193 10 0.600063 0.256340 0.126445 0.040717 0.097956 0.082383 0.135342 0.006369 0.002414 0.002312 0.001526 0.000552 0.000868 0.000435 0.000576 0.001145 0.001706 0.003688 0.013234 0.006626 0.006840 0.012971 0.003639 0.002955 0.001962 0.001988

i1 0 999999     ;live audio input and sf management
;i2 and i3 play and load soundfiles for input
i4 0 999999    ;mixes mic/line and soundfile playback, generates audio data for modulation
i5 0 999999    ;LFO generator
;i10 is the big synth controlled by MIDI
i20 0 999999    ;noise generator
i25 0 999999    ;PW rslider GUI control
i60 0 999999 ;vocal formant parallel filter preset control
i61 0 999999 ;Transposer preset control
i100 0 999999 ;MIDI controller mapping
i101 0 999999 ;MIDI controller instruments
i103 0 999999
i105 0 999999
i110 0 999999
i120 0 999999
i130 0 999999
i140 0 999999
i150 0 999999
i200 0 999999
i210 0 999999
i220 0 999999
i230 0 999999
i240 0 999999
i250 0 999999
i260 0 999999
i280 0 999999
i290 0 999999
i300 0 999999
i500 0 999999       ;global FX
i502 0 999999
i505 0 999999       ;global delay
i510 0 999999       ;global reverb
i750 0 999999       ;global audio clear

</CsScore>
</CsoundSynthesizer>
